package holders.stock;

import java.util.LinkedHashMap;
import java.util.Vector;
import medstore.String.StringUtils;

public class Campaign {
    public static final String stockid = "stockid";
    public static final String id = "id";
    public static final String discount = "discount";
    public static final String lownum = "lownum";
    public static final String highnum = "highnum";
    public static final String fromdate = "fromdate";
    public static final String todate     = "todate";
    
    public static LinkedHashMap findCampaign(String stck_key, Vector data){
        for(int i = 0; i < data.size(); i++){
            LinkedHashMap row = (LinkedHashMap)data.get(i);
            
            try{
                int stck_id = new Integer(StringUtils.clearString(row.get(stockid),"-1")).intValue();
                int key = new Integer(StringUtils.clearString(stck_key,"-1")).intValue();                
                if(stck_id==key && key>0){
                    return row;
                }
            }
            catch(Exception e){
                
            }
        }
        return null;
    }
}
