/*
 * CoommonDialog.java
 *
 * Created on , 2005,  26, 13:23
 */

package medstore.forms;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.*;

public class CommonDialog extends javax.swing.JDialog {
   
   /* public CommonDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        // make ESC to cancel dialog
        JComponent c = (JComponent)getRootPane();
        InputMap im = c.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);//WHEN_IN_FOCUSED_WINDOW
        im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "ESCAction");
        ActionMap am = c.getActionMap();
        am.put("ESCAction", m_escAction);
    }*/
    public CommonDialog(Dialog parent, boolean modal) {
        super(parent==null ? new Dialog(new Frame()) : parent, modal);
        // make ESC to cancel dialog
        JComponent c = (JComponent)getRootPane();
        InputMap im = c.getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT/*JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT*/);//WHEN_IN_FOCUSED_WINDOW
        im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "ESCAction");
        ActionMap am = c.getActionMap();
        am.put("ESCAction", m_escAction);
    }
    /**
     *set main window to close when esc is pressed and table has focus
     **/
    public void enableExit( JComponent comp )
    {
        //JComponent c = (JComponent)table.getRootPane();
        InputMap im = comp.getInputMap(JComponent.WHEN_FOCUSED/*JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT*/);//WHEN_IN_FOCUSED_WINDOW
        im.put(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "ESCAction");
        ActionMap am = comp.getActionMap();
        am.put("ESCAction", m_escAction);        
    }
    
    Action m_escAction = new AbstractAction() 
    {
         public void actionPerformed(ActionEvent evt) 
         {
             Object o = evt.getSource();
             if( o instanceof JComboBox )
             {
                 if( ((JComboBox)o).isPopupVisible() )
                 {
                     ((JComboBox)o).setPopupVisible(false);
                     return;
                 }    
             }            
             dispose();
         }
    };
}



