package medstore.orders;

import medstore.remote.io.RemoteURL;
import holders.User;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import medstore.remote.io.ServletWriter;

public class MacroUtils {

    public MacroUtils() {
    }
    
    public static HashMap loadMacros(User user) throws Exception{
        URL url = new URL(RemoteURL.loadMacros);
        Serializable[] obj = {(Serializable)user.getUserMap()};
        ObjectInputStream result = ServletWriter.postObjects(url,obj);
        HashMap map = (HashMap)result.readObject();
        return map;
    }
    public static boolean saveMacros(User user, HashMap macros) throws Exception{
        URL url = new URL(RemoteURL.saveMacros);
        Serializable[] obj = {(Serializable)user.getUserMap(),(Serializable)macros};
        ObjectInputStream result = ServletWriter.postObjects(url,obj);
        Boolean saved = (Boolean)result.readObject();
        return saved.booleanValue();
    }
}
