package medstore.print;

import java.net.URL;
import javax.swing.table.TableModel;
import org.jfree.report.JFreeReport;
import org.jfree.report.demo.helper.ReportDefinitionException;
import org.jfree.report.modules.parser.base.ReportGenerator;
import org.jfree.util.ObjectUtilities;

public class RepotUtil {
    
    private static TableModel data;
    private String printTemplate;
    private String name;
    public RepotUtil(TableModel data, String printTemplate,String name) {
        this.data = data;
        this.printTemplate = printTemplate;
        this.name = name;
    }
    public JFreeReport createReport() throws ReportDefinitionException {
        JFreeReport report;
        ReportGenerator generator;
        generator = ReportGenerator.getInstance( );
        
        try {
            report = generator.parseReport( getReportDefinitionSource() );
        } catch( Exception e ) {            
            e.printStackTrace();
            return null;
        }
        
        report.setData( data );
        report.setName(name);
        return report;
    }    
    public URL getReportDefinitionSource() {
        return ObjectUtilities.getResourceRelative
                (printTemplate, RepotUtil.class);
    }
}
