package medstore.remote.io.auftrag;

import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import medstore.remote.io.RemoteIO;
import medstore.remote.io.ServletWriter;

public class RemoteAuftrag extends RemoteIO{
    
    public static HashMap loadAuftrag(HashMap user, String v_nr) throws Exception{
        URL url = new URL(RemoteUrl.auftrag);
        Serializable[] obj = {(Serializable)user, v_nr};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        HashMap data = (HashMap)in.readObject();
        closeInput(in);
        return data;
    }
    
}
