package medstore.remote.io.stores;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Vector;
import medstore.remote.io.RemoteIO;
import medstore.remote.io.ServletWriter;

public class RemoteStores extends RemoteIO{
    
    public static Vector loadStores(HashMap user) throws Exception{
        URL url = new URL(RemoteUrl.allstores);
        Serializable[] obj = {(Serializable)user};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        Vector data = (Vector)in.readObject();
        closeInput(in);
        return data;
    }
    
    public static Vector getPackingRooms(HashMap user) throws Exception{
        URL url = new URL(RemoteUrl.packingrooms);
        Serializable[] obj = {(Serializable)user};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        Vector data = (Vector)in.readObject();
        closeInput(in);
        return data;
    }
    
}
