package medstore.stock;

import java.awt.event.InputEvent;
import javax.swing.table.TableModel;
import medstore.stocks.print.PrintStocks;

public class AllStocks extends javax.swing.JFrame {
    
    public AllStocks() {
        initComponents();
    }
    public void setStockModel(TableModel model){
        tblAllStocks.setModel(model);
        tblAllStocks.repaint();
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        scrAllStocks = new javax.swing.JScrollPane();
        tblAllStocks = new javax.swing.JTable();
        menu = new javax.swing.JMenuBar();
        file = new javax.swing.JMenu();
        print = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        scrAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblAllStocks.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblAllStocks.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblAllStocks.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblAllStocksMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblAllStocks);

        menu.setFont(new java.awt.Font("Arial", 1, 12));
        file.setText("File");
        file.setFont(new java.awt.Font("Arial", 1, 12));
        file.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileActionPerformed(evt);
            }
        });

        print.setFont(new java.awt.Font("Arial", 1, 12));
        print.setText("Print");
        print.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printActionPerformed(evt);
            }
        });

        file.add(print);

        menu.add(file);

        setJMenuBar(menu);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(scrAllStocks, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 646, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(scrAllStocks, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 275, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void printActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printActionPerformed
        try {
            PrintStocks.printAllStocks(tblAllStocks.getModel());
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_printActionPerformed
    private void fileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileActionPerformed
        
    }//GEN-LAST:event_fileActionPerformed
        private void tblAllStocksMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblAllStocksMouseClicked
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                
            }
    }//GEN-LAST:event_tblAllStocksMouseClicked
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu file;
    private javax.swing.JMenuBar menu;
    private javax.swing.JMenuItem print;
    private javax.swing.JScrollPane scrAllStocks;
    private javax.swing.JTable tblAllStocks;
    // End of variables declaration//GEN-END:variables
    
}
