package medstore.stock.nomenclature;

import java.util.Vector;
import medstore.model.HashTableModel;
import medstore.model.MixedDataModel;


public class CompositeStockPanel extends javax.swing.JPanel {

    public CompositeStockPanel() {
        initComponents();
    }
    public void setComposite(Vector data){
        if(data.size()>0)
       lstSrcProds.setModel(new MixedDataModel(new HashTableModel(data,new String[]{""})));
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        scrSrcPane = new javax.swing.JScrollPane();
        lstSrcProds = new javax.swing.JList();
        chkComposite = new javax.swing.JCheckBox();

        scrSrcPane.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "All Products", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12)));
        scrSrcPane.setMinimumSize(new java.awt.Dimension(100, 150));
        scrSrcPane.setPreferredSize(new java.awt.Dimension(100, 150));
        scrSrcPane.setViewportView(lstSrcProds);

        chkComposite.setFont(new java.awt.Font("Tahoma", 1, 13));
        chkComposite.setText("Composite");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(chkComposite)
            .add(scrSrcPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 251, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(chkComposite)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(scrSrcPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox chkComposite;
    private javax.swing.JList lstSrcProds;
    private javax.swing.JScrollPane scrSrcPane;
    // End of variables declaration//GEN-END:variables
    
}
