<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%@include file="/medstore/utils/dataFromRs.jsp"%>
<%@include file="/medstore/utils/validate.jsp"%>
<%@include file="/WEB-INF/db/db.jsp"%>

<%

    url = cn;
    Connection conn = getConnection();
    conn.setAutoCommit(false);
    
    String result = "";
    try{
        ObjectInputStream in = new ObjectInputStream(request.getInputStream());
        HashMap user = (HashMap)in.readObject();
        HashMap data = (HashMap)in.readObject();

        validate(user);

        String stor_key = String.valueOf(data.get("stor_key"));

        Vector stock = (Vector)data.get("stock");

        

        Statement stmt = conn.createStatement();
        String date = "";
        SimpleDateFormat df = new SimpleDateFormat("yyyy.MM.dd");
        date = df.format(new java.util.Date());
        for(int i = 0; i < stock.size(); i++){

            LinkedHashMap row = (LinkedHashMap)stock.get(i);

            String v_nr = String.valueOf(row.get("v_nr"));
            String stck_name = String.valueOf(row.get("stck_name"));
            String stck_brcd = String.valueOf(row.get("stck_brcd"));
            String p_menge = String.valueOf(row.get("p_menge"));
            String p_pos = String.valueOf(row.get("p_pos"));
            String stck_key = String.valueOf(row.get("stck_key"));
            int count = Integer.parseInt(p_menge);

            execStoreOperation(conn, count, stck_brcd, stor_key, date.toString(), v_nr,
                    String.valueOf(user.get("uid")) );
        }
        //conn.commit();
        
        result = "Your order was successfully fulfilled!";


    } catch(Exception ex){
        conn.rollback();
        result = ex.getMessage();
        ex.printStackTrace();
    } finally{
        try{
            
            conn.close();
        } catch(Exception ex){

        }
    }
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
    o.writeObject(result);
    o.flush();
    o.close();
%>
    <%!
        String url = "";
        private Connection conn;

        public void execStoreOperation(Connection conn,
                int addedStockCount, String stockBarcode,
                String storeId, String date, String orderId, String userId )
                throws Exception {

            // return values
            String insertedEventId;
            String stockId;
            int newStockCountOnHand;

            // find stock
            String sql = "SELECT STCK_KEY," +
                    " STCK_PCNT, CNTN_BCOD, STCK_NAME " +
                    " FROM BASE_STCK " +
                    " WHERE STCK_BRCD='" + stockBarcode + "'";
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            if( !rs.next() )
                throw new Exception( "BARCODE NOT REGISTERED IN THE SYSTEM" );
            stockId = rs.getString(1);
            String countInPacket = rs.getString(2);
            String contentBarcode = rs.getString(3);
            String stockName = rs.getString(4);
            rs.close();
            stm.close();

            int stockCountOnHand = 0;
            sql = " SELECT STCK_CNT " +
                    " FROM CONN_STCK_IN_STOR " +
                    " WHERE STCK_IDNT=" + stockId +  " AND STOR_IDNT=" + storeId;
            stm = conn.createStatement();
            rs = stm.executeQuery(sql);
            boolean isExistConnStockStore = rs.next();
            if( isExistConnStockStore ) {
                stockCountOnHand = rs.getInt(1);
            }
            rs.close();
            stm.close();

            //update conn_stock_in_count

            newStockCountOnHand = stockCountOnHand - addedStockCount;

            if( newStockCountOnHand < 0 )
                throw new Exception("CANT'T MOVE OUT MORE THAN WE HAVE ON HAND");
            String errorMessage = "";
            if( isExistConnStockStore ) {
                sql = " UPDATE CONN_STCK_IN_STOR SET STCK_CNT = " +  newStockCountOnHand +
                        " WHERE STCK_IDNT=" + stockId +
                        " AND STOR_IDNT=" + storeId;
                errorMessage = "ERROR UPDATINGINSERTING STOCK COUNT ON HAND ROW";
            } else {
                sql = " INSERT INTO CONN_STCK_IN_STOR (stck_idnt,stor_idnt,stck_cnt,stck_ivtr) VALUES" +
                        " ( " + stockId + "," + storeId + "," +
                        newStockCountOnHand + ", 0) ";
                errorMessage = "ERROR INSERTING STOCK COUNT ON HAND ROW";
            }
            stm = conn.createStatement();
            if( stm.executeUpdate(sql) <= 0 )
                throw new Exception(errorMessage);
            stm.close();

            //update event tables
            sql = "INSERT INTO BASE_EVNT " +
                    " (evnt_date ,stor_idnt , oper_idnt, strn_evnt ,user_idnt) " +
                    "VALUES('" + date + "', " +
                    storeId + ", 'OT',NULL," + userId + ")";

            stm = conn.createStatement();
            stm.executeUpdate(sql,new String[]{"evnt_key"});
            ResultSet rset = stm.getGeneratedKeys();
            rset.next();
            insertedEventId = rset.getString(1);
            stm.close();

            sql = "INSERT INTO CONN_STCK_IN_EVNT " +
                    " (stck_idnt ,evnt_idnt , stck_cnt) " +
                    " VALUES ( " + stockId +
                    " , " + insertedEventId + ", " + addedStockCount + " ) ";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();

            sql = "INSERT INTO CONN_EVNT_QUER (evnt_idnt,quer_idnt ) VALUES(" + insertedEventId + "," + orderId + ")";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            
        }
        protected Connection getConnection() throws Exception{
            try{
                if(conn==null || conn.isClosed())
                    conn = DriverManager.getConnection(url);
            } catch(Exception e){
                throw new Exception("Error: Database connection failed!\n" + e.getMessage());
            }
            return conn;
        }
    %>