<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>

<%@include file="/medstore/utils/dataFromRs.jsp"%>
<%@include file="/medstore/utils/validate.jsp"%>
<%@include file="/WEB-INF/db/db.jsp"%>

<%

    url = cn;
    try{
        ObjectInputStream in = new ObjectInputStream(request.getInputStream());

        HashMap user = (HashMap)in.readObject();
        HashMap data = (HashMap)in.readObject();

        String stck_brcd = String.valueOf(data.get("stck_brcd"));
        String p_menge = String.valueOf(data.get("p_menge"));
        String v_nr = String.valueOf(data.get("v_nr"));

        validate(user);

        HashMap result = new HashMap();

        String stck_key = keyFromBarckode(stck_brcd);
        Vector row = new Vector();

        try{
            Integer.parseInt(stck_key.trim());
            row = isValidRow(stck_key, p_menge, v_nr);
        } catch(Exception e){
            result.put("barcode","There is no stock registered with that barcode!");
        }
        if(data.size()<=0){
            result.put("record","There is no such record for this order!");
        }
        result.put("data",row);
        
        ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
        o.writeObject(result);
        o.flush();
        o.close();

    } catch(Exception ex){
        ex.printStackTrace();
    } finally{
        try{
            conn.close();
        } catch(Exception ex){

        }
    }
    %>
<%!
    String url = "";
    private Connection conn;

    protected String keyFromBarckode(String barcode) throws Exception{
        String sql = "SELECT STCK_KEY,STCK_NAME " +
                " FROM BASE_STCK WHERE STCK_BRCD = '" + barcode + "'";
        PreparedStatement pstmt = getConnection().prepareStatement(sql);        
        ResultSet rs = pstmt.executeQuery();
        if(rs.next()){
            return rs.getString(1);
        }
        return null;
    }

    protected Vector isValidRow(
            String nStockID, String strStockCount, String nCurrentOrderNo)
            throws Exception{

        String sql = "" +
                "   SELECT  " +
                "       * " +
                "   FROM " +
                "       VIEW_ORDER_INFO " +
                "   WHERE " +
                "       STCK_KEY='" + nStockID + "' AND " +
                "       P_MENGE=" + strStockCount + " AND " +
                "       V_NR=" + String.valueOf(nCurrentOrderNo);
        
                
        PreparedStatement pstmt = getConnection().prepareStatement(sql);
        ResultSet rs = pstmt.executeQuery();
        
        return initLinkedMapVector(rs);
    }

    protected Connection getConnection() throws Exception{
        try{
            if(conn==null || conn.isClosed())
                conn = DriverManager.getConnection(url);
        } catch(Exception e){
            throw new Exception("Error: Database connection failed!\n" + e.getMessage());
        }
        return conn;
    }
%>