<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="javax.swing.table.*"%>

<%@include file="/WEB-INF/db/db.jsp"%>
<%

    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
    try{
        HashMap row = (HashMap)in.readObject();
        Integer stck_key = (Integer)row.get("stck_key");
        String stck_name = String.valueOf(row.get("stck_name"));
        String stck_abrv = String.valueOf(row.get("stck_abrv"));
        Integer stockgroup = (Integer)row.get("stockgroup");
        String stck_brcd = String.valueOf(row.get("stck_brcd"));
        String cntn_bcod = String.valueOf(row.get("cntn_bcod"));
        Integer stck_pcnt = (Integer)row.get("stck_pcnt");
        Integer stck_limt = (Integer)row.get("stck_limt");
        Double pric_buy = (Double)row.get("pric_buy");
        Double pric_mid = (Double)row.get("pric_mid");
        Double pric_sell = (Double)row.get("pric_sell");
        Integer quote = (Integer)row.get("quote");

        String inssql = "INSERT INTO BASE_STCK" +
                " (" +
                "   stck_name," +
                "   stck_brcd," +
                "   stck_pcnt," +
                "   cntn_bcod," +
                "   stck_limt," +
                "   pric_buy," +
                "   pric_mid," +
                "   pric_sell," +
                "   stck_abrv," +
                "   stockgroup," +
                "   quote" +
                " )" +
                " VALUES(" +
                "   '" + stck_name + "'," +
                "   '" + stck_brcd + "'," +
                "   "  + stck_pcnt + "," +
                "   '" + cntn_bcod + "'," +
                "   " + stck_limt + "," +
                "   " + pric_buy + "," +
                "   " + pric_mid + "," +
                "   " + pric_sell +  "," +
                "   '" + stck_abrv + "'," +
                "   " + stockgroup +"," +
                "   " + quote +
                " )";
        String updatesql = "UPDATE BASE_STCK " +
                " SET" +
                " STCK_NAME ='" + stck_name + "', " +
                " STCK_BRCD ='" + stck_brcd + "', " +
                " STCK_PCNT = " + stck_pcnt + ", " +
                " CNTN_BCOD ='" + cntn_bcod + "', " +
                " STCK_LIMT = " + stck_limt  + ", " +
                " PRIC_BUY = "  + pric_buy + ", " +
                " PRIC_MID = " + pric_mid + ", " +
                " PRIC_SELL = " + pric_sell + ", " +
                " STCK_ABRV = '" + stck_abrv + "', " +
                " STOCKGROUP=" + stockgroup + ", " +
                " quote = " + quote +
                "   WHERE " +
                " STCK_KEY = " + stck_key;

        String abbr_sql = " SELECT STCK_KEY " +
                "   FROM BASE_STCK " +
                "   WHERE " +
                "       (STCK_ABRV = '" + stck_abrv + "')";

        String barcode_sql = " SELECT STCK_KEY " +
                "   FROM BASE_STCK " +
                "   WHERE " +
                "       (   stck_brcd = '" + stck_brcd + "')";

        Connection conn = DriverManager.getConnection(cn);
        String[] cols = {"stck_key"};
        String sql = "";

        if(stck_key.intValue()<=0){
            sql = inssql;
        } else{
            abbr_sql+= " AND   STCK_KEY != " + stck_key.intValue();
            barcode_sql+= " AND   STCK_KEY != " + stck_key.intValue();
            sql = updatesql;
        }
        ResultSet rs = conn.createStatement().executeQuery(abbr_sql);
        if(rs.next()){
            throw new Exception("Abbreviation already exist.\nPlease, choose another!");
        }
        rs = conn.createStatement().executeQuery(barcode_sql);
        if(rs.next()){
            throw new Exception("Barcode already exist.\nPlease, choose another!");
        }

        PreparedStatement ps = conn.prepareStatement(sql,cols);
        int i = ps.executeUpdate();
        if(i<=0){
            throw new Exception("Record not inserted!");
        }
        if(stck_key.intValue()>0){
            o.writeObject(stck_key);
        } else{
            rs = ps.getGeneratedKeys();
            if(rs.next()){
                String key = rs.getString(1);
                if("null".equalsIgnoreCase(key)){
                    throw new NumberFormatException("Can't generate stock key");
                }
                else{
                     o.writeObject(key);
                }
            } else{
                o.writeObject(new Exception("Record not inserted!"));
            }
        }
        try{
            conn.close();
        } catch(Exception e){

        }
    } catch(Exception ex){
        o.writeObject(new Exception("Remote Error: " + ex.getMessage()));
    }
    o.flush();
    o.close();


    %>

