<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>

<%@include file="/WEB-INF/db/db.jsp"%>
<%@include file="/medstore/products/CompositeProduct.jsp"%>
<%@include file="/medstore/procedures/ProcedureStore.jsp"%>

<%
    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());

    HashMap map;
    String barcode ;
    int count;
    int storeId;
    int storeTo;
    String operation;
    
    try{

        try{
            map = (HashMap)in.readObject();            
        } catch(Exception ex){
            o.writeObject(new Exception("Error: Invalid data"));
            return;
        }

        try{
            barcode = String.valueOf(map.get("barcode"));
            count = Integer.parseInt(""+map.get("count"));
            storeId = Integer.parseInt(String.valueOf(map.get("store")));
            operation = String.valueOf(map.get("operation"));

        } catch(Exception ex){
            ex.printStackTrace();
            o.writeObject(new Exception("Error: Invalid data!"));
            return;
        }

        Connection conn = DriverManager.getConnection(cn);
        boolean b = executeStoreOperation(
                conn,
                operation, 
                count, 
                barcode, 
                storeId,
                medstore.SharedUtils.getDateStringFormatted(java.util.Calendar.getInstance()), 
                "1"
                );
        o.writeObject(strStockName);

    } catch(Exception e){
        o.writeObject(e);
    } finally{
        o.flush();
        o.close();
    }

%>

<%!
    String strStockName = null;;
    private boolean executeStoreOperation(
            Connection conn, 
            String strOperationCode, 
            int nStockCount,
            String strBarcode,
            int nStoreId, 
            String date, 
            String nUserID
            ) throws Exception {

        CompositeProduct compositeProduct = new CompositeProduct(conn);
        try {
            if(compositeProduct.isCompositeForBarcode(strBarcode)){
                throw new Exception("Can't move composite products!");
            }
            strStockName = null;
            
            conn.setAutoCommit(false);
            ProcedureStore proc = new ProcedureStore();
            proc.execStoreOperation(conn,
                strOperationCode,
                nStockCount, strBarcode,
                ""+nStoreId, date, nUserID );
                        
            strStockName = proc.m_stockName;
            
            conn.commit();
        } catch(Exception e) {

            try{
                conn.rollback();
            } catch(Exception ex){

            }
            throw new Exception("Operation can not be completed!\n" + e.getMessage() );
        } finally {
            try{
                conn.close();
            } catch(Exception ex){

            }
        }
        return true;
    }
%>