<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="java.text.*"%>

<%@include file="/medstore/utils/dataFromRs.jsp"%>
<%@include file="/medstore/utils/validate.jsp"%>
<%@include file="/WEB-INF/db/db.jsp"%>

<%
    Connection conn = null;
    try{
        ObjectInputStream in = new ObjectInputStream(request.getInputStream());
        HashMap map = (HashMap)in.readObject();

        Boolean datefilter = (Boolean)map.get("datefilter");
        Boolean storefilter = (Boolean)map.get("storefilter");
        int storeid = Integer.parseInt(String.valueOf(map.get("storeid")));
        Long datefrom = (Long)map.get("datefrom");
        Long dateto = (Long)map.get("dateto");
        
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd");
        
        String sql = "SELECT   " +
                "   BASE_EVNT.EVNT_DATE, " +
                "   BASE_STOR.STOR_NAME, " +
                "   BASE_OPER.OPER_NAME, " +
                "   BASE_STCK.STCK_NAME, " +
                "   CONN_STCK_IN_EVNT.STCK_CNT " +
                " FROM    " +
                "   BASE_EVNT INNER JOIN BASE_OPER ON(BASE_EVNT.OPER_IDNT = BASE_OPER.OPER_KEY)" +
                "   INNER JOIN CONN_STCK_IN_EVNT ON(CONN_STCK_IN_EVNT.EVNT_IDNT = BASE_EVNT.EVNT_KEY)" +
                "   INNER JOIN BASE_STCK ON(CONN_STCK_IN_EVNT.STCK_IDNT = BASE_STCK.STCK_KEY)" +
                "   INNER JOIN BASE_STOR ON(BASE_EVNT.STOR_IDNT = BASE_STOR.STOR_KEY)" +
                " WHERE " +
                "   OPER_IDNT IN('IN','OT')";
        sql+= storefilter.booleanValue() ? " AND STOR_IDNT = " + storeid : "";
        sql+= datefilter.booleanValue() ? " AND EVNT_DATE >= '" + 
                sdf.format(new java.util.Date(datefrom.longValue())) + " 00:00:00' AND EVNT_DATE <= '" + 
                sdf.format(new java.util.Date(dateto.longValue())) + " 23:59:59'" : "";
        
        System.out.println(sql);

        conn = DriverManager.getConnection(cn);
        
        Statement stm = conn.createStatement();
        ResultSet rs = stm.executeQuery(sql);

        Vector data = new Vector();

        while(rs.next()){
            LinkedHashMap row = new LinkedHashMap();
            row.put("EVNT_DATE", rs.getObject("EVNT_DATE"));
            row.put("STOR_NAME", rs.getObject("STOR_NAME"));
            row.put("OPER_NAME", rs.getObject("OPER_NAME"));
            row.put("STCK_NAME", rs.getObject("STCK_NAME"));
            row.put("STCK_CNT", rs.getObject("STCK_CNT"));
            data.add(row);
        }

        ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
        o.writeObject(data);
        o.flush();
        o.close();

    } catch(Exception sqle){

    } finally{
        try{
            conn.close();
        } catch(Exception sqle){

        }
    }
%>