package adminmodul.accesscontrol;

public class PassChangeData extends UserData{
    private String oldPass;
    private String newPass;
    private String confirmNewPass;
    public PassChangeData() {
        this.oldPass = null;
        this.newPass = null;
        this.confirmNewPass = null;
    }
    public boolean validatePass() throws Exception{                
        if(newPass==null || confirmNewPass==null)
            throw new Exception("Validation failed!\nAll fields are mandatory!");
        if(newPass.trim().length()<=0)
            throw new Exception("Validation failed!\nAll fields are mandatory!");
        if(!newPass.equals(confirmNewPass))
            throw new Exception("Validation failed!\nThe New & Confirm Passwords must be equal!");
        setPassword(this.newPass);
        return true;
    }
    
    public void setOldPass(String value){
         this.oldPass = value;
    }
    public void setNewPass(String value){
        this.newPass = value;
    }
    public void setConfirmNewPass(String value){
        this.confirmNewPass = value;
    }
}
