/*
 * AddClient.java
 *
 * Created on , 2005,  5, 14:15
 */

package medstore;

import java.awt.event.InputEvent;
import java.sql.Connection;
import java.sql.PreparedStatement;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import medstore.date.DateUtil;
import medstore.math.BigDec;

/**
 *
 * @author  JohnyEdu
 */
public class AddClient extends CommonDialog implements SharedConstants,ListSelectionListener{
    
    public static final int ADD_MODE = 1;
    public static final int EDIT_MODE = 2;
    
    public static final int PROV1_NAME_INDEX = 0;
    public static final int PROV2_NAME_INDEX = 1;
    public static final int COMM_KEY_INDEX = 2;
    Vector vecProvSearchResults = new Vector();
    UniversalInputVerifier uivFirstName,uivSurname,uivCity,uivCode,uivStreet,uivDiscount,uivProv3Pers,uivProv1Pers,uivProv2Pers;
    //UniversalInputVerifier uniFax,uniEmail;
    private Vector vecProv1SearchResults;
    private Vector vecProv2SearchResults;
    private Vector vecResults;
    int nProv1Idnt,nProv2Idnt;
    int nMode;
    int nPersonID;
    String m_strProv3Id = "";
    UniversalInputVerifier dateVerifier;
    
    private DateUtil dateUtil;
    
    //private final static int PERSON_KEY_INDEX = 0;
    public AddClient(java.awt.Frame parent, boolean modal,int nMode,Vector vecResults) {
        super(parent, modal);
        vecProv1SearchResults = new Vector();
        vecProv2SearchResults = new  Vector();
        this.vecResults = vecResults;
        
        nProv1Idnt = -1;
        nProv2Idnt = -1;
        this.nMode = nMode;
        initComponents();
        afterInitComponents();
        if(nMode == ADD_MODE)
            nPersonID = -1;
        else{
            nPersonID = Integer.parseInt((String)vecResults.get(0));
            loadClientInfo(nPersonID);
        }
        translate();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        editWorkPhone = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        editMobilePhone = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        editFax = new javax.swing.JTextField();
        editPrivatePhone = new javax.swing.JTextField();
        editEmail = new javax.swing.JTextField();
        jScrollPane5 = new javax.swing.JScrollPane();
        edpAddInfo = new javax.swing.JEditorPane();
        jLabel4 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jpanGenInfo = new javax.swing.JPanel();
        editUIN = new javax.swing.JTextField();
        editDiscount = new javax.swing.JTextField();
        editFirstName = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        editStreet = new javax.swing.JTextField();
        editCity = new javax.swing.JTextField();
        editCode = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        editSurname = new javax.swing.JTextField();
        chkbCanPurchase = new javax.swing.JCheckBox();
        comboAppeal = new javax.swing.JComboBox();
        comboPersonType = new javax.swing.JComboBox();
        comboCountry = new javax.swing.JComboBox();
        chkbProv1Appr = new javax.swing.JCheckBox();
        chkbProv2Appr = new javax.swing.JCheckBox();
        jLabel12 = new javax.swing.JLabel();
        editCLCode = new javax.swing.JTextField();
        chkbVATFree = new javax.swing.JCheckBox();
        editAlternateName = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jpanProv = new javax.swing.JPanel();
        editProv1UIN = new javax.swing.JTextField();
        editProv1Name = new javax.swing.JTextField();
        editProv1Pers = new javax.swing.JTextField();
        btnSelectProv1 = new javax.swing.JButton();
        editProv2UIN = new javax.swing.JTextField();
        editProv2Name = new javax.swing.JTextField();
        editProv2Pers = new javax.swing.JTextField();
        btnShowPercents = new javax.swing.JButton();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        lblProv1 = new javax.swing.JLabel();
        lblProv2 = new javax.swing.JLabel();
        scrProvs = new javax.swing.JScrollPane();
        tblProvs = new javax.swing.JTable();
        btnSelectProv2 = new javax.swing.JButton();
        jLabel24 = new javax.swing.JLabel();
        editProv3UIN = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        editProv3Name = new javax.swing.JTextField();
        btnSelectProv3 = new javax.swing.JButton();
        editProv3Pers = new javax.swing.JTextField();
        lblPers3 = new javax.swing.JLabel();
        btnAdd = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        editBirthDate = new javax.swing.JTextField();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add Person");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                AddClient.this.windowClosed(evt);
            }
        });

        getContentPane().add(jPanel1);
        jPanel1.setBounds(200, 470, 10, 10);

        getContentPane().add(jPanel2);
        jPanel2.setBounds(140, 440, 10, 10);

        jPanel4.setLayout(null);

        jPanel4.setBorder(new javax.swing.border.TitledBorder(null, "Additional Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jPanel4.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Private phone");
        jPanel4.add(jLabel8);
        jLabel8.setBounds(10, 20, 150, 18);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Work phone");
        jPanel4.add(jLabel1);
        jLabel1.setBounds(170, 20, 160, 18);

        editWorkPhone.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel4.add(editWorkPhone);
        editWorkPhone.setBounds(170, 40, 160, 21);

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Mobile Phone");
        jPanel4.add(jLabel2);
        jLabel2.setBounds(10, 70, 150, 18);

        editMobilePhone.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel4.add(editMobilePhone);
        editMobilePhone.setBounds(10, 90, 150, 21);

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText("Fax");
        jPanel4.add(jLabel3);
        jLabel3.setBounds(170, 70, 160, 18);

        editFax.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel4.add(editFax);
        editFax.setBounds(170, 90, 160, 21);

        editPrivatePhone.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel4.add(editPrivatePhone);
        editPrivatePhone.setBounds(10, 40, 150, 21);

        editEmail.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel4.add(editEmail);
        editEmail.setBounds(10, 140, 320, 21);

        edpAddInfo.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane5.setViewportView(edpAddInfo);

        jPanel4.add(jScrollPane5);
        jScrollPane5.setBounds(10, 190, 320, 70);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("E-mail");
        jPanel4.add(jLabel4);
        jLabel4.setBounds(10, 120, 320, 18);

        jLabel18.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel18.setText("Additional Info");
        jPanel4.add(jLabel18);
        jLabel18.setBounds(10, 170, 320, 18);

        getContentPane().add(jPanel4);
        jPanel4.setBounds(350, 90, 340, 270);

        jpanGenInfo.setLayout(null);

        jpanGenInfo.setBorder(new javax.swing.border.TitledBorder(null, "General Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanGenInfo.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        editUIN.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        editUIN.setEnabled(false);
        jpanGenInfo.add(editUIN);
        editUIN.setBounds(240, 310, 70, 23);

        editDiscount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDiscount.setText("0");
        jpanGenInfo.add(editDiscount);
        editDiscount.setBounds(260, 100, 60, 21);

        editFirstName.setColumns(5);
        editFirstName.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editFirstName);
        editFirstName.setBounds(10, 50, 100, 21);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("UIN");
        jLabel5.setName("lblOPUIN");
        jpanGenInfo.add(jLabel5);
        jLabel5.setBounds(240, 290, 95, 18);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Appeal");
        jLabel6.setName("lblOPApeal");
        jpanGenInfo.add(jLabel6);
        jLabel6.setBounds(230, 30, 90, 18);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Type");
        jLabel7.setName("lblOPType");
        jpanGenInfo.add(jLabel7);
        jLabel7.setBounds(140, 80, 100, 18);

        jLabel9.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel9.setText("Discount %");
        jLabel9.setName("lblOPDiscount");
        jpanGenInfo.add(jLabel9);
        jLabel9.setBounds(260, 80, 70, 18);

        editStreet.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editStreet);
        editStreet.setBounds(10, 260, 210, 21);

        editCity.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editCity);
        editCity.setBounds(10, 310, 90, 21);

        editCode.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editCode);
        editCode.setBounds(230, 260, 90, 21);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel10.setText("First Name");
        jLabel10.setName("lblOPFName");
        jpanGenInfo.add(jLabel10);
        jLabel10.setBounds(10, 30, 110, 18);

        jLabel11.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel11.setText("Surname");
        jLabel11.setName("lblOPLName");
        jpanGenInfo.add(jLabel11);
        jLabel11.setBounds(120, 30, 110, 18);

        jLabel14.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel14.setText("Street");
        jLabel14.setName("lblOPStreet");
        jpanGenInfo.add(jLabel14);
        jLabel14.setBounds(10, 240, 210, 18);

        jLabel15.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel15.setText("Code");
        jLabel15.setName("lblOPCode");
        jpanGenInfo.add(jLabel15);
        jLabel15.setBounds(230, 240, 90, 18);

        jLabel16.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel16.setText("City");
        jLabel16.setName("lblOPCity");
        jpanGenInfo.add(jLabel16);
        jLabel16.setBounds(10, 290, 90, 18);

        jLabel17.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel17.setText("Country");
        jLabel17.setName("lblOPCountry");
        jpanGenInfo.add(jLabel17);
        jLabel17.setBounds(110, 290, 120, 18);

        editSurname.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editSurname);
        editSurname.setBounds(120, 50, 100, 21);

        chkbCanPurchase.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbCanPurchase.setText("Can purchase");
        chkbCanPurchase.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chkbCanPurchase.setName("chkOPCanPurchase");
        jpanGenInfo.add(chkbCanPurchase);
        chkbCanPurchase.setBounds(172, 130, 150, 20);

        comboAppeal.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboAppeal.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Frau", "Herr", "Frau Dr.", "Herr Dr.", "Mevrouw", "Meneer", "Mister", "Misses" }));
        jpanGenInfo.add(comboAppeal);
        comboAppeal.setBounds(230, 50, 90, 22);

        comboPersonType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanGenInfo.add(comboPersonType);
        comboPersonType.setBounds(140, 100, 80, 22);

        comboCountry.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanGenInfo.add(comboCountry);
        comboCountry.setBounds(110, 310, 130, 22);

        chkbProv1Appr.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbProv1Appr.setText("Prov.1 appropriate");
        chkbProv1Appr.setName("CLProv1Appropriate");
        jpanGenInfo.add(chkbProv1Appr);
        chkbProv1Appr.setBounds(10, 160, 160, 20);

        chkbProv2Appr.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbProv2Appr.setText("Prov.2 appropriate");
        chkbProv2Appr.setName("CLProv2Appropriate");
        jpanGenInfo.add(chkbProv2Appr);
        chkbProv2Appr.setBounds(170, 160, 150, 20);

        jLabel12.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel12.setText("Client/Firm No");
        jLabel12.setName("lblOPFirmNo");
        jpanGenInfo.add(jLabel12);
        jLabel12.setBounds(10, 80, 130, 18);

        editCLCode.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editCLCode.setMinimumSize(new java.awt.Dimension(11, 21));
        editCLCode.setPreferredSize(new java.awt.Dimension(11, 21));
        jpanGenInfo.add(editCLCode);
        editCLCode.setBounds(10, 100, 100, 21);

        chkbVATFree.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbVATFree.setText("VAT Free ");
        chkbVATFree.setName("chkOPVatFree");
        jpanGenInfo.add(chkbVATFree);
        chkbVATFree.setBounds(10, 130, 160, 20);

        editAlternateName.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanGenInfo.add(editAlternateName);
        editAlternateName.setBounds(10, 210, 210, 21);

        jLabel13.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel13.setText("Alternative Name");
        jLabel13.setName("lblOPAltName");
        jpanGenInfo.add(jLabel13);
        jLabel13.setBounds(10, 190, 210, 18);

        getContentPane().add(jpanGenInfo);
        jpanGenInfo.setBounds(10, 10, 340, 350);

        jpanProv.setLayout(null);

        jpanProv.setBorder(new javax.swing.border.TitledBorder(null, "Relations - Provisions", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanProv.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        editProv1UIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv1UIN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(editProv1UIN);
        editProv1UIN.setBounds(80, 30, 50, 21);

        editProv1Name.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv1Name.setEnabled(false);
        jpanProv.add(editProv1Name);
        editProv1Name.setBounds(230, 30, 150, 21);

        editProv1Pers.setText("0");
        jpanProv.add(editProv1Pers);
        editProv1Pers.setBounds(450, 30, 60, 20);

        btnSelectProv1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSelectProv1.setText("Select Provision 1");
        btnSelectProv1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSelectProv1.setName("btnSelProv1");
        btnSelectProv1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(btnSelectProv1);
        btnSelectProv1.setBounds(530, 30, 130, 25);

        editProv2UIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv2UIN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(editProv2UIN);
        editProv2UIN.setBounds(80, 60, 50, 21);

        editProv2Name.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv2Name.setEnabled(false);
        jpanProv.add(editProv2Name);
        editProv2Name.setBounds(230, 60, 150, 21);

        editProv2Pers.setText("0");
        jpanProv.add(editProv2Pers);
        editProv2Pers.setBounds(450, 60, 60, 20);

        btnShowPercents.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnShowPercents.setText("%");
        btnShowPercents.setIconTextGap(1);
        btnShowPercents.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnShowPercents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(btnShowPercents);
        btnShowPercents.setBounds(390, 30, 20, 50);

        jLabel20.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel20.setText("Prov.1 UIN");
        jLabel20.setName("lblProv1UIN");
        jpanProv.add(jLabel20);
        jLabel20.setBounds(10, 30, 70, 18);

        jLabel21.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel21.setText("Prov2 UIN");
        jLabel21.setName("lblProv2UIN");
        jpanProv.add(jLabel21);
        jLabel21.setBounds(10, 60, 70, 18);

        jLabel22.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel22.setText("Prov.1 Name");
        jLabel22.setName("lblProv1Name");
        jpanProv.add(jLabel22);
        jLabel22.setBounds(140, 30, 90, 18);

        jLabel23.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel23.setText("Prov.2 Name");
        jLabel23.setName("lblProv2Name");
        jpanProv.add(jLabel23);
        jLabel23.setBounds(140, 60, 90, 18);

        lblProv1.setText("======>");
        jpanProv.add(lblProv1);
        lblProv1.setBounds(410, 30, 60, 15);

        lblProv2.setText("======>");
        jpanProv.add(lblProv2);
        lblProv2.setBounds(410, 60, 60, 15);

        scrProvs.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblProvs.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Prov.1 %", "Prov.2 %"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblProvs.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                AddClient.this.mousePressed(evt);
            }
        });

        scrProvs.setViewportView(tblProvs);

        jpanProv.add(scrProvs);
        scrProvs.setBounds(420, 10, 100, 110);

        btnSelectProv2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSelectProv2.setText("Select Provision 2");
        btnSelectProv2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSelectProv2.setName("btnSelProv2");
        btnSelectProv2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(btnSelectProv2);
        btnSelectProv2.setBounds(530, 60, 130, 25);

        jLabel24.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel24.setText("Prov3 UIN");
        jLabel24.setName("lblProv3UIN");
        jpanProv.add(jLabel24);
        jLabel24.setBounds(10, 90, 70, 18);

        editProv3UIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv3UIN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        jpanProv.add(editProv3UIN);
        editProv3UIN.setBounds(80, 90, 50, 21);

        jLabel25.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel25.setText("Prov.3 Name");
        jLabel25.setName("lblProv3Name");
        jpanProv.add(jLabel25);
        jLabel25.setBounds(140, 90, 90, 18);

        editProv3Name.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv3Name.setEnabled(false);
        jpanProv.add(editProv3Name);
        editProv3Name.setBounds(230, 90, 150, 21);

        btnSelectProv3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSelectProv3.setText("Select Provision 3");
        btnSelectProv3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSelectProv3.setName("btnSelProv3");
        btnSelectProv3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectProv3ActionPerformed(evt);
            }
        });

        jpanProv.add(btnSelectProv3);
        btnSelectProv3.setBounds(530, 90, 130, 25);

        jpanProv.add(editProv3Pers);
        editProv3Pers.setBounds(450, 90, 60, 20);

        lblPers3.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        lblPers3.setText("%");
        jpanProv.add(lblPers3);
        lblPers3.setBounds(435, 90, 15, 18);

        getContentPane().add(jpanProv);
        jpanProv.setBounds(10, 360, 680, 130);

        btnAdd.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAdd.setText("Add");
        btnAdd.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAdd.setName("btnClAdd");
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        getContentPane().add(btnAdd);
        btnAdd.setBounds(230, 500, 100, 26);

        btnCancel.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnCancel.setText("Cancel");
        btnCancel.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnCancel.setName("btnClCancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddClient.this.actionPerformed(evt);
            }
        });

        getContentPane().add(btnCancel);
        btnCancel.setBounds(350, 500, 100, 26);

        jPanel6.setLayout(null);

        jPanel6.setBorder(new javax.swing.border.TitledBorder(null, "Birth Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jLabel19.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel19.setText("Birth Date");
        jPanel6.add(jLabel19);
        jLabel19.setBounds(10, 30, 100, 18);

        editBirthDate.setColumns(5);
        editBirthDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        jPanel6.add(editBirthDate);
        editBirthDate.setBounds(10, 50, 100, 21);

        getContentPane().add(jPanel6);
        jPanel6.setBounds(350, 10, 340, 80);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-707)/2, (screenSize.height-566)/2, 707, 566);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnSelectProv3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectProv3ActionPerformed
        Vector searchResults = new Vector();
        new PersonSearch(new javax.swing.JFrame(), true, searchResults,PersonSearch.PROV3_SEARCH ).setVisible(true);
        if(searchResults.size() == 0)
            return;
        String strUIN = m_strProv3Id = (String)searchResults.get(0);
        String strName = (String)searchResults.get(1);
        editProv3UIN.setText(strUIN);
        editProv3Name.setText(strName);
    }//GEN-LAST:event_btnSelectProv3ActionPerformed
    
    private void windowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosed
        vecResults.removeAllElements();
        //dispose();
    }//GEN-LAST:event_windowClosed
    
    private void mousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed
        if( evt.getSource() == tblProvs ){
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                int nRow = tblProvs.rowAtPoint(evt.getPoint());
                String strProv1 = (String)((UniversalTableRow)((UniversalTableModel)tblProvs.getModel()).getRowObject(nRow)).getRowElement(PROV1_NAME_INDEX);
                String strProv2 = (String)((UniversalTableRow)((UniversalTableModel)tblProvs.getModel()).getRowObject(nRow)).getRowElement(PROV2_NAME_INDEX);
                tblProvs.setVisible(false);
                scrProvs.setVisible(false);
                editProv1Pers.setText(strProv1);
                editProv2Pers.setText(strProv2);
                lblProv1.setVisible(true);
                lblProv2.setVisible(true);
                editProv1Pers.setVisible(true);
                editProv2Pers.setVisible(true);
            }
        }
        
    }//GEN-LAST:event_mousePressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnShowPercents ){
            lblProv1.setVisible(false);
            lblProv2.setVisible(false);
            editProv1Pers.setVisible(false);
            editProv2Pers.setVisible(false);
            tblProvs.setVisible(true);
            scrProvs.setVisible(true);
        } else if( evt.getSource() == btnSelectProv1 ){
            
            new PersonSearch(new javax.swing.JFrame(), true, vecProv1SearchResults,PersonSearch.DOCTOR_SEARCH ).setVisible(true);
            if(vecProv1SearchResults.size() == 0)
                return;
            String strUIN = (String)vecProv1SearchResults.get(0);
            String strName = (String)vecProv1SearchResults.get(1);
            String strProv2Idnt = (String)vecProv1SearchResults.get(2);
            String strProv1Comm = (String)vecProv1SearchResults.get(3);
            String strProv2Comm = (String)vecProv1SearchResults.get(4);
            
            this.nProv1Idnt = Integer.parseInt(strUIN);
            if(strProv2Idnt!=null && !"null".equals(strProv2Idnt) && strProv2Idnt.length()>0){
                try{
                    
                    this.nProv2Idnt = Integer.parseInt(strProv2Idnt);
                    Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                    String strSQL = " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                            " FROM base_prsn " +
                            " WHERE prsn_key = " + strProv2Idnt;
                    
                    Statement stm = connDB.createStatement();
                    ResultSet rsDBData=stm.executeQuery(strSQL);
                    boolean bMore = rsDBData.next();
                    if(bMore){
                        String strProv2Name = rsDBData.getString(1);
                        editProv2UIN.setText(strProv2Idnt);
                        editProv2Name.setText(strProv2Name);
                        editProv2Pers.setText(strProv2Comm);
                        loadProv3FromProv2( strProv2Idnt, connDB );
                    }
                    rsDBData.close();
                    stm.close();
                    
                }catch(SQLException sqle){
                    SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
                } catch(Exception e){
                    
                }
            }
            editProv1UIN.setText(strUIN);
            editProv1Name.setText(strName);
            editProv1Pers.setText(strProv1Comm);
            
        } else if( evt.getSource() == btnSelectProv2 ) {
            
            new PersonSearch(new javax.swing.JFrame(), true, vecProv2SearchResults,PersonSearch.DEALER_SEARCH ).setVisible(true);
            if(vecProv2SearchResults.size() == 0)
                return;
            String strUIN = (String)vecProv2SearchResults.get(0);
            String strName = (String)vecProv2SearchResults.get(1);
            this.nProv2Idnt = Integer.parseInt(strUIN);
            editProv2UIN.setText(strUIN);
            editProv2Name.setText(strName);
            editProv1Pers.setText("0");
            editProv2Pers.setText("0");
            Connection conn = null;
            try {
                conn = SharedUtils.getConnection();
                loadProv3FromProv2( strUIN, conn );
            } catch( Exception e ) {
                e.printStackTrace();
            } finally {
                SharedUtils.closeConnection(conn);
            }
            JOptionPane.showMessageDialog(null,"You choose to change the dealer but now you have to put the provisions charge manually!");
        } else if( evt.getSource() == btnAdd ){
            
            if(!uivFirstName.Universal_String_Verifier(editFirstName)){
                JOptionPane.showMessageDialog(null,"Please enter valid First Name(50 characters max)!");
                return;
            }
            if(editSurname.getText().length()>50){
                JOptionPane.showMessageDialog(null,"Please enter valid Surname!(50 characters max)");
                editSurname.requestFocus();
                return;
            }
            if(editCity.getText().length()>50){
                JOptionPane.showMessageDialog(null,"Please enter valid City Name(50 characters max)!");
                editCity.requestFocus();
                return;
            }
            if(editCode.getText().length()>50){
                JOptionPane.showMessageDialog(null,"Please enter valid City Code(100 characters max)!");
                editCode.requestFocus();
                return;
            }            
            if(editCLCode.getText().length()>30){
                JOptionPane.showMessageDialog(null,"Please enter valid Client/Firm No(30 characters max)!");
                editCLCode.requestFocus();
                return;
            }
            if(editAlternateName.getText().length()>100){
                JOptionPane.showMessageDialog(null,"Please enter valid Alternative Name(100 characters max)!");
                editAlternateName.requestFocus();
                return;
            }
            
            if( !uivDiscount.SCALED2_PERSENT_Verifier(editDiscount) ){
                JOptionPane.showMessageDialog(null,"Please enter valid Discount value(0-100%)!");
                return;
            }
            if( !uivProv3Pers.SCALED2_PERSENT_Verifier(editProv3Pers) ){
                JOptionPane.showMessageDialog(null,"Please enter valid Provision 3 percent value(0-100%)!");
                return;
            }
            if( !uivProv1Pers.SCALED2_PERSENT_Verifier(editProv1Pers) ){
                JOptionPane.showMessageDialog(null,"Please enter valid Provision 1 percent value(0-100%)!");
                return;
            }
            if( !uivProv2Pers.SCALED2_PERSENT_Verifier(editProv2Pers) ){
                JOptionPane.showMessageDialog(null,"Please enter valid Provision 2 percent value(0-100%)!");
                return;
            }
            if(editBirthDate.getText().length()<=0){
                editBirthDate.setText("01.01.2010");
            }
            if(!dateVerifier.DATE_Verifier((JComponent)editBirthDate)){
                JOptionPane.showMessageDialog(this,"Please enter valid Birth date!");
                return;
            }
            if(editPrivatePhone.getText().length()>50){
                JOptionPane.showMessageDialog(this,"Please enter valid Private phone (50 characters max)!");
                editPrivatePhone.requestFocus();
                return;
            }
            if(editWorkPhone.getText().length()>50){
                JOptionPane.showMessageDialog(this,"Please enter valid Work phone (50 characters max)!");
                editWorkPhone.requestFocus();
                return;
            }
            if(editMobilePhone.getText().length()>50){
                JOptionPane.showMessageDialog(this,"Please enter valid Mobile phone (50 characters max)!");
                editMobilePhone.requestFocus();
                return;
            }
            if(editFax.getText().length()>50){
                JOptionPane.showMessageDialog(this,"Please enter valid Fax (50 characters max)!");
                editFax.requestFocus();
                return;
            }
            if(editEmail.getText().length()>60){
                JOptionPane.showMessageDialog(this,"Please enter valid E-mail (60 characters max)!");
                editEmail.requestFocus();
                return;
            }
            if(edpAddInfo.getText().length()>400){
                JOptionPane.showMessageDialog(this,"Please enter valid Additional Info (400 characters max)!");
                edpAddInfo.requestFocus();
                return;
            }
            /*if( this.nProv1Idnt == -1 || this.nProv2Idnt == -1 )
            {
                JOptionPane.showMessageDialog(null,"Please select Provision 1 and Provision 2");
                return;
            }*/
            
            String  prov1Idnt = null;
            String  prov2Idnt = null;
            String  prov3Idnt = null;
            
            String strProv1Pers = editProv1Pers.getText();
            String strProv2Pers = editProv2Pers.getText();
            String strProv3Pers = editProv3Pers.getText();
            
            String nProv1Pers = "0";
            String nProv2Pers = "0";
            String nProv3Pers = "0";
            
            if( this.nProv1Idnt != -1 ) {
                prov1Idnt = String.valueOf(this.nProv1Idnt);
                nProv1Pers = BigDec.scaledRoundHalfUp( editProv1Pers.getText() ,2);
            }
            
            if( this.nProv2Idnt != -1 ) {
                prov2Idnt = String.valueOf(this.nProv2Idnt);
                nProv2Pers = BigDec.scaledRoundHalfUp( editProv2Pers.getText(),  2 );
            }
            
            if( !m_strProv3Id.equals("") ) {
                prov3Idnt = m_strProv3Id;
                nProv3Pers = BigDec.scaledRoundHalfUp( editProv3Pers.getText(), 2 );
            }
            
            String strApeal = (String)comboAppeal.getSelectedItem();
            int nTypeID = ((ComboDataModel)comboPersonType.getModel()).getCObjectAt(comboPersonType.getSelectedIndex()).nItemDBKey;
            String strTypeID = String.valueOf(nTypeID);
            String strFirstName = editFirstName.getText();
            String strSurname = editSurname.getText();
            int nCountryID = ((ComboDataModel)comboCountry.getModel()).getCObjectAt(comboCountry.getSelectedIndex()).nItemDBKey;
            String strCountry = String.valueOf(nCountryID);
            String strCity = editCity.getText();
            String strStreet = editStreet.getText();
            String strCode = editCode.getText();
            String strDiscount = editDiscount.getText();
            String altName = editAlternateName.getText();
            String nDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
            boolean bCanPurchase = chkbCanPurchase.isSelected();
            boolean bProv1Appr = chkbProv1Appr.isSelected();
            boolean bProv2Appr = chkbProv2Appr.isSelected();
            
            String strPurchase,strProv1Good,strProv2Good,strVATFree;
            if(bCanPurchase)
                strPurchase = "Y";
            else
                strPurchase = "N";
            
            if(bProv1Appr)
                strProv1Good = "Y";
            else
                strProv1Good = "N";
            
            if(bProv2Appr)
                strProv2Good = "Y";
            else
                strProv2Good = "N";
            
            strVATFree = chkbVATFree.isSelected() ? "Y" : "N";
            
            String strPrivatePhone = editPrivatePhone.getText();
            String strWorkPhone = editWorkPhone.getText();
            String strMobilePhone = editMobilePhone.getText();
            String strEmail = editEmail.getText();
            String strFax = editFax.getText();
            String strAddInfo = edpAddInfo.getText();
            String strCLCode = editCLCode.getText();
            
            Timestamp tmspCurrentDate = SharedUtils.getCurrentTimestamp();
            String strCurrentDate = SharedUtils.getCurrentDateStringFormatted();
            int nUserID = SharedUtils.nUserID;
            String strUserID = String.valueOf(nUserID);
            dateUtil = new DateUtil(editBirthDate.getText().trim(), ".");
            String birthDate = "";
            
            try{
                
                birthDate = dateUtil.getDMYtoYDM();
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                String strSQL="";
                if(nMode == ADD_MODE){
                    boolean clexist = checkClientExist(strFirstName, strSurname, strCity, nCountryID);                    
                    if(clexist!=true){
                        return;
                    }
                    strSQL = "INSERT INTO BASE_PRSN" +
                            " ( prsn_lnam,prsn_fnam,prsn_appl,type_idnt," +
                            " prsn_dscn,prsn_info,alow_prch,cntr_idnt," +
                            " prsn_city,city_code,prsn_strt,prv1_idnt," +
                            " prv1_comm,prv2_idnt,prv2_comm,priv_phon," +
                            " work_phon,mobi_phon,prsn_fax,prsn_eml," +
                            " cret_date,cret_user_idnt,mdfc_date," +
                            " mdfc_user_idnt,prv1_good,prv2_good," +
                            " clcode,vatfree,altr_name,prv3_idnt,prv3_comm,birthDate )" +
                            " VALUES('" + strSurname + "','" +
                            strFirstName + "','" + strApeal + "'," + strTypeID + "," + strDiscount + ",'" + strAddInfo + "', " +
                            " '" + strPurchase + "','" + strCountry + "','" + strCity + "','" + strCode +
                            "','" + strStreet + "'," + prov1Idnt + "," + strProv1Pers +
                            "," + prov2Idnt + "," + strProv2Pers + ",'" + strPrivatePhone +
                            "','" + strWorkPhone + "','" + strMobilePhone +
                            "','" + strFax + "','" + strEmail + "','" + strCurrentDate + "','" + strUserID +
                            "','" + strCurrentDate + "'," + strUserID + ",'" + strProv1Good +
                            "','" + strProv2Good + "','" + strCLCode + "','" + strVATFree + "','" + altName + "'," +
                            prov3Idnt + "," + strProv3Pers + ",'" + birthDate + "')";
                    Statement stm = connDB.createStatement();
                    int nResult = stm.executeUpdate(strSQL);
                    stm.close();
                    String strID = SharedUtils.getLastInsertedID(connDB);
                    vecResults.removeAllElements();
                    vecResults.addElement(strID);
                    JOptionPane.showMessageDialog(null,"New Client has been added successfully!");
                    dispose();
                } else{
                    strSQL = "UPDATE BASE_PRSN SET PRSN_LNAM = ?, PRSN_FNAM = ?, PRSN_APPL = ?, TYPE_IDNT = ?, PRSN_DSCN = ?, " +
                            " PRSN_INFO = ?, ALOW_PRCH = ?, CNTR_IDNT = ?, PRSN_CITY = ?, CITY_CODE = ?, " +
                            " PRSN_STRT = ?, PRV1_IDNT = ?, PRV1_COMM = ?, PRV2_IDNT = ?, PRV2_COMM = ?, " +
                            " PRIV_PHON = ?, WORK_PHON = ?, MOBI_PHON = ?, PRSN_FAX  = ?, PRSN_EML  = ?, " +
                            " MDFC_DATE = ?, MDFC_USER_IDNT = ?, " +
                            " PRV1_GOOD = ?, PRV2_GOOD = ?, CLCode = ?, VATFree = ?, altr_name=?, " +
                            " PRV3_IDNT = " + prov3Idnt + ", PRV3_COMM = " + strProv3Pers + "," +
                            " birthDate = ? " +
                            " WHERE PRSN_KEY = ?";
                    
                    PreparedStatement pquery = connDB.prepareStatement(strSQL);
                    pquery.setObject(1,strSurname, Types.VARCHAR);
                    pquery.setObject(2,strFirstName, Types.VARCHAR);
                    pquery.setObject(3,strApeal, Types.VARCHAR);
                    pquery.setInt(4,nTypeID);
                    pquery.setObject(5,nDiscount,Types.NUMERIC,2);
                    pquery.setObject(6,strAddInfo, Types.VARCHAR);
                    
                    if(bCanPurchase)
                        pquery.setObject(7,"Y", Types.VARCHAR);
                    else
                        pquery.setObject(7,"N", Types.VARCHAR);
                    
                    pquery.setInt(8,nCountryID);
                    pquery.setObject(9,strCity, Types.VARCHAR);
                    pquery.setObject(10,strCode, Types.VARCHAR);
                    pquery.setObject(11,strStreet, Types.VARCHAR);
                    
                    if( prov1Idnt != null )
                        pquery.setInt(12,nProv1Idnt);
                    else
                        pquery.setNull(12,java.sql.Types.INTEGER );
                    pquery.setObject(13,nProv1Pers,Types.NUMERIC,2);
                    
                    if( prov2Idnt != null )
                        pquery.setInt(14,nProv2Idnt);
                    else
                        pquery.setNull(14,java.sql.Types.INTEGER );
                    pquery.setObject(15,nProv2Pers,Types.NUMERIC,2);
                    
                    pquery.setObject(16,strPrivatePhone, Types.VARCHAR);
                    pquery.setObject(17,strWorkPhone, Types.VARCHAR);
                    pquery.setObject(18,strMobilePhone, Types.VARCHAR);
                    pquery.setObject(19,strFax, Types.VARCHAR);
                    pquery.setObject(20,strEmail, Types.VARCHAR);
                    pquery.setTimestamp(21,tmspCurrentDate); // when editing this is modif. date
                    pquery.setInt(22,nUserID);               // but when adding - creation date
                    if(bProv1Appr)
                        pquery.setString(23,"Y");
                    else
                        pquery.setString(23,"N");
                    if(bProv2Appr)
                        pquery.setString(24,"Y");
                    else
                        pquery.setString(24,"N");
                    pquery.setObject(25,strCLCode);
                    pquery.setString(26,strVATFree);
                    pquery.setString(27,altName);
                    pquery.setString(28,birthDate);
                    pquery.setInt(29,nPersonID);
                    
                    pquery.executeUpdate();
                    pquery.close();
                    JOptionPane.showMessageDialog(null,"Client has been edited successfully!");
                    dispose();
                }
                
                
            }catch(Exception e){
                //SharedUtils.handleError(GENERAL_DB_ERROR);
                JOptionPane.showMessageDialog(this,"Error:" + e.getMessage());
            }
        } else if(evt.getSource() == editProv1UIN){
            
            String strPrsnIdnt = editProv1UIN.getText();
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT PRSN_LNAM + ' , ' +  PRSN_FNAM AS NAME " +
                    " ,PRV1_COMM,PRV2_IDNT,PRV2_COMM  FROM BASE_PRSN " +
                    " WHERE PRSN_KEY = " + strPrsnIdnt;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(rsDBData.next()){
                    String strName = rsDBData.getString(1);
                    //not his prov needed but the person himselft
                    //String strProv1Idnt = rsDBData.getString(2);
                    String strProv1Comm = rsDBData.getString(2);
                    String strProv2Idnt = rsDBData.getString(3);
                    String strProv2Comm = rsDBData.getString(4);
                    rsDBData.close();
                    stm.close();
                    
                    vecProvSearchResults.removeAllElements();
                    vecProvSearchResults.addElement(strPrsnIdnt);
                    vecProvSearchResults.addElement("");
                    vecProvSearchResults.addElement(strProv2Idnt);
                    this.nProv1Idnt = Integer.parseInt(strPrsnIdnt);
                    this.nProv2Idnt = Integer.parseInt(strProv2Idnt);
                    
                    connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                    strSQL = " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                            " FROM base_prsn " +
                            " WHERE prsn_key = " + strProv2Idnt;
                    stm = connDB.createStatement();
                    rsDBData=stm.executeQuery(strSQL);
                    boolean bMore = rsDBData.next();
                    if(bMore){
                        String strProv2Name = rsDBData.getString(1);
                        editProv2UIN.setText(strProv2Idnt);
                        editProv2Name.setText(strProv2Name);
                        editProv2Pers.setText(strProv2Comm);
                    }
                    rsDBData.close();
                    stm.close();
                    //editProv1UIN.setText(strUIN);
                    editProv1Name.setText(strName);
                    editProv1Pers.setText(strProv1Comm);
                } else{
                    JOptionPane.showMessageDialog(null,"There is no person with that UIN!");
                    if(vecProvSearchResults== null || vecProvSearchResults.size()<1){
                        editProv1UIN.setText("");
                        return;
                    }
                    editProv1UIN.setText((String)vecProvSearchResults.get(0));
                }
            }catch(SQLException sqle){
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            }
        } else if(evt.getSource() == editProv2UIN){
            
            String strPrsnIdnt = editProv2UIN.getText();
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT PRSN_LNAM + ' , ' +  PRSN_FNAM AS NAME " +
                    " ,PRV2_COMM  FROM BASE_PRSN " +
                    " WHERE PRSN_KEY = " + strPrsnIdnt;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(rsDBData.next()){
                    String strName = rsDBData.getString(1);
                    String strProv2Comm = rsDBData.getString(2);
                    rsDBData.close();
                    stm.close();
                    if(vecProvSearchResults == null || vecProvSearchResults.size() <1){
                        JOptionPane.showMessageDialog(null,"Please select a doctor first!");
                        editProv2UIN.setText("");
                        return;
                    }
                    vecProvSearchResults.setElementAt(strPrsnIdnt, 2);
                    this.nProv2Idnt = Integer.parseInt(strPrsnIdnt);
                    //vecProvSearchResults.addElement(strProv2Idnt);
                    editProv2UIN.setText(strPrsnIdnt);
                    editProv2Name.setText(strName);
                    editProv2Pers.setText(strProv2Comm);
                } else{
                    JOptionPane.showMessageDialog(null,"There is no person with that UIN!");
                    if(vecProvSearchResults== null || vecProvSearchResults.size()<1){
                        editProv2UIN.setText("");
                        return;
                    }
                    editProv2UIN.setText((String)vecProvSearchResults.get(2));
                }
            }catch(SQLException sqle){
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            }
        } else if( evt.getSource() == editProv3UIN ) {
            String strPrsnIdnt = editProv3UIN.getText();
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT PRSN_LNAM + ' , ' +  PRSN_FNAM AS NAME " +
                    " ,PRV3_COMM  FROM BASE_PRSN " +
                    " WHERE PRSN_KEY = " + strPrsnIdnt;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(rsDBData.next()){
                    String strName = rsDBData.getString(1);
                    String strProv3Comm = rsDBData.getString(2);
                    rsDBData.close();
                    stm.close();
                    editProv3UIN.setText(strPrsnIdnt);
                    editProv3Name.setText(strName);
                    editProv3Pers.setText(strProv3Comm);
                    m_strProv3Id = strPrsnIdnt;
                } else{
                    JOptionPane.showMessageDialog(null,"There is no person with that UIN!");
                    editProv3UIN.setText( m_strProv3Id );
                }
            }catch(SQLException sqle){
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            }
        } else if( evt.getSource() == btnCancel ){
            dispose();
        }
    }//GEN-LAST:event_actionPerformed
    
    public void valueChanged(ListSelectionEvent e) {
        
        if(e.getSource()==tblProvs.getSelectionModel()) {
        }
    }
    
    private void afterInitComponents(){
        try {
            dateVerifier = new UniversalInputVerifier(UniversalInputVerifier.UNI_DATE_VERIFIER,new Vector());
            editBirthDate.setInputVerifier(dateVerifier);
            
            if(nMode == ADD_MODE)
                btnAdd.setText("Add");
            else
                btnAdd.setText("Save");
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString, true);
            String strSQL = "SELECT TYPE_ABBR, TYPE_KEY  FROM BASE_PRSN_TYPE ORDER BY TYPE_ABBR";
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbClients = new ComboDataModel(rsDBData);
            comboPersonType.setModel(cdbClients);
            comboPersonType.setSelectedIndex(0);
            comboPersonType.setSelectedIndex(1);
            //comboPersonType.setSelectedIndex(1);
            comboPersonType.updateUI();
            rsDBData.close();
            stm.close();
            
            strSQL = "SELECT CNTR_NAME, CNTR_KEY FROM BASE_CNTR ORDER BY CNTR_NAME";
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbCountries = new ComboDataModel(rsDBData);            
            comboCountry.setModel(cdbCountries);
            cdbCountries.selectIndexByKey(15);
                       
            enableExit( comboCountry );
            enableExit( comboPersonType );
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        String strSQL = "SELECT COMM_PRV1,COMM_PRV2,COMM_KEY FROM BASE_COMM";
        String[] str_rgn_columnNames ={"Prov.1","Prov.2"};
        SharedUtils.setTableDBModel(tblProvs, strSQL, str_rgn_columnNames);
        tblProvs.getTableHeader().setReorderingAllowed(false);
        tblProvs.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblProvs.getSelectionModel().addListSelectionListener(this);
        tblProvs.setVisible(false);
        scrProvs.setVisible(false);
        
        Vector vecParams = new Vector(2);
        vecParams.addElement(new Integer(1));
        vecParams.addElement(new Integer(50));
        uivFirstName = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        editFirstName.setInputVerifier(uivFirstName);
        uivCity = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        editCity.setInputVerifier(uivCity);
        
        vecParams = new Vector(2);
        vecParams.addElement(new Integer(0));
        vecParams.addElement(new Integer(60));
        uivSurname = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        editSurname.setInputVerifier(uivSurname);
        
        vecParams = new Vector(2);
        vecParams.addElement(new Integer(0));
        vecParams.addElement(new Integer(80));
        uivStreet = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        editStreet.setInputVerifier(uivStreet);
        
        vecParams = new Vector(2);
        vecParams.addElement(new Integer(0));
        vecParams.addElement(new Integer(20));
        uivCode = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        editCode.setInputVerifier(uivCode);
        
        uivDiscount = new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,vecParams);
        editDiscount.setInputVerifier(uivDiscount);
        editDiscount.setText("0");
        
        uivProv3Pers = new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,vecParams);
        editProv3Pers.setInputVerifier(uivProv3Pers);
        editProv3Pers.setText("5");
        
        editProv1Pers.setInputVerifier( new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,new Vector()) );
        editProv2Pers.setInputVerifier( new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,new Vector()) );
        
        comboAppeal.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Frau", "Herr", "Frau Dr.", "Herr Dr.", "Mevrouw", "Meneer", "Mister", "Misses", "" }));
    }
    
    private void loadClientInfo(int nPersonID){
        String strUIN = String.valueOf(nPersonID);
        
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT base_prsn.prsn_lnam, base_prsn.prsn_fnam, base_prsn.prsn_appl," +
                    " base_prsn_type.type_abbr, base_prsn.prsn_dscn, base_prsn.prsn_info, " +
                    " base_prsn.alow_prch, base_cntr.cntr_name, base_prsn.prsn_city, " +
                    " base_prsn.city_code, base_prsn.prsn_strt, base_prsn.prv1_idnt, " +
                    " base_prsn.prv1_comm, base_prsn.prv2_idnt, base_prsn.prv2_comm, " +
                    " base_cntr.cntr_vat, base_prsn.prv1_good, base_prsn.prv2_good, " +
                    " base_prsn.priv_phon, base_prsn.work_phon, base_prsn.mobi_phon," +
                    " base_prsn.prsn_fax, base_prsn.prsn_eml, base_prsn.CLCode ,"+
                    " base_prsn.vatfree,base_prsn.altr_name, base_prsn.prv3_idnt, " +
                    " base_prsn.prv3_comm, " +
                    " CONVERT(CHAR(8),base_prsn.birthDate,4) as birthDate "+
                    " FROM base_prsn INNER JOIN " +
                    " base_prsn_type ON base_prsn.type_idnt = base_prsn_type.type_key INNER JOIN " +
                    " base_cntr ON base_prsn.cntr_idnt = base_cntr.cntr_key" +
                    " WHERE base_prsn.prsn_key = " + strUIN;
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            if(!bMore){
                JOptionPane.showMessageDialog(null,"Error while loading client information.Client Data Corrupted!");
                return;
            }
            
            
            String strSurname = rsDBData.getString(1);
            String strFirstName = rsDBData.getString(2);
            String strAppeal = rsDBData.getString(3);
            String strType = rsDBData.getString(4);
            String strDiscount = rsDBData.getString(5);
            String strPrsnInfo = rsDBData.getString(6);
            String strCanPurchase = rsDBData.getString(7);
            String strCountry = rsDBData.getString(8);
            String strCity = rsDBData.getString(9);
            String strCode = rsDBData.getString(10);
            String strStreet = rsDBData.getString(11);
            
            String strProv1Idnt = rsDBData.getString(12);
            String strProv1Comm = rsDBData.getString(13);
            strProv1Comm = BigDec.scaledRoundHalfUp(strProv1Comm,2);
            
            String strProv2Idnt = rsDBData.getString(14);
            String strProv2Comm = rsDBData.getString(15);
            strProv2Comm = BigDec.scaledRoundHalfUp(strProv2Comm,2);
            
            String strVat = rsDBData.getString(16);
            String strPrv1Good = rsDBData.getString(17);
            String strPrv2Good = rsDBData.getString(18);
            String strPrivatePhone = rsDBData.getString(19);
            String strWorkPhone = rsDBData.getString(20);
            String strMobiPhone = rsDBData.getString(21);
            String strFax = rsDBData.getString(22);
            String strEmail = rsDBData.getString(23);
            String strCLCode = rsDBData.getString(24);
            String strVATFree = rsDBData.getString(25);
            String altName =  rsDBData.getString(26);
            String strProv3Idnt = m_strProv3Id = rsDBData.getString(27);
            
            String birthDate = rsDBData.getString("birthDate");
            
            editBirthDate.setText(birthDate);
            
            if( m_strProv3Id == null )
                m_strProv3Id = "";
            String strProv3Comm = rsDBData.getString(28);
            strProv3Comm = BigDec.scaledRoundHalfUp(strProv3Comm,2);
            rsDBData.close();
            stm.close();
            
            this.nProv1Idnt = strProv1Idnt != null ? Integer.parseInt(strProv1Idnt) : -1;
            this.nProv2Idnt = strProv2Idnt != null ? Integer.parseInt(strProv2Idnt) : -1;
            vecProvSearchResults.addElement(strProv1Idnt);
            vecProvSearchResults.addElement("");
            vecProvSearchResults.addElement(strProv2Idnt);
            boolean bPrv1Good,bPrv2Good;
            if(strPrv1Good.equals("Y"))
                bPrv1Good = true;
            else
                bPrv1Good = false;
            if(strPrv2Good.equals("Y"))
                bPrv2Good = true;
            else
                bPrv2Good = false;
            
            
            SharedUtils.setComboIndexByContent(comboAppeal, strAppeal);
            //((ComboDataModel)comboAppeal.getModel()).selectIndexByContent(strAppeal);
            editFirstName.setText(strFirstName);
            editSurname.setText(strSurname);
            ((ComboDataModel)comboPersonType.getModel()).selectIndexByContent(strType);
            strDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
            editDiscount.setText(strDiscount);
            editCLCode.setText(strCLCode);
            //tblSums.getModel().setValueAt(strDiscount, DISCOUNT_INDEX, VALUE_COL_INDEX);
            //tblSums.getModel().setValueAt(strVat, VAT_INDEX, VALUE_COL_INDEX);
            ((ComboDataModel)comboCountry.getModel()).selectIndexByContent(strCountry);
            editCity.setText(strCity);
            editCode.setText(strCode);
            editStreet.setText(strStreet);
            editUIN.setText(strUIN);
            edpAddInfo.setText(strPrsnInfo);
            editAlternateName.setText( altName );
            if(strCanPurchase.equals("Y"))
                chkbCanPurchase.setSelected(true);
            else
                chkbCanPurchase.setSelected(false);
            
            if( "Y".equals(strVATFree) )
                chkbVATFree.setSelected(true);
            else
                chkbVATFree.setSelected(false);
            
            chkbProv1Appr.setSelected(bPrv1Good);
            chkbProv2Appr.setSelected(bPrv2Good);
            
            editPrivatePhone.setText(strPrivatePhone);
            editWorkPhone.setText(strWorkPhone);
            editMobilePhone.setText(strMobiPhone);
            editFax.setText(strFax);
            editEmail.setText(strEmail);
            
            strSQL = " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                    " FROM base_prsn " +
                    " WHERE prsn_key = " + strProv1Idnt;
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            bMore = rsDBData.next();
            if(bMore){
                String strProv1Name = rsDBData.getString(1);
                editProv1UIN.setText(strProv1Idnt);
                editProv1Name.setText(strProv1Name);
                editProv1Pers.setText(strProv1Comm);
            }
            rsDBData.close();
            stm.close();
            
            strSQL = " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                    " FROM base_prsn " +
                    " WHERE prsn_key = " + strProv2Idnt;
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            bMore = rsDBData.next();
            if(bMore){
                String strProv2Name = rsDBData.getString(1);
                editProv2UIN.setText(strProv2Idnt);
                editProv2Name.setText(strProv2Name);
                editProv2Pers.setText(strProv2Comm);
            }
            rsDBData.close();
            stm.close();
            
            //ait
            if( strProv3Idnt != null ) {
                String name3 = SharedUtils.executeSqlScalar(
                        " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                        " FROM base_prsn " +
                        " WHERE prsn_key = " + strProv3Idnt );
                editProv3UIN.setText(strProv3Idnt);
                editProv3Name.setText(name3);
                editProv3Pers.setText(strProv3Comm);
            }
        }catch(SQLException sqle){
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
    }
    
    private void loadProv3FromProv2( String prov2Id, Connection conn )
    throws SQLException {
        String sql = " SELECT base_prsn.prv3_idnt,  base_prsn.prv3_comm " +
                " FROM base_prsn " +
                " WHERE prsn_key = " + prov2Id;
        Statement stm = conn.createStatement();
        ResultSet rs = stm.executeQuery(sql);
        if( rs.next() ) {
            String prov3Id = m_strProv3Id = rs.getString(1);
            int prov3Comm = rs.getInt(2);
            if( prov3Id != null ) {
                String name3 = SharedUtils.executeSqlScalar(
                        " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                        " FROM base_prsn " +
                        " WHERE prsn_key = " + prov3Id );
                
                editProv3UIN.setText(prov3Id);
                editProv3Name.setText(name3);
                editProv3Pers.setText( "" + prov3Comm);
            } else {
                editProv3UIN.setText("");
                editProv3Name.setText("");
                editProv3Pers.setText( "5" );
                m_strProv3Id = "";
            }
        }
        rs.close();
        stm.close();
    }
    public boolean checkClientExist(String fname, String lname,String city, int country){
        try{
            String sql = "" +
                    " select prsn_key, prsn_fnam, prsn_lnam, cntr_name, prsn_city " +
                    " from base_prsn inner join base_cntr on (cntr_idnt = cntr_key) " +
                    " where " +
                    "         prsn_fnam like '%" + fname.trim() + "%' and " +
                    "         prsn_lnam like '%"  + lname.trim() + "%' and " +
                    "         cntr_idnt="       + country      + "  and " +
                    "         prsn_city like '%" + city.trim()  + "%'     ";
            //System.out.println(sql);
            Connection conn = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            PreparedStatement pstmt = conn.prepareStatement(sql);
            ResultSet rs = pstmt.executeQuery();
            String show = "Similar person has already registered in the system!\n" +
                    "-----------------------------------------------\n";
            int count = 0;
            if(rs!=null){
                while(rs.next()){
                    count++;
                    String key = rs.getString("prsn_key");
                    key = "UID : " + (rs.wasNull() ? "" : key);
                    
                    String prsn_fnam = rs.getString("prsn_fnam");
                    prsn_fnam = "Name : " +(rs.wasNull() ? "" : prsn_fnam + ", ");
                    
                    String prsn_lnam = rs.getString("prsn_lnam");
                    prsn_lnam = rs.wasNull() ? "" : prsn_lnam;
                    
                    String prsn_city = rs.getString("prsn_city");
                    prsn_city = "City : " + (rs.wasNull() ? "" : prsn_city);
                    
                    String cntr_name = rs.getString("cntr_name");
                    cntr_name = "Country : " + (rs.wasNull() ? "" : cntr_name);
                    
                    show+=  key+"\n" +
                            prsn_fnam + prsn_lnam +"\n" +
                            cntr_name+"\n" +
                            prsn_city + "\n" +
                            "-----------------------------------------------\n";
                }
            }
            if(count>0){
                
                Object[] opt = {"It's OK", "Cancel"};
                
                
                int res = JOptionPane.showOptionDialog(this,show,"Confirm dialog", JOptionPane.YES_NO_OPTION,
                        JOptionPane.WARNING_MESSAGE,   null, opt,  opt[0]);
                
                if(res == JOptionPane.YES_OPTION){
                    return true;
                } else{
                    return false;
                }
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return true;
    }
    public void translate(){
        Main.def_app_lang.loadLabelsFromPanel(jpanGenInfo);
        Main.def_app_lang.loadLabelsFromPanel(jpanProv);
        Main.def_app_lang.loadLabelsFromPanel(this.getContentPane());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnSelectProv1;
    private javax.swing.JButton btnSelectProv2;
    private javax.swing.JButton btnSelectProv3;
    private javax.swing.JButton btnShowPercents;
    private javax.swing.JCheckBox chkbCanPurchase;
    private javax.swing.JCheckBox chkbProv1Appr;
    private javax.swing.JCheckBox chkbProv2Appr;
    private javax.swing.JCheckBox chkbVATFree;
    private javax.swing.JComboBox comboAppeal;
    private javax.swing.JComboBox comboCountry;
    private javax.swing.JComboBox comboPersonType;
    private javax.swing.JTextField editAlternateName;
    private javax.swing.JTextField editBirthDate;
    private javax.swing.JTextField editCLCode;
    private javax.swing.JTextField editCity;
    private javax.swing.JTextField editCode;
    private javax.swing.JTextField editDiscount;
    private javax.swing.JTextField editEmail;
    private javax.swing.JTextField editFax;
    private javax.swing.JTextField editFirstName;
    private javax.swing.JTextField editMobilePhone;
    private javax.swing.JTextField editPrivatePhone;
    private javax.swing.JTextField editProv1Name;
    private javax.swing.JTextField editProv1Pers;
    private javax.swing.JTextField editProv1UIN;
    private javax.swing.JTextField editProv2Name;
    private javax.swing.JTextField editProv2Pers;
    private javax.swing.JTextField editProv2UIN;
    private javax.swing.JTextField editProv3Name;
    private javax.swing.JTextField editProv3Pers;
    private javax.swing.JTextField editProv3UIN;
    private javax.swing.JTextField editStreet;
    private javax.swing.JTextField editSurname;
    private javax.swing.JTextField editUIN;
    private javax.swing.JTextField editWorkPhone;
    private javax.swing.JEditorPane edpAddInfo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JPanel jpanGenInfo;
    private javax.swing.JPanel jpanProv;
    private javax.swing.JLabel lblPers3;
    private javax.swing.JLabel lblProv1;
    private javax.swing.JLabel lblProv2;
    private javax.swing.JScrollPane scrProvs;
    private javax.swing.JTable tblProvs;
    // End of variables declaration//GEN-END:variables
    
}
