/*
 * CutomTableModel.java
 *
 * Created on , 2005,  8, 20:26
 */

package medstore;

import javax.swing.table.*;
import javax.swing.*;
import java.awt.*;
import java.util.Vector;
public class CustomTableModel extends AbstractTableModel implements TableModel {
    String[] columnNames;

    public  Vector data;
    public CustomTableModel(String[] columnNames)
    {    
        data = new Vector();
        int  nColumnCount = columnNames.length;
        this.columnNames = new String[nColumnCount];                                
        for(int i=0; i<nColumnCount ;i++){   
                this.columnNames[i] = columnNames[i];        
        }
    }
        
    public Vector getData()
    {
            return data;
    }
    public void clearData()
    {
            data.removeAllElements();
    }
    public int getColumnCount() {       
        if(columnNames!=null)
              return columnNames.length; 
        return 0;      
        
    }
    public int getRowCount() {
        if(data!=null)
                return data.size();
        return 0;        
    }
    public synchronized String getObjName(int row)
    {        
        return null;          
    }
    public String getColumnName(int col) {
        if(columnNames!=null)
                return columnNames[col];
        return null;        
               
    }

    public Object getValueAt(int row, int col) {
        if(data!=null)
        {
              return  ((CustomTableRow)data.elementAt(row)).getRowElement(col);
        }
        return null;
    }

    public Class getColumnClass(int c) {
        if(data!=null)
                return getValueAt(0, c).getClass();
        return null;        
    }

    public boolean isCellEditable(int row, int col) {
        return false;
    }

    public void setValueAt(Object value, int row, int col) {
  
        if ( data != null && row >= 0 && row < data.size())
        {
          ((CustomTableRow)data.elementAt(row)).setRowElement(value,col);
        }
        fireTableCellUpdated(row, col);
      }
   public void removeItemAt(int index)
   {
          data.removeElementAt(index);
          
   }
   public void insertItem(Object value){
          data.insertElementAt(value,0);
  }  
}





