/*
 * DBSettingsMSSQL.java
 *
 * Created on , 2005,  16, 9:58
 */

package medstore;
import java.sql.*;
import java.util.*;


/**
 *
 * @author ait
 */
public class DBSettingsMSSQL implements DBSettings
{
    
    public DBSettingsMSSQL() 
    {
    }
    
    public String getSqlSelectPersonNamesById(String id)
    {
        return " SELECT TOP 1000 base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                     " FROM base_prsn " +
                     " WHERE prsn_key = " + id;        
    }
    
    public String getSqlSearchPersons()
    {
        return "SELECT  TOP 1000 PRSN_KEY, PRSN_LNAM + ' , ' + PRSN_FNAM  AS NAME " +
                ", TYPE_ABBR, CNTR_NAME " +
                ",  PRSN_CITY + ' , ' + PRSN_STRT,PRV1_IDNT,PRV1_COMM,PRV2_IDNT,PRV2_COMM, prv1_good, prv2_good  FROM BASE_PRSN " +
                " INNER JOIN BASE_CNTR ON ( BASE_PRSN.CNTR_IDNT = BASE_CNTR.CNTR_KEY) " +
                " INNER JOIN BASE_PRSN_TYPE ON ( BASE_PRSN.TYPE_IDNT = BASE_PRSN_TYPE.TYPE_KEY )";
    }
    
    public Connection getConnection()
    {
        java.sql.Connection  con = null;
        String url = "jdbc:microsoft:sqlserver://";
        String fullUrl = url + SharedUtils.databaseUrl + ":" + SharedUtils.databaseUrlPort + 
                 ";databaseName=" + SharedUtils.databaseName + ";";
         try
         {
             Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
             Properties props = new Properties();
             props.setProperty("user", SharedUtils.dbUserName );
             props.setProperty("password", SharedUtils.dbPassword );
             props.setProperty("charSet", "ISO-8859-1" );
             props.setProperty("useUnicode", "true");
             props.setProperty("SendStringParametersAsUnicode", "true");   
             con = java.sql.DriverManager.getConnection(fullUrl,props);             
         }
         catch(Exception e)
         {
             e.printStackTrace();               
         }
         return con;
    }
}

