/*
 * DBSettingsPostgre.java
 *
 * Created on , 2005,  16, 10:07
 */

package medstore;
import java.sql.*;
import java.util.*;

/**
 *
 * @author ait
 */
public class DBSettingsPostgre implements DBSettings{
    
    /** Creates a new instance of DBSettingsPostgre */
    public DBSettingsPostgre() {
    }
    public String getSqlSelectPersonNamesById(String id)
    {
        return " SELECT base_prsn.prsn_lnam || ' , ' || base_prsn.prsn_fnam as name " +
                     " FROM base_prsn " +
                     " WHERE prsn_key = " + id;        
    }
    
    public String getSqlSearchPersons()
    {
        return "SELECT PRSN_KEY, PRSN_LNAM || ' , ' || PRSN_FNAM  AS NAME " +
                ", TYPE_ABBR, CNTR_NAME " +
                ",  PRSN_CITY || ' , ' || PRSN_STRT,PRV1_IDNT,PRV1_COMM,PRV2_IDNT,PRV2_COMM  FROM BASE_PRSN " +
                " INNER JOIN BASE_CNTR ON ( BASE_PRSN.CNTR_IDNT = BASE_CNTR.CNTR_KEY) " +
                " INNER JOIN BASE_PRSN_TYPE ON ( BASE_PRSN.TYPE_IDNT = BASE_PRSN_TYPE.TYPE_KEY )";
    }  
    
    public Connection getConnection()        
    {
         Connection  con = null;
         String url = "jdbc:postgresql:" + SharedUtils.databaseName;
         try
         {
             Class.forName("org.postgresql.Driver");
             Properties props = new Properties();
             props.setProperty("user", "medstore" );
             props.setProperty("password", "medstore" );
             props.setProperty("charSet", "ISO-8859-1" );
             props.setProperty("useUnicode", "true");
             props.setProperty("SendStringParametersAsUnicode", "true"); 
             con = java.sql.DriverManager.getConnection( url, props );
         }
         catch(Exception e)
         {
             e.printStackTrace();               
         }
         return con;        
    }
}
