/*
 * UIUtils.java
 *
 * Created on , 2005,  27, 20:40
 */

package medstore;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author ait
 */
public class UIUtils {
    
    /** Creates a new instance of UIUtils */
    public UIUtils() {
    }
    
    public static void setTableFonts( JTable table  )
    {
        table.setFont(new java.awt.Font("Tahoma", 1, 13));
        table.getTableHeader().setFont(new java.awt.Font("Tahoma", 1, 13));
        //table.setFont(new java.awt.Font("Times New Roman", 1, 13));
        //table.getTableHeader().setFont(new java.awt.Font("Times New Roman", 1, 13));
    }
    
    public static void setColumnWidth( JTable table, int columnIndex, int preferredWidth )
    {
        TableColumn col = table.getColumnModel().getColumn(columnIndex);
        col.setPreferredWidth(preferredWidth);        
    }  
    
    public static void setHorizontalAlignment( JTable table, int columnIndex, int align )
    {
        DefaultTableCellRenderer tcrColumn = new DefaultTableCellRenderer();
        tcrColumn.setHorizontalAlignment(align);
        table.getColumnModel().getColumn(columnIndex).setCellRenderer(tcrColumn);
        
    }
}
