/*
 * UniversalTableCellRenderer.java
 *
 * Created on , 2005,  14, 19:12
 */

package medstore;

import javax.swing.table.*;
import javax.swing.*;
import java.awt.*;

public class UniversalTableCellRenderer extends DefaultTableCellRenderer implements SharedConstants{
    private int aligns[][]={};
    public UniversalTableCellRenderer() {
        //this.isBordered = isBordered;
        //setOpaque(true); //MUST do this for background to show up.
    }

    public Component getTableCellRendererComponent(
                            JTable table, Object value,
                            boolean isSelected, boolean hasFocus,
                            int row, int column)
    {
    
        super.getTableCellRendererComponent(table,value, isSelected, hasFocus, row, column);
        if(column < aligns.length)
            setHorizontalAlignment(aligns[column][1]);
        /*
        for(int i=0; i < this.aligns.length; i++){
            if(column == i){
                setHorizontalAlignment(aligns[i][1]);
                //return;
            }
        }
         */
        //setHorizontalAlignment(JLabel.RIGHT);
        return  this;
    }
    
    public void setAlignment(int aligns[][]){
        this.aligns = aligns;
    }
}

