package medstore.print.invoice;

public class Customer
{
  private String firstName;
  private String lastName;
  private String street;
  private String streetNo;
  private String postalCode;
  private String town;
  private String country;
  private String salutation;
  private String altAddress;
  private String altAddressCaption;
  private String macro;
  private String invAltName;
  private String packmacro;
  
  public Customer (final String firstName, final String lastName,
                   final String salutation, final String street, 
                   final String postalCode, final String town,
                   final String country, final String altAddressCaption, 
          final String altAddress, final String macro, final String invAltName, final String packmacro)
  {
    this.firstName = firstName;
    this.lastName = lastName;
    this.salutation = salutation;
    this.street = street;
    this.postalCode = postalCode;
    this.town = town;
    this.country = country;
    this.altAddress = altAddress;
    this.altAddressCaption = altAddressCaption;
    this.macro = macro;
    this.invAltName = invAltName;
    this.packmacro = packmacro;
  }

  public String getCountry ()
  {
    return country;
  }

  public String getFirstName ()
  {
    return firstName;
  }

  public String getLastName ()
  {
    return lastName;
  }

  public String getPostalCode ()
  {
    return postalCode;
  }

  public String getStreet ()
  {
    return street;
  }
  public String getAltAddressCaption(){      
      return (altAddress==null || "null".equals(altAddress) || altAddress.length()<=0) ? "" : altAddressCaption;
  }
  public String getAltAddress(){ 
      //System.out.println(altAddress);
      return (altAddress==null || "null".equals(altAddress) || altAddress.length()<=0) ? "" : altAddress;
  }
  
  public String getTown ()
  {
    return town;
  }

  public String getSalutation ()
  {
    return salutation;
  }
  public String getMacro ()
  {
    return macro;
  }
  public String getInvAltName(){
      return invAltName;
  }
  public String getPackMacro(){
      return packmacro;
  }
}
