package medstore.print.reports.commissions.personcommperoffer;

public class PCPOData {
    
    private String prsn_key;
    private String name; 
    private String usertype;     
    private String date;
    private String ordno;
    private String netto;
    private String percent;
    private String sum;
    private String prsn_key_rel;
    private String prsn_name_rel;
    private String invc_addr;
    
    public PCPOData(final String prsn_key, final String name, final String usertype, final String date, final String ordno,
            final String netto, final String percent, final String sum, String prsn_key_rel, String prsn_name_rel, String invc_addr) {
        this.prsn_key = prsn_key;
        this.name = name;
        this.usertype = usertype;        
        this.date = date;
        this.ordno = ordno;
        this.netto = netto;
        this.percent = percent;
        this.sum = sum;
        this.prsn_key_rel = prsn_key_rel;
        this.prsn_name_rel = prsn_name_rel;
        this.invc_addr = invc_addr;
    }
    
    public String getKey(){
        return prsn_key;
    }
    public String getName(){
        return name;
    }
    public String getType(){
        return usertype;
    }
    public String getDate(){
        return date;
    }
    public String getOrderNo(){
        return ordno;
    }    
    public Double getNetto(){
        return new Double(netto);
    }
    public Double getPercent(){
        return new Double(percent);
    }
    public Double getSum(){
        return new Double(sum);
    }
    public String getRelKey(){
        return prsn_key_rel;
    }
    public String getRelName(){
        return prsn_name_rel;
    }
    public String getInvcAddr(){
        return invc_addr;
    }
}
