package medstore.print.reports.inventory.movmentrevision;

import java.net.URL;
import javax.swing.JComponent;
import org.jfree.report.JFreeReport;
import org.jfree.report.demo.helper.AbstractXmlDemoHandler;
import org.jfree.report.demo.helper.ReportDefinitionException;
import org.jfree.util.ObjectUtilities;

public class MRevPrintUtils extends AbstractXmlDemoHandler{
    
    private static MRevTableModel data;
    private String printTemplate;
    private String name;
    public MRevPrintUtils(MRevTableModel data, String printTemplate,String name) {
        this.data = data;
        this.printTemplate = printTemplate;
        this.name = name;
    }
    public JFreeReport createReport() throws ReportDefinitionException {
        final JFreeReport report = parseReport();
        report.setName(name);
        report.setData(data);
        return report;
    }
    
    public JComponent getPresentationComponent() {
        return createDefaultTable(data);
    }
    public URL getDemoDescriptionSource() {
        return null;
    }
    public String getDemoName() {
        return name;
    }
    public URL getReportDefinitionSource() {
        return ObjectUtilities.getResourceRelative
                (printTemplate, MRevPrintUtils.class);
    }    
}
