package medstore.print.reports.inventory.stockonhandtotal;

public class SOHTData {
    private String barcode; 
    private String stockname; 
    private String storename; 
    private String stockcount; 
    private String checkout;
    private String diff;
    
    public SOHTData(final String barcode, final String stockname, final String storename, 
            final String stockcount) {
        this(barcode, stockname, storename, stockcount, "", "");    
    }
    public SOHTData(final String barcode, final String stockname, final String storename, 
            final String stockcount, final String checkout, final String diff) {
        this.barcode = barcode;
        this.stockname = stockname;
        this.storename = storename;
        this.stockcount = stockcount;  
        this.checkout = checkout;
        this.diff = diff;
    }
    public String getBarcode(){
        return barcode;
    }
    public String getStoreName(){
        return storename;
    }
    public String getStockName(){
        return stockname;
    }
    
    public String getCount(){
        return stockcount;
    }
    public String getCheckout(){
        return checkout;
    }
    public String getDiffrence(){        
        return diff;
    }
}
