package medstore.print.reports.ordersdetails;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;
import medstore.print.reports.ReportTop;

public class ODTableModel  extends AbstractTableModel{    
    
    private final ArrayList data;

    private int size;
    private static Class[] COLUMN_TYPES =
    {
        
                String.class, String.class, String.class, String.class, 
                String.class, String.class, String.class, String.class, Integer.class, 
                        String.class, String.class, String.class, String.class, String.class
    };
    private static String[] COLUMN_NAMES =
    {
                
                        "report.date","report.query","report.interval","report.producer",
                        "col.date","col.ordnum", "col.barcode", "col.name", "Integer", 
                                "Double", "col.total","invoice.totalSum", "ordcount", "prodcount"
    };
    public ODTableModel(final ArrayList data) {
       this.data = data;
       this.size = data.size();       
    }

  public int getRowCount ()
  {
    return size;
  }


  public int getColumnCount ()
  {
    return COLUMN_NAMES.length;
  }

  public Class getColumnClass (final int column)
  {
    return COLUMN_TYPES[column];
  }
  
  public String getColumnName (final int column)
  {
     return COLUMN_NAMES[column];
  }

  public Object getValueAt (final int row, final int column)
  {      
    return ((ArrayList)(data.get(row))).get(column);
  }

}
