/*
 * ProcedureUndoTranStore.java
 *
 * Created on , 2005,  11, 0:34
 */

package medstore.procedures;

import java.sql.*;
import medstore.*;
import java.util.*;

/**
 *
 * @author ait
 */
public class ProcedureUndoTranStore {
    public String m_newTranId;    
    /** Creates a new instance of ProcedureUndoTranStore */
    public ProcedureUndoTranStore() 
    {
    }
    
    public void execUndoTranStore(Connection conn, String date, int userId, 
            String tranDesc, int undoTranId , int sequence)
        throws Exception
    {
        String sql = "SELECT BASE_EVNT.EVNT_KEY, CONN_EVNT_TRNS.OPER_IDNT " +
                " FROM BASE_EVNT INNER JOIN CONN_EVNT_TRNS " + 
                " ON BASE_EVNT.EVNT_KEY=CONN_EVNT_TRNS.EVNT_IDNT " + 
                " WHERE CONN_EVNT_TRNS.TRNS_IDNT=" + undoTranId;
        Statement stm = conn.createStatement();
        ResultSet rs = stm.executeQuery(sql);
        ArrayList evntKeys = new ArrayList();
        ArrayList ops = new ArrayList();
        while( rs.next() )
        {
            evntKeys.add( rs.getString(1) );
            ops.add( rs.getString(2) );
        }
        rs.close();
        stm.close();            
        if( evntKeys.size() == 0 )
            throw new MedstoreException("NO EVENTS FOR THIS TRAN");

        //
        sql = "INSERT INTO BASE_EVNT_TRNS (trns_descr) VALUES( " + tranDesc + ")";
        stm = conn.createStatement();
        stm.executeUpdate(sql);
        stm.close();
        m_newTranId = SharedUtils.getLastInsertedID( conn );
        for( int i = 0; i < evntKeys.size(); i++ )
        {
            String evntKey = (String)evntKeys.get(i);
            String opCode = (String)ops.get(i);

            ProcedureUndoStore proc = new ProcedureUndoStore();
            proc.execUndoStoreOperation( conn, date, Integer.parseInt(evntKey), userId );

            sql = "INSERT INTO CONN_EVNT_TRNS (evnt_idnt,trns_idnt,oper_idnt,sqns_nmbr) VALUES(" +
                    proc.m_insertedEventId + "," + m_newTranId + 
                    " , '" + opCode + "' , " + (sequence + i) + ")";
            stm = conn.createStatement();
            if( stm.executeUpdate(sql) <= 0 )
                throw new MedstoreException("");
            stm.close();
        }        
    }    
}
