package medstore.products;
import java.util.Calendar;
import java.util.Date;
import medstore.SharedUtils;

public class Quotes {
    
    private String uid;
    private String pid;
    private String remain;
    private String ordered;
    private Date date;
    private String datefrom;
    private String dateto;
    
    public Quotes(String uid, String pid) {
        this.uid = uid;
        this.pid = pid;
        date = new Date();
        Calendar cal = Calendar.getInstance();
        cal.set( Calendar.DAY_OF_MONTH, cal.getMinimum(Calendar.DAY_OF_MONTH) );
        datefrom = (cal.get(Calendar.MONTH) + 1) + "-" + cal.get(Calendar.DAY_OF_MONTH) + "-" + cal.get(Calendar.YEAR);
        datefrom+= " 00:00:00";
        cal.set( Calendar.DAY_OF_MONTH, cal.getMaximum(Calendar.DAY_OF_MONTH) );
        dateto = (cal.get(Calendar.MONTH) + 1) + "-" + cal.get(Calendar.DAY_OF_MONTH) + "-" + cal.get(Calendar.YEAR);
        dateto+= " 23:59:59";
        
    }
    
    public void setQuote(String cnt) throws Exception{
        String sql = " SELECT     " +
                " SUM([position].p_menge) AS ordered " +
                " FROM         " +
                " [position] INNER JOIN" +
                "   vorgang ON [position].v_nr = vorgang.v_nr " +
                " INNER JOIN   base_stck ON [position].nstk_idnt = base_stck.stck_key " +
                " WHERE" +
                "   nstk_idnt = " + pid + " and " +
                "   vorgang.patn_idnt = " + uid + " and " +
                "   quote > 0 and " +                
                "   (vorgang.v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE      doc_type_idnt = 2)) and " +
                "   vorgang.doc_type_idnt = 1 and" +
                "   (vorgang.pay_date >= '" + datefrom + "' AND vorgang.pay_date <= '" + dateto + "')" +                
                " GROUP BY " +
                "   [position].nstk_idnt, " +
                "   vorgang.patn_idnt ";
        System.out.println(sql);
        try{
            ordered = SharedUtils.executeSqlScalarList(sql).get(0).toString();
        } catch(Exception e){
            ordered = "0";
        }
        
        String rem_sql = " SELECT quote from base_stck " +
                "   where " +
                "   quote > 0 and " +
                "   stck_key = " + pid;
        try{
            remain = SharedUtils.executeSqlScalarList(rem_sql).get(0).toString();
        } catch(Exception e){
            remain = "0";
        }
        
        int toPay = 0;
        
        int rem = Integer.parseInt(remain) - Integer.parseInt(ordered);
        if(rem<=0){
            remain = cnt; 
        }
        else{
            if((rem - Integer.parseInt(cnt))<0){
                remain = ""+Math.abs(Integer.parseInt(cnt)-rem);
            }
            else{
                remain = "0";
            }
        }
        
            
        System.out.println(remain);
    }
    
    public int getRemain() throws Exception{
        return Integer.parseInt(remain);
    }
    
}
