package medstore.trans;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;





public class GerLangPack implements LangPack{
    
    private int index;
    private TableModel data;
    
    
    public GerLangPack()throws Exception{
        this.data = createTableModel();
    }
    
    
    public String getElementLabel(int index){
        return data.getValueAt(index, 1).toString();
    }
    public String getElementLabel(String name, int col) throws Exception{
        if(name==null || name.equals("null"))
            throw new Exception("Control - '" + name + "' is Not Alowed");
        int rows = data.getRowCount();
        for(int i = 0; i< rows; i++){
            String value = data.getValueAt(i, 0).toString();
            if(value.equals(name.trim()))
                return data.getValueAt(i, col).toString();
        }
        throw new Exception("Control '" + name + "' Not Fount");
    }
    public String getElementLabel(String name) throws Exception{
        return getElementLabel(name,1);
    }
    public String[] getTblHeader(String name) throws Exception{
        int rows = data.getRowCount();
        for(int i = 0; i< rows; i++){
            String value = data.getValueAt(i, 0).toString();
            if(value.equals(name.trim()))
                return (String[])data.getValueAt(i, 1);
        }
        throw new Exception("Table Control '" + name + "' Not Fount");
    }
    
    private TableModel createTableModel() throws Exception{
        final String[] names = new String[]{"name", "label", "label changed"};
        final String[] tblOrderGoodsHeader = {"Art. Nr.","K\u00FCrzel","Bezeichnung","Anzahl","E-Preis","G-Preis"};
        final String[] tblOrdersHeader = {"Rechnungs Nr.","Datum","Art","Netto","Endsumme","Bezahlt"};
        final String[] tblClSearchPersonsHeader = {"Kundenummer","Name","Typ","Land","Adresse"};
        final String[] tblStockSelStocksHeader = {"Produktbezeichnis","K\u00FCrzel"};
        
        final Object[][] data = new Object[][]{
            { menu_file, "Programm"},
            { menu_file_exit,"Exit"},
                    
            { menu_movement, "Bewegungen"},
            { menu_movement_in_out,"Bewegungen rein/raus"},
            { menu_movement_from_to,"Bewege von-zu"},
            { menu_movement_revision,"Warenbestand-Revision"},
            { menu_nomenclature, "Namensverzeichnis"},
            
            { menu_inventory, "Warenbestand"},
            { menu_inventory_start_stock_counting,"Zaehle Bestand"},
            { menu_inventory_checkout,"Pruefe Inventur"},
            { menu_inventory_limits,"Inventurgrenzen"},
            
            { menu_inventory_rep, "Uebersicht"},
            { menu_inventory_mov_revision, "Warenbestand-Revision"},
            { menu_inventory_stock_on_hand, "Aktueller Warenbestand"},
            { menu_inventory_on_hand_totals, "Gesamter Warenbestand"},
            { menu_inventory_checkouts,"Pruefe Inventur"},
            { menu_inventory_checkouts_dif,"Pruefe Inventur Differenzen"},
            { menu_inventory_time_to_purchase,"Muss bestellt werden"},
            { menu_inventory_sales_movement,"Umsatzbewegungen"},
            
            { menu_orders, "Bestellungen"},
            { menu_orders_fullfill,"Bestellungen erfuellen"},
            { menu_orders_placement,"Bestellen"},
                    
            { menu_orderReports, new String("\u00DCbersichte Bestellungen")},
            { menu_orderReports_OrderHistory,"Bestell-Historie"},
            { menu_orderReports_OrderHistoryItems,"Bestell-Historie Artikel"},
            { menu_orderReports_Details,"Bestell-Details"},
            { menu_orderReports_Amounts,"Bestell-Wert"},
            { menu_orderReports_OrdersPending,"Offene Bestellungen"},
            { menu_orderReports_OrdersUnpaid,"Unbezahlte Bestellungen"},
            { menu_orderReports_OrdersNumber_Daily,"Taegliche Bestellungen"},
            { menu_orderReports_OrdersNumber_Monthly,"Monatliche Bestellungen"},
            { menu_orderReports_Usage,"Verbrauch"},
            { menu_orderReports_Usage_Monthly,"Monatlicher Verbrauch"},
            { menu_orderReports_ActiveSalesPeople_Daily,"Aktive MAs taeglich"},
            { menu_orderReports_ActiveSalesPeople_Monthly,"Aktive MAs monatlich"},
            { menu_orderReports_ActiveCustomers,"Aktive Kunden taeglich"},
            { menu_orderReports_ActiveCustomers_Monthly,"Active Kunden monatlich"},
            { menu_orderReports_OrderCommisions,"Bestellhonorare"},
            { menu_orderReports_CommissionsBtPeriod,"Honorare pro Monat"},
            
            
            {menu_generate,"Erstelle"},
            {menu_generate_letter1,"Erstelle Brief 1"},
            {menu_generate_letter2,"Erstelle Brief 2"},
            {menu_generate_letter3,"Erstelle Brief 3"},
                    
            {menu_query,"Frage"},
            {menu_query_letter1,"Brief 1"},
            {menu_query_letter2,"Brief 2"},
            {menu_query_letter3,"Brief 3"},
                    
            { tabpane_orderParticipants, "Auftragsverwaltung"},
            { tabpane_orderSession, "Order Session"},
            { tabpane_orders, "Bestellungen"},
            { tabpane_invoice, "Rechnung"},
            { tabpane_packingList, "Lieferschein"},
                    
                    /** Order Placement  * JPanels  **/
            { jpanOPClient, "Kunde"},
            { jpanOPClientInfo, "Weitere Kundenangaben"},
            { jpanOPOrderDetails, "Rechnung"},
                    /** Order Placement  * Labels  **/
            { lblOPFName, "Vorname"},
            { lblOPLName, "Nachname"},
            { lblOPApeal, "Anrede"},
            { lblOPAltName, "Zweite Name"},
            { lblOPType, "Typ"},
            { lblOPStreet, "Strasse"},
            { lblOPDiscount, "Rabatt %"},
            { lblOPCode, "Post. (PLZ)"},
            { lblOPCity, "Ort"},
            { lblOPCountry, "Land"},
            { chkOPCanPurchase, "Darf bestellen"},
            { chkOPVatFree, "Mehrwertsteuerfrei"},
            { chkAltAddress, "Lieferadresse benutzen"},
            { lblOPFirmNo, "Umsatz st. ID-Num."},
            { lblOPUIN, "Kundenummer"},
            { lblOPDate, "Datum"},
            { lblOPDocNo, "Rechnungsnummer"},
            { lblOPInvNo, "Rechnung Num."},
            { lblOPDocType, "Art"},
            { lblOPOperator, "Bearbeiter"},
            { lblOPStock, "K\u00FCrzel"},
            { lblOPCount, "Anzahl"},
            { lblOPPayDate, "Eingangsdatum"},
            { lblOPPayed, "Bezahlt"},
            { lblOPStockNotSel, "Kein Artikel eingegeben"},
                    /** Order Placement  * Buttons  **/
            { btnOPNewClient, "Neu"},
            { btnOPEditClient, "\u00C4ndern"},
            { btnOPSearchClient, "Suchen"},
            { btnOPPlaceOrder, "Bestellung eingeben"},
            { btnOPAddProduct, "Zuf\u00FCgen"},
            { btnOPSetAltAddress, "Lieferadresse eingeben"},
            { btnOPCancelNewOrder, "Bestellung stornieren","Bestellungen Neu"},
            { btnOPPay, "Bezahlt"},
            { btnOPMacros, "Macros"},
            { btnOPSendLetter, "Mahnung verschicken"},
            { btnOPCreditNote, "Gutschrift"},
            { tblOrderGoods, tblOrderGoodsHeader},
            { tblOrders, tblOrdersHeader},
            {wordNetto , "Netto"},
            {wordDiscount , "Rabatt"},
            {wordPorto , "Versandkosten"},
            {wordTotal , "Netto Betrag"},
            {wordVAT , "Mwst"},
            {wordTotalSum , "Endsumme"},
            {CLProv1Appropriate,"Provisionstyp 1"},
            {CLProv2Appropriate,"Provisionstyp 2"},
            {lblProv1UIN , "Prov. 1 ID"},
            {lblProv2UIN , "Prov. 2 ID"},
            {lblProv3UIN , "Prov. 3 ID"},
            {lblProv1Name , "Prov. 1 Name"},
            {lblProv2Name , "Prov. 2 Name"},
            {lblProv3Name , "Prov. 3 Name"},
            {btnSelProv1 , "W\u00E4hlen Provision 1"},
            {btnSelProv2 , "W\u00E4hlen Provision 2"},
            {btnSelProv3 , "W\u00E4hlen Provision 3"},
            {lblEnterKeyWords , "Such kennzeichen"},
            {lblPersonType , "Kundentyp"},
            {btnSearch , "Suchen"},
            {lblPersons , "Personen"},
            {tblClSearchPersons,tblClSearchPersonsHeader},
                    
            {lblStockSelSearchStr , "Suchangaben"},
            {lblStockSelStocks , "Artikelliste"},
            {btnStockSelSelect , "W\u00E4hlenhlen"},                        
            {tblStockSelStocks,tblStockSelStocksHeader},
            {btnClCancel,"Abbrechen"},
            {btnClAdd,"Zuf\u00FCgen"}
        };
        return new DefaultTableModel(data, names);
    }
    
}
