/*
 * ComboDataModel.java
 *
 * Created on , 2005,  1, 20:34
 */

package adminmodul;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultSingleSelectionModel;
import javax.swing.JOptionPane;
import javax.swing.event.ListDataListener;

/**
 *
 * @author JohnyEdu
 */
public class ComboDataModel extends DefaultSingleSelectionModel implements ComboBoxModel{
    Vector vecData;
    
    /** Creates a new instance of ComboDataModel */
    public ComboDataModel(ResultSet rsSQLResult) {
        vecData = new Vector();
        try{                                                
                boolean bEOF = rsSQLResult.next();           
                while( bEOF )
                {
                          String strItemName = new String((rsSQLResult.getString(1)));                          
                          int nItemId = rsSQLResult.getInt(2);
                          if(strItemName==null)
                          {
                              //some error handling here      
                              break;                                                                      
                          }
                          vecData.addElement(new ComboDataRow(strItemName,nItemId));
                          bEOF=rsSQLResult.next();
                }                            
        }catch(SQLException sqle){  JOptionPane.showMessageDialog(null,sqle.toString());  } 
        catch(NullPointerException npe){ JOptionPane.showMessageDialog(null,npe.toString());  }
    }
    public Object getElementAt(int index) {
        return (String)((ComboDataRow)vecData.get(index)).strComboItem;
    }
    public ComboDataRow getCObjectAt(int index)
    {
        return (ComboDataRow)vecData.get(index);
    }
    public int getSize() {
        return(vecData.size());
    }

    public void addListDataListener(ListDataListener l) {}

    public void removeListDataListener(ListDataListener l) {}
    
    public Object getSelectedItem()
    {
        if(vecData!=null)
        {
            if(vecData.size()>0)
            {
                int nSelIndex = getSelectedIndex();
                if(nSelIndex != -1)
                    return ((ComboDataRow)vecData.get(getSelectedIndex())).strComboItem;
                return ((ComboDataRow)vecData.get(0)).strComboItem;
            }
        }
        return null;       
    }
    public void setSelectedItem(Object obj)
    {
        for(int index=0;index<vecData.size();index++)
        {
            if(((ComboDataRow)vecData.get(index)).strComboItem == obj)
            {
                setSelectedIndex(index);
                break;
            }
        }
    }
    public void setObject(ComboDataRow obj){
        vecData.addElement(obj);                  
        fireStateChanged();
        
    }
    public void setObjectAt(ComboDataRow obj, int index){
        vecData.setElementAt(obj,index);                 
    }
}
