package adminmodul;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class CommNomenclature extends javax.swing.JDialog implements SharedConstants,ListSelectionListener{
    public static final int PROV1_NAME_INDEX = 0;
    public static final int PROV2_NAME_INDEX = 1;
    public static final int COMM_KEY_INDEX = 2;
    
    public CommNomenclature(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        afterInitComponents();
    }
    
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        scrProvs = new javax.swing.JScrollPane();
        tblProvs = new javax.swing.JTable();
        btnAdd = new javax.swing.JButton();
        btnEdit = new javax.swing.JButton();
        btnDelete = new javax.swing.JButton();
        editProv1 = new javax.swing.JTextField();
        editProv2 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("%  Info");
        tblProvs.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Prov.1 %", "Prov.2 %"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        scrProvs.setViewportView(tblProvs);

        getContentPane().add(scrProvs);
        scrProvs.setBounds(10, 50, 150, 110);

        btnAdd.setText("Add");
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CommNomenclature.this.actionPerformed(evt);
            }
        });

        getContentPane().add(btnAdd);
        btnAdd.setBounds(170, 50, 70, 23);

        btnEdit.setText("Edit");
        btnEdit.setEnabled(false);
        btnEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CommNomenclature.this.actionPerformed(evt);
            }
        });

        getContentPane().add(btnEdit);
        btnEdit.setBounds(170, 80, 70, 23);

        btnDelete.setText("Delete");
        btnDelete.setEnabled(false);
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        getContentPane().add(btnDelete);
        btnDelete.setBounds(170, 110, 70, 23);

        getContentPane().add(editProv1);
        editProv1.setBounds(10, 20, 70, 20);

        getContentPane().add(editProv2);
        editProv2.setBounds(100, 20, 60, 20);

        jLabel1.setText("Prov.1 %");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(10, 5, 50, 14);

        jLabel2.setText("Prov.2 %");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(100, 5, 50, 14);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-256)/2, (screenSize.height-204)/2, 256, 204);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
        BigDecimal bdm = new BigDecimal(0.0);
        
        String strProv1 = editProv1.getText().trim().length()<=0 ? "0" : editProv1.getText().trim();
        String strProv2 = editProv2.getText().trim().length()<=0 ? "0" : editProv2.getText().trim();
        
        bdm = new BigDecimal(strProv1);
        bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
        strProv1 = bdm.toString();
        
        bdm = new BigDecimal(strProv2);
        bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
        strProv2 = bdm.toString();
        int row = tblProvs.getSelectedRow();
        if(row < 0) {
            JOptionPane.showMessageDialog(null,"Please select record from the table above!");
            return;
        }
        String strCoutryID  = (String)((UniversalTableModel)tblProvs.getModel()).getValueAt(row, COMM_KEY_INDEX);
        Connection connDB = null;
        try{
            connDB = SharedUtils.getConnection();
            //SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "delete from BASE_COMM WHERE COMM_KEY = " + strCoutryID;
            Statement stm = connDB.createStatement();
            int nRowsModified = stm.executeUpdate(strSQL);
            if(nRowsModified <= 0){
                JOptionPane.showMessageDialog(null,"Record was not registered!");
                return;
            }
            
            stm.close();
            //String strLastID = SharedUtils.getLastInsertedID(connDB);
            ((UniversalTableModel)tblProvs.getModel()).removeAt(row);
            tblProvs.updateUI();
            SharedUtils.sortTableBySingleColumn(tblProvs, 0, 0, true);
            
        }catch(Exception e){
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(connDB);
        }
    }//GEN-LAST:event_btnDeleteActionPerformed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        BigDecimal bdm = new BigDecimal(0.0);
        
        String strProv1 = editProv1.getText().trim().length()<=0 ? "0" : editProv1.getText().trim();
        String strProv2 = editProv2.getText().trim().length()<=0 ? "0" : editProv2.getText().trim();
        
        bdm = new BigDecimal(strProv1);
        bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
        strProv1 = bdm.toString();
        
        bdm = new BigDecimal(strProv2);
        bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
        strProv2 = bdm.toString();
        
        if(evt.getSource() == btnAdd){
            
            if(((UniversalTableModel)tblProvs.getModel()).objectExistsAt(strProv1, PROV1_NAME_INDEX) &&
                    ((UniversalTableModel)tblProvs.getModel()).objectExistsAt(strProv2, PROV2_NAME_INDEX)){
                JOptionPane.showMessageDialog(null,"Record with these values is already registered in the system!");
                return;
            }
            Connection connDB = null;
            try{
                connDB = SharedUtils.getConnection();
                
                String strSQL = "INSERT INTO BASE_COMM VALUES(" + strProv1 + "," + strProv2 +")";
                Statement stm = connDB.createStatement();
                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"Record was not registered!");
                    return;
                }
                
                stm.close();
                String strLastID = SharedUtils.getLastInsertedID(connDB);
                Vector vecRowElements = new Vector();
                vecRowElements.addElement(strProv1);
                vecRowElements.addElement(strProv2);
                vecRowElements.addElement(strLastID);
                UniversalTableRow uniRow = new UniversalTableRow(vecRowElements);
                ((UniversalTableModel)tblProvs.getModel()).addObject(uniRow);
                tblProvs.updateUI();
                //SharedUtils.sortTableBySingleColumn(tblProvs, 0, 0, true);
                
            }catch(SQLException sqle){
                SharedUtils.handleError(GENERAL_DB_ERROR);
            } finally {
                SharedUtils.closeConnection(connDB);
            }
        } else if(evt.getSource() == btnEdit){
            int row = tblProvs.getSelectedRow();
            if(row < 0) {
                JOptionPane.showMessageDialog(null,"Please select record from the table above!");
                return;
            }
            
            String strCommID  = (String)((UniversalTableModel)tblProvs.getModel()).getValueAt(row, PROV1_NAME_INDEX);
            
            if(((UniversalTableModel)tblProvs.getModel()).objectExistsAt(strProv1, PROV1_NAME_INDEX)){
                if(!strProv1.equals(strCommID)){
                    JOptionPane.showMessageDialog(null,"Coutry with that name is already registered in the system.Please, type another name!");
                    return;
                }
            }
            String strCoutryID  = (String)((UniversalTableModel)tblProvs.getModel()).getValueAt(row, COMM_KEY_INDEX);
            Connection connDB = null;
            try{
                connDB = SharedUtils.getConnection();
                String strSQL = "UPDATE BASE_COMM SET COMM_PRV1 = " + strProv1 + ", COMM_PRV2 =" + strProv2 + " WHERE COMM_KEY = " + strCoutryID;
                Statement stm = connDB.createStatement();
                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"Record was not updated!");
                    return;
                }
                UniversalTableRow trowSelected = ((UniversalTableModel)tblProvs.getModel()).getRowObject(row);
                trowSelected.setRowElement(strProv1, PROV1_NAME_INDEX);
                trowSelected.setRowElement(strProv2, PROV2_NAME_INDEX);
                tblProvs.updateUI();
                //SharedUtils.sortTableBySingleColumn(tblProvs, 0, 0, true);
                
            }catch(Exception e){
                e.printStackTrace();
            } finally {
                SharedUtils.closeConnection(connDB);
            }
        }
        editProv1.setText(strProv1);
        editProv2.setText(strProv2);
    }//GEN-LAST:event_actionPerformed
    
    
    
    public void valueChanged(ListSelectionEvent e) {
        if(e.getSource()==tblProvs.getSelectionModel()) {
            if(tblProvs.getSelectedRow()>=0){
                btnEdit.setEnabled(true);
                btnDelete.setEnabled(true);
            } else{
                btnEdit.setEnabled(false);
                btnDelete.setEnabled(false);
            }
            int row = tblProvs.getSelectedRow();
            UniversalTableRow trowSelected = ((UniversalTableModel)tblProvs.getModel()).getRowObject(row);
            String strProv1 = (String)trowSelected.vecRowElements.get(PROV1_NAME_INDEX);
            String strProv2 = (String)trowSelected.vecRowElements.get(PROV2_NAME_INDEX);
            editProv1.setText(strProv1);
            editProv2.setText(strProv2);
        }
    }
    
    private void afterInitComponents(){
        //Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT COMM_PRV1,COMM_PRV2,COMM_KEY FROM BASE_COMM";
        //Statement stm = connDB.createStatement();
        //ResultSet rsDBData=stm.executeQuery(strSQL);
        String[] str_rgn_columnNames ={"Country","VAT"};
        SharedUtils.setTableDBModel(tblProvs, strSQL, str_rgn_columnNames);
        tblProvs.getTableHeader().setReorderingAllowed(false);
        tblProvs.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblProvs.getSelectionModel().addListSelectionListener(this);
        
        
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnDelete;
    private javax.swing.JButton btnEdit;
    private javax.swing.JTextField editProv1;
    private javax.swing.JTextField editProv2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane scrProvs;
    private javax.swing.JTable tblProvs;
    // End of variables declaration//GEN-END:variables
    
}
