/*
 * SharedConstants.java
 *
 * Created on , 2005,  27, 14:04
 */

package adminmodul;

/**
 *
 * @author JohnyEdu
 */
public interface SharedConstants {    
    
// Database related constants
    //public final String dbServer = "127.0.0.1";
    //public final String dbPort = "1433";
    //public final String dbName="medstore";
    //public final String username="medstore";
    //public final String password="medstore";
    //public final String connectionString = "jdbc:microsoft:sqlserver://"+dbServer+":"+dbPort/*+";DatabaseName="+dbName*/;    
    //public final String connectionString = "jdbc:odbc:medstore";
    //  Database related constants 
    

// Stock related constants
   public final int STOCK_STATUS_UNKNOWN = 2;
   public final int STOCK_STATUS_NOTPACKED = 1;
   public final int STOCK_STATUS_PACKED = 2;      
// Stock related constants
   
// Event related constants
   public final int EVENT_TYPE_UNKNOWN = 0;
   public final int EVENT_TYPE_INPUT = 1;
   public final int EVENT_TYPE_OUTPUT = 2;
   public final int EVENT_TYPE_MOVETO = 3;
   public final int EVENT_TYPE_MOVEFROM = 4;
   
   public final String EVENT_TYPE_INPUT_STR = "1";
   public final String EVENT_TYPE_OUTPUT_STR = "2";
   
   public final String EVENT_TEXT_INPUT = "Move In";
   public final String EVENT_TEXT_OUTPUT = "Move Out";
   public final String EVENT_TEXT_MOVETO = "Move To";
   public final String EVENT_TEXT_MOVEFROM = "Move From";  
   
   public final int EVENT_STATUS_ACTIVE = 1;
   public final int EVENT_STATUS_NOTACTIVE = 2;
   public final int EVENT_STATUS_UNPACK = 3;
   
   public final String EVENT_STATUS_TEXT_ACTIVE = "Done";
   public final String EVENT_STATUS_TEXT_NOTACTIVE = "Undone";

// Store related constants
   public final int STORE_ID_UNKNOWN = 1;   
// Store related constants
   
// db queries constants
   public final int DB_ERROR = 0;
   public final int DB_RECORD_EXISTS = 1;
   public final int DB_RECORD_DONTEXISTS = 2;
// db queries constants
   
// project controls user defined ID's used for input validation
   public final int MedStoreNavigatorDialog_STOCK_COUNT = 1;
   public final int MedStoreNavigatorDialog_ORDER_ID = 2;
   public final int MedStoreNavigatorDialog_BARCODE = 3;   
   public final int AddStockDialog_STOCK_COUNT = 4;
   public final int AddStockDialog_STOCK_NAME = 5;
   public final int AddStockDialog_STOCK_BARCODE = 6;   
   public final int OrdersInOut_STOCK_COUNT = 7;
   public final int OrdersMoveFromTo_STOCK_COUNT = 8;   
   public final int StoreManager_STORE_NAME= 9;
   public final int MovementInOut_STOCK_COUNT = 10;
   public final int MovementInOut_BARCODE = 11;   
   public final int MovementFromTo_STOCK_COUNT = 12;
   public final int MovementFromTo_BARCODE = 13;      
   public final int EditInventoryCellEditor_INVENTORY_COUNT = 14;
   public final int OrderFullfilment_ORDERNO = 15;
   public final int OrderFullfilment_STOCK_COUNT = 16;
   public final int OrderFullfilment_BARCODE = 17;
   public final int FilterQueryDialog_DATE = 18;
   public final int Universal_Integer = 19;
   public final int Universal_Float = 20;
   
   
   
// project controls user defined ID's
   
// table rows constants
   public final int ANY_TABLE_ROW = 0;
   public final int SELECTED_TABLE_ROW = 1;
// table rows constants
   
   
// operation codes
   public final String OPCODE_INPUT = "IN";
   public final String OPCODE_OUTPUT = "OT";
   public final String OPCODE_MOVE = "MV";
   public final String OPCODE_QUERY = "QR";
   public final String OPCODE_PACK = "UK";
   
   public final String OPNAME_INPUT = "INPUT";
   public final String OPNAME_OUTPUT = "OUTPUT";
   public final String OPNAME_MOVE = "MOVE";
   public final String OPNAME_QUERY = "QUERY";
   public final String OPNAME_PACK = "UNPACK";
   
// operation codes 
   
//error codes
  public final int NO_ERROR =  0;
  public final int UNKNOWN_BARCODE =  1;
  public final int INVALID_BALANCE =  2;
  public final int STOCK_COUNT_IN_STOR_INSERT_ERROR =  3;
  public final int STOCK_COUNT_IN_STOR_UPDATE_ERROR =  4;
  public final int STOCK_COUNT_IN_STOR_DELETE_ERROR =  5;
  public final int INVALID_OPCODE =  6;
  public final int INSERT_EVENT_ERROR =  7;
  public final int STOCK_COUNT_IN_EVENT_INSERT_ERROR =  8;  
  public final int EVENT_FOR_STORNO_NOT_FOUND =  9;
  public final int STORNO_UPDATE_EVENT_TABLE_ERROR =  10;
  public final int INSERT_TRANSACTION_EVENT_ERROR =  11; 
  public final int INSERT_EVENTS_IN_TRAN_ERROR =  12;
  public final int NO_EVENTS_FOR_TRAN_FOUND =  13;
  public final int UNPACK_AGAINST_ATOMIC_STOCK_ERROR =  14;
  public final int GENERAL_DB_ERROR =  15;
  public final int INTERNAL_SYSTEM_ERROR =  16;
//error codes
  
//store types
  public final String STORE_TYPE_STORING = "ST";
  public final String STORE_TYPE_PACKING = "PK";
//store types 
  
  
// query filter constants
   public final int TEXT_DATE_FILTER = 1;
   public final int MONTH_DATE_FILTER = 2;
   public final int WEEK_DATE_FILTER = 3;
   public final int STOCK_FILTER = 4;      
// query filter constants  
   
// query filter var constants
   public final String TEXT_DATE_FROM = "1";
   public final String TEXT_DATE_TO = "2";
   public final String MONTH_DATE_FROM = "3";
   public final String MONTH_DATE_TO = "4";
   public final String WEEK_DATE_FROM = "5";
   public final String WEEK_DATE_TO = "6";
   public final String STOCK_LIST = "7";
   
// query filter var constants
   
// query constants
   public final int ORDERS_HISTORY_QUERY =  0;
// query constants   
  
//user constants
   public final int ADMIN_USER = 0;
   public final int OPERATOR_USER = 1;        
//user constants 
   
// permissions
   public final int MENU_NOT_ALLOWED = 0;
   public final int MENU_ALLOWED = 1;
// permissions   
   public final int EXPORT_TYPE_CLIENTS = 0;
   public final int EXPORT_TYPE_ORDERS = 1;
    
}
