package medstore;
import holders.User;
import java.io.File;
import java.io.FileOutputStream;
import javax.jnlp.ExtendedService;
import javax.jnlp.FileContents;
import javax.jnlp.ServiceManager;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import medstore.main.LoginForm;
import medstore.main.MainMenu;
import org.jfree.report.JFreeReportBoot;

public class Main implements Base{
    private LoginForm login;
    private MainMenu menu;
    
    public static User user = new User();
    
    public Main() throws Exception{        
        user = new User();
        try {
            
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        } catch (ClassNotFoundException ex) {
            ex.printStackTrace();
        } catch (IllegalAccessException ex) {
            ex.printStackTrace();
        } catch (UnsupportedLookAndFeelException ex) {
            ex.printStackTrace();
        } catch (InstantiationException ex) {
            ex.printStackTrace();
        }
        
    }
    public User getUser(){
        return user;
    }
    
    public static void main(String[] a) throws Exception{
        JFreeReportBoot.getInstance().start();
        Main main = new Main();
        main.Login();
    }
    
    public void Login() {
        if(login!=null){
            login.dispose();
        }
        user = new User();
        
        login = new LoginForm(this);
        login.setLocationRelativeTo(null);
        login.setVisible(true);
    }
    public void loadMainMenu(){
        
        if(login!=null){
            login.dispose();
        }
        if(menu!=null){
            menu.dispose();
        }
        
        menu = new MainMenu(this);
        menu.setLocation(50,10);
        menu.setVisible(true);
    }
    public static String getUrlSessionId(User user){
        return ";jsessionid="+user.getUserMap().get(User.SESSION_ID);
    }
    
    public static void exit(){
        System.exit(0);
    }
}
