package medstore.auftrag;

public class AuftragData {
    private String orderNom;
    private String appeal;
    private String firstName;
    private String lastName;   
    private String altr_name;
    private String clientCode;
    private String street;
    private String city;
    private String pcode;
    
    public AuftragData(String orderNom, String appeal, String firstName, String lastName, String altr_name, String clientCode, String street, String city, String pcode) {
        this.orderNom = orderNom==null ? "" : orderNom;
        this.appeal = appeal==null ? "" : appeal;
        this.firstName = firstName==null ? "" : firstName;
        this.lastName = lastName==null ? "" : lastName;    
        this.altr_name = altr_name==null ? "" : altr_name;    
        this.clientCode = clientCode==null ? "" : clientCode;
        this.street = street==null ? "" : street;
        this.city = city==null ? "" : city;
        this.pcode = pcode==null ? "" : pcode;
       
    }
    
    public String toString(){        
        return orderNom.toString().trim() + 
                "|" + appeal.toString().trim() + " " + 
                "|" + firstName.toString().trim() + " " + lastName.toString().trim() +
                "|" + altr_name.toString().trim() +
                "|" + " " +
                "|" + street.toString().trim() + 
                "|" + pcode.toString().trim() + 
                "|" + city.toString().trim() + 
                "|" + clientCode.toString().trim() + 
                setEmpty(13) + System.getProperty( "line.separator" );
    }
    public String setEmpty(int br){        
        String empty = "|";
        for(int i = 0; i < br-1; i++)
            empty+= "|";
        return empty;
    }
}
