package medstore.auftrag;

import java.io.File;
import java.util.Date;
import medstore.remote.io.auftrag.FileIO;

public class AuftragFile {
    private File file;
    
    public AuftragFile(File file) throws Exception {
        this.file = file;         
    }    
    public AuftragFile(String file) throws Exception {        
        this(new File(file));        
    }    
    public long lastModefiedtoLong(){
        return file.lastModified();
    }    
    public Date lastModefiedToDate(){
        return new Date(file.lastModified());
    }        
    public void appendOrder(AuftragData auftragData) throws Exception{        
        FileIO.WriteToFile(file,auftragData.toString(),true);
    }
}
