package medstore.main;

import holders.User;
import java.awt.event.WindowEvent;
import javax.swing.JOptionPane;
import medstore.*;
import medstore.remote.io.login.RemoteLogin;
public class LoginForm extends javax.swing.JFrame {
    int action = -1;
    private Main main;
    private WindowEvent evt;
    
    public LoginForm(Main main) {
        super("Login Form");
        this.main = main;
        initComponents();
        evt = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
        
    }
    public void submit(java.awt.event.KeyEvent evt){
         if(evt.getKeyCode() == evt.VK_ENTER) {
             cmdLogin.doClick(100);
         }
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtUsername = new javax.swing.JTextField();
        cmdLogin = new javax.swing.JButton();
        cmdCancel = new javax.swing.JButton();
        txtPassword = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("Username");
        jLabel1.setMaximumSize(new java.awt.Dimension(100, 21));
        jLabel1.setMinimumSize(new java.awt.Dimension(100, 21));
        jLabel1.setPreferredSize(new java.awt.Dimension(100, 21));

        jLabel2.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel2.setText("Password");
        jLabel2.setMaximumSize(new java.awt.Dimension(100, 21));
        jLabel2.setMinimumSize(new java.awt.Dimension(100, 21));
        jLabel2.setPreferredSize(new java.awt.Dimension(100, 21));

        txtUsername.setFont(new java.awt.Font("Arial", 1, 12));
        txtUsername.setMaximumSize(new java.awt.Dimension(100, 21));
        txtUsername.setMinimumSize(new java.awt.Dimension(100, 21));
        txtUsername.setPreferredSize(new java.awt.Dimension(100, 21));
        txtUsername.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtUsernameKeyPressed(evt);
            }
        });

        cmdLogin.setFont(new java.awt.Font("Arial", 1, 12));
        cmdLogin.setText("Login");
        cmdLogin.setMaximumSize(new java.awt.Dimension(100, 21));
        cmdLogin.setMinimumSize(new java.awt.Dimension(100, 21));
        cmdLogin.setPreferredSize(new java.awt.Dimension(100, 21));
        cmdLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdLoginActionPerformed(evt);
            }
        });

        cmdCancel.setFont(new java.awt.Font("Arial", 1, 12));
        cmdCancel.setText("Cancel");
        cmdCancel.setMaximumSize(new java.awt.Dimension(100, 21));
        cmdCancel.setMinimumSize(new java.awt.Dimension(100, 21));
        cmdCancel.setPreferredSize(new java.awt.Dimension(100, 21));
        cmdCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdCancelActionPerformed(evt);
            }
        });

        txtPassword.setFont(new java.awt.Font("Arial", 1, 12));
        txtPassword.setMaximumSize(new java.awt.Dimension(100, 21));
        txtPassword.setMinimumSize(new java.awt.Dimension(100, 21));
        txtPassword.setPreferredSize(new java.awt.Dimension(100, 21));
        txtPassword.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtPasswordKeyPressed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                    .add(cmdCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(txtPassword, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                    .add(cmdLogin, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, txtUsername, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE))
                .addContainerGap(14, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(layout.createSequentialGroup()
                        .add(txtUsername, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(8, 8, 8)))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(txtPassword, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(14, 14, 14)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cmdLogin, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(cmdCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void txtPasswordKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtPasswordKeyPressed
        submit(evt);
    }//GEN-LAST:event_txtPasswordKeyPressed
    
    private void txtUsernameKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtUsernameKeyPressed
        submit(evt);
    }//GEN-LAST:event_txtUsernameKeyPressed
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        try{
            System.exit(0);
        } catch(Exception e){
            
        }
    }//GEN-LAST:event_formWindowClosing
    
    private void cmdLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdLoginActionPerformed
        try {
            main.user.setUsername(txtUsername.getText());
            main.user.setPassword(new String(txtPassword.getPassword()));
            main.user.validate();
            main.user.validateRemote();
            main.loadMainMenu();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,ex.getMessage());
        }
    }//GEN-LAST:event_cmdLoginActionPerformed
            private void cmdCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdCancelActionPerformed
                Main.exit();
    }//GEN-LAST:event_cmdCancelActionPerformed
                // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdCancel;
    private javax.swing.JButton cmdLogin;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPasswordField txtPassword;
    private javax.swing.JTextField txtUsername;
    // End of variables declaration//GEN-END:variables
    
}
