package medstore.math;

import java.math.BigDecimal;
import javax.swing.JOptionPane;

public class BigDec {
    
    public static String scaledRoundHalfUp(String value, int scale){        
        try {
            value = (value==null || "null".equalsIgnoreCase(String.valueOf(value).trim()) || value.trim().length()<=0) ? "0.00" : value;
            BigDecimal bdm = new BigDecimal(value);
            bdm = bdm.setScale(scale,BigDecimal.ROUND_HALF_UP);
            return bdm.toString();
        } catch(Exception e) {            
            return value;
        }
    }
    public static String scaledRoundHalfUp(double value, int scale){                
        return scaledRoundHalfUp(String.valueOf(value), scale);
    }
    public static String longValue(String value){        
        value = (value==null || value.equalsIgnoreCase("null") || value.trim().length()<=0) ? "0" : value;
        BigDecimal bdm = new BigDecimal(value);
        
        return new Long(bdm.intValue()).toString();
    }
}
