package medstore.orders;

import java.awt.Dialog;
import javax.swing.JComponent;
import medstore.forms.CommonDialog;

public class AlternateAddress extends CommonDialog {
    public static final String isPermanent = "permanent";
    public AlternateAddress(Dialog parent) {
        super(parent,true);
        setTitle("Alternate address");         
        initComponents();
        try{            
            setLocationRelativeTo(parent);
        } catch(Exception e){
            
        }
    }
    
    public void setAddress(String address){
        edpAltAddress.setText(address);
    }
    public String getAddress(){
        return edpAltAddress.getText();
    }
    public boolean isPermanent() {
        return chkPermanent.isSelected();
    }
    public void setPermanent(boolean value){
        chkPermanent.setSelected(value);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane3 = new javax.swing.JScrollPane();
        edpAltAddress = new javax.swing.JEditorPane();
        btnSubmit = new javax.swing.JButton();
        chkPermanent = new javax.swing.JCheckBox();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Alternate Address");
        edpAltAddress.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane3.setViewportView(edpAltAddress);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(jScrollPane3, gridBagConstraints);

        btnSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSubmit.setText("OK");
        btnSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AlternateAddress.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 29;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 0);
        getContentPane().add(btnSubmit, gridBagConstraints);

        chkPermanent.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkPermanent.setText("Set Permanent  ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 0);
        getContentPane().add(chkPermanent, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-303)/2, (screenSize.height-231)/2, 303, 231);
    }// </editor-fold>//GEN-END:initComponents
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnSubmit ){
            dispose();
        }
    }//GEN-LAST:event_actionPerformed
        // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSubmit;
    private javax.swing.JCheckBox chkPermanent;
    private javax.swing.JEditorPane edpAltAddress;
    private javax.swing.JScrollPane jScrollPane3;
    // End of variables declaration//GEN-END:variables
}
