package medstore.orders;

import holders.person.Person;
import java.util.HashMap;
import medstore.model.HashTableModel;

public class PlaceOrderPanel extends javax.swing.JPanel{
    BasePlaceOrderPanel base;
    
    public PlaceOrderPanel() {
        initComponents();
        
    }
    public void setBase(BasePlaceOrderPanel base){
        this.base = base;
    }
    public void disableBtnPlace(boolean value){
        btnPlaceOrder.setEnabled(value);        
    }
    public void disableBtnPay(boolean value){        
        btnPay.setEnabled(value);
    }
    public void btnCancel_NewOrder(){
        btnCancelOrder.setText("Cancel Order");
    }
    public void btnCancel_CancelOrder(){
        btnCancelOrder.setText("New Order");
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnPlaceOrder = new javax.swing.JButton();
        btnCancelOrder = new javax.swing.JButton();
        btnPay = new javax.swing.JButton();

        setMinimumSize(new java.awt.Dimension(280, 25));
        setPreferredSize(new java.awt.Dimension(280, 25));
        btnPlaceOrder.setFont(new java.awt.Font("Arial", 1, 12));
        btnPlaceOrder.setText("Place Order");
        btnPlaceOrder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPlaceOrderActionPerformed(evt);
            }
        });

        btnCancelOrder.setFont(new java.awt.Font("Arial", 1, 12));
        btnCancelOrder.setText("New Order");
        btnCancelOrder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelOrderActionPerformed(evt);
            }
        });

        btnPay.setFont(new java.awt.Font("Arial", 1, 12));
        btnPay.setText("Pay");
        btnPay.setEnabled(false);
        btnPay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPayActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(btnPlaceOrder)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnCancelOrder)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 21, Short.MAX_VALUE)
                .add(btnPay))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(btnPlaceOrder)
                .add(btnCancelOrder)
                .add(btnPay))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnPayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPayActionPerformed
        base.payOrder();
    }//GEN-LAST:event_btnPayActionPerformed
    
    private void btnCancelOrderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelOrderActionPerformed
        base.prepareNewOrder();
    }//GEN-LAST:event_btnCancelOrderActionPerformed
    
    private void btnPlaceOrderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPlaceOrderActionPerformed
        base.placeOrder();
    }//GEN-LAST:event_btnPlaceOrderActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelOrder;
    private javax.swing.JButton btnPay;
    private javax.swing.JButton btnPlaceOrder;
    // End of variables declaration//GEN-END:variables
    
}
