package medstore.remote.io;

import java.util.HashMap;
import javax.jnlp.BasicService;
import javax.jnlp.ServiceManager;
import javax.jnlp.UnavailableServiceException;

public class RemoteURL {
    
    
    public static final String baseUrl = getBase() + "medstore/";
    //public static final String baseUrl = "http://localhost:8084/webreport/medstore/";
    public static final String loginUrl = baseUrl + "login.jsp";
    public static final String logoffUrl = baseUrl + "logoff.jsp";
    public static final String allStocksModelUrl = baseUrl + "getAllStocksModel.jsp";
    public static final String PersonSearch = baseUrl + "PersonSearch.jsp";
    public static final String findPerson = baseUrl + "findPerson.jsp";
    public static final String loadPerson = baseUrl + "loadPerson.jsp";
    
    public static final String printInvoice = baseUrl + "printInvoice.jsp";
    public static final String findOrderByIdDate = baseUrl + "findOrderByIdDate.jsp";
    
    public static final String loadPersonByOrder = baseUrl + "loadPersonByOrder.jsp";
    
    public static final String loadStock = baseUrl + "loadStock.jsp";
    
    public static final String placeOrder = baseUrl + "placeOrder.jsp";
    
    public static final String loadMacros = baseUrl + "loadMacros.jsp";
    public static final String saveMacros = baseUrl + "saveMacros.jsp";
    
    public static final String loadCampaign = baseUrl + "loadCampaign.jsp";
    
    public static final String loadPercent = baseUrl + "loadPercent.jsp";
    
    public static final String savePerson = baseUrl + "savePerson.jsp";
    public static final String updatePerson = baseUrl + "updatePerson.jsp";
    
    public static final String payOrder = baseUrl + "payOrder.jsp";
    
    public static final String creditNote = baseUrl + "creditNote.jsp";
    
    public static String getBase(){        
        try {
            BasicService bs = (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
            return bs.getCodeBase().toString();            
        } catch (UnavailableServiceException ex) {
            ex.printStackTrace();
        }        
        return null;
    }
}
