package medstore.remote.io;

import java.io.*;
import java.net.*;

public class ServletWriter {
    
    static public ObjectInputStream postObjects(URL servlet, Serializable objs[]) throws Exception {
        URLConnection con = null;
        try{
            con = servlet.openConnection();
            
            con.setDoInput(true);
            con.setDoOutput(true);
            con.setUseCaches(false);
            con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            
            ObjectOutputStream out = new ObjectOutputStream(con.getOutputStream());
            int numObjects = objs.length;
            for (int x = 0; x < numObjects; x++) {
                out.writeObject(objs[x]);
            }
            out.flush();
            out.close();
        } catch(Exception e){
            e.printStackTrace();
        }
        
        return new ObjectInputStream(con.getInputStream());
    }
    
    static public ObjectInputStream postObject(URL servlet, Serializable obj) throws Exception {
        URLConnection con = null;
        try{
            con = servlet.openConnection();
            
            con.setDoInput(true);
            con.setDoOutput(true);
            con.setUseCaches(false);
            con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            
            ObjectOutputStream out = new ObjectOutputStream(con.getOutputStream());
            out.writeObject(obj);
            out.flush();
            out.close();
        } catch(Exception e){
            e.printStackTrace();
        }
        
        return new ObjectInputStream(con.getInputStream());
    }
}
