package medstore.remote.io.forms;

import medstore.remote.io.RemoteURL;
import holders.User;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Vector;
import medstore.remote.io.ServletWriter;

public class RemoteOrderSearch {
    private User user;
    
    public RemoteOrderSearch(User user) {
        this.user = user;
    }
    
    public Vector findOrder(String v_nr, String date_from, String date_to) throws Exception{
        HashMap map = new HashMap();   
        map.put("v_nr", v_nr);
        map.put("date_from", date_from);
        map.put("date_to", date_to);
        
        URL url = new URL(RemoteURL.findOrderByIdDate);
        Serializable[] obj = {(Serializable)user.getUserMap(),(Serializable)map};
        ObjectInputStream result = ServletWriter.postObjects(url,obj);
        
        return (Vector)result.readObject();
    }
}
