package medstore.remote.io.login;


import medstore.remote.io.RemoteURL;
import holders.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import medstore.Main;
import medstore.remote.io.ServletWriter;

public class RemoteLogin {
    
    public static HashMap Login(User user) throws Exception{               
        try {            
            ObjectInputStream in = ServletWriter.postObjects(new URL(RemoteURL.loginUrl), new Serializable[]{(Serializable)user.getUserMap()});
            HashMap usermap = (HashMap)in.readObject();                        
            return usermap;
        } catch (Exception ex) {         
            ex.printStackTrace();
            throw new Exception("Login Failed!");
        }        
    }
    public static void LogOff(User user) throws Exception{
               
        try {
            Serializable[] m_user = {(Serializable)user.getUserMap()}; 
            ObjectInputStream in = ServletWriter.postObjects(new URL(RemoteURL.loginUrl+";"+user.getUserMap().get(User.SESSION_ID)),m_user);            
        } catch (Exception ex) {              
        }
        finally{
            System.exit(0);
        }
    }
}
