package medstore.stocks.print;

import javax.swing.JFrame;
import javax.swing.table.TableModel;
import medstore.print.*;
import org.jfree.report.JFreeReport;

public class PrintStocks {
    
    public static void printAllStocks(TableModel model) throws Exception{
        
        RepotUtil spUtils = new RepotUtil(model,"/medstore/stocks/print/report_all.xml","Stock Details");        
        final JFreeReport report = spUtils.createReport();
        PrintPreview frame = new PrintPreview(report);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.setSize(600,800);
        frame.pack();
        frame.setVisible(true);
    }
    
}
