<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="javax.swing.table.*"%>

<%@include file="../WEB-INF/db/db.jsp"%>
<%

    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    HashMap user = (HashMap)in.readObject();
    HashMap data = (HashMap)in.readObject();
    in.close();

    url = cn;
    getConnection();

    String v_nr = data.get("v_nr").toString();
    String date_from = data.get("date_from").toString();
    String date_to = data.get("date_to").toString();

    response.setStatus(response.SC_OK);

    String sql = searchSql(v_nr, date_from, date_to);
    
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
    o.writeObject(findOrder(sql));
    o.flush();
    o.close();
    try{
        conn.close();
    } catch(Exception e){

    }
%>
<%!    
    String url = "";
    Connection conn;
    public Connection getConnection() throws Exception {
        conn = DriverManager.getConnection(url);
        return conn;
    }
    public Vector findOrder(String sql) throws Exception {
        PreparedStatement ps = conn.prepareStatement(sql);
        ResultSet rs = ps.executeQuery();        
        Vector data = initLinkedModel(rs);

        return data;
    }
    public String searchSql(String v_nr, String date_from, String date_to) throws Exception{
        String where = "";
        String where_v_nr = "";
        String where_date = "";

        boolean v_nr_filter = false;
        boolean date_filter = false;

        if(v_nr.trim().length()>0){
            v_nr_filter = true;
            where_v_nr = where_v_nr +  " V_NR =  " + v_nr;
        }
        if(date_from.length()>0 && date_to.length()>0){

            String strFromDate = date_from;
            {
                String dateFields[] = date_from.split("\\.");
                strFromDate = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
            }

            String strToDate = date_to;
            {
                String dateFields[] = date_to.split("\\.");
                strToDate = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
            }

            where_date = " INVC_DATE >='" + strFromDate + " 00:00:00' AND " +
                    " INVC_DATE <'" + strToDate + " 23:59:59'";
            date_filter = true;
        }
        where = (v_nr_filter || date_filter) ? " where " : "";
        where+= v_nr_filter ? where_v_nr : "";
        where+= date_filter ?
            (v_nr_filter ? " and " : "") +
                where_date : "";
        
        String strSQL = " " +
                "   SELECT TOP 1000 " +
                "       V_NR, " +
                "       INVC_DATE, " +
                "       TYPE_NAME, " +
                "       NETO_SUM, " +
                "       TOTL_SUM, " +
                "       PAY_SUM," +
                "       patn_idnt " +
                "   FROM " +
                "       VORGANG INNER JOIN BASE_DOC_TYPE ON " +
                "       (VORGANG.DOC_TYPE_IDNT = BASE_DOC_TYPE.TYPE_KEY) ";
        strSQL += where + " order by V_NR desc ";
        
        
        return strSQL;
    }
    public Vector initLinkedModel(ResultSet rs){
        
        Vector data = new Vector();
        try{
            ResultSetMetaData meta = rs.getMetaData();
            while(rs.next()){
                LinkedHashMap row = new LinkedHashMap();
                for(int i = 1; i <= meta.getColumnCount(); i++){
                    row.put(meta.getColumnName(i).toLowerCase(),rs.getObject(i));
                }
                data.add(row);
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return data;
    }
%>