<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="javax.swing.table.*"%>

<%@include file="../WEB-INF/db/db.jsp"%>
<%

    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    HashMap user = (HashMap)in.readObject();
    HashMap data = (HashMap)in.readObject();
    in.close();
    
    url = cn;
    getConnection();
    


    String keyWords = data.get("keyWords").toString();
    int user_type = new Integer(data.get("user_type").toString()).intValue();
    int ctry = new Integer(data.get("ctry").toString()).intValue();
    String uid =  data.get("uid").toString();    
    response.setStatus(response.SC_OK);
    
    String sql = searchSql(keyWords, ctry, user_type, uid);
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
    o.writeObject(findPersons(sql));
    o.flush();
    o.close();
    try{
        conn.close();
    }
    catch(Exception e){
        
    }
%>
<%!
    private String str_rgn_searchFields[] = {"prsn_lnam","prsn_fnam","prsn_city","city_code","prsn_strt"};

    String url = "";
    Connection conn;
    public Connection getConnection() throws Exception {
        conn = DriverManager.getConnection(url);
        return conn;
    }
    public Vector findPersons(String sql) throws Exception {
        PreparedStatement ps = conn.prepareStatement(sql);
        ResultSet rs = ps.executeQuery();
        ResultSetMetaData meta = rs.getMetaData();
        Vector data = initLinkedModel(rs);
        
        return data;
    }
    public String searchSql(String keyWords, int ctry, int user_type, String uid) throws Exception{
        String strSelectClause = "" +
                "   SELECT  " +
                "       TOP 100 PRSN_KEY, " +
                "       PRSN_LNAM + ' , ' + PRSN_FNAM  AS NAME, " +
                "       TYPE_ABBR, " +
                "       CNTR_NAME, " +
                "       PRSN_CITY + ' , ' + PRSN_STRT," +
                "       PRV1_IDNT," +
                "       PRV1_COMM," +
                "       PRV2_IDNT," +
                "       PRV2_COMM, " +
                "       prv1_good, " +
                "       prv2_good  " +
                "   FROM " +
                "       BASE_PRSN " +
                "   INNER JOIN " +
                "       BASE_CNTR " +
                "           ON ( BASE_PRSN.CNTR_IDNT = BASE_CNTR.CNTR_KEY) " +
                "   INNER JOIN" +
                "        BASE_PRSN_TYPE " +
                "           ON ( BASE_PRSN.TYPE_IDNT = BASE_PRSN_TYPE.TYPE_KEY )";
        String strKeywords = keyWords.trim();
        int nCountryId = ctry;
        int nTypeId = user_type;

        String strWhereClause = "";
        int nConditions = 0;
        if(!strKeywords.equals("")){
            nConditions++;
            String str_rgn_keywordTokens[] = strKeywords.split(" ");
            int nKeywordsCount = str_rgn_keywordTokens.length;
            if(nKeywordsCount < 1){
                throw new Exception("Please enter at least one keyword for search");

            }
            int nSearchFieldsCount = str_rgn_searchFields.length;
            for(int i = 0; i < nKeywordsCount; i++){
                str_rgn_keywordTokens[i] = str_rgn_keywordTokens[i].trim();

                if(str_rgn_keywordTokens[i].equals("")){
                    continue;
                }
                for(int j = 0; j < nSearchFieldsCount; j++){
                    if(i == 0 && j == 0)
                        strWhereClause += "(";
                    else if(i > 0 && j == 0)
                        strWhereClause += ") AND (";
                    else if(i > 0 || j > 0)
                        strWhereClause += " OR ";
                    strWhereClause = strWhereClause + " UPPER(" + str_rgn_searchFields[j] + ") " + " like UPPER('" + str_rgn_keywordTokens[i] + "%') ";
                }
                if(i==nKeywordsCount-1){
                    strWhereClause += " ) ";
                }
            }
        }

        if(nCountryId >0){
            if(nConditions>0)
                strWhereClause += " AND CNTR_IDNT = " + nCountryId;
            else
                strWhereClause += " CNTR_IDNT = " + nCountryId;
            nConditions++;
        }
        if(nTypeId >0){
            String provGood = getAddProvGoodSql(nTypeId);
            provGood = provGood!=null ? " or " + provGood : "";
            if(nConditions>0){
                strWhereClause += " and (type_idnt = " + nTypeId + provGood + ")";
                
            } else{
                strWhereClause += " (type_idnt = " + nTypeId + provGood + ")";
            }
            nConditions++;
        }

        if(nConditions > 0)
            strWhereClause = " WHERE " + strWhereClause;
        if(uid.trim().length()>0){
            strWhereClause = " WHERE prsn_key = " + Long.parseLong(uid);
        }
        String strSQL = strSelectClause + strWhereClause;
        return strSQL;
    }
    public String getAddProvGoodSql(int type){
        if(type == 1){
            return "prv1_good like 'Y'";
        }
        if(type == 2){
            return "prv2_good like 'Y'";
        }
        return null;
    }
%>
<%!
    public Vector initLinkedModel(ResultSet rs){

        Vector data = new Vector();
        try{
            ResultSetMetaData meta = rs.getMetaData();
            while(rs.next()){
                LinkedHashMap row = new LinkedHashMap();
                for(int i = 1; i <= meta.getColumnCount(); i++){
                    row.put(meta.getColumnName(i).toLowerCase(),rs.getObject(i));
                }
                data.add(row);
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return data;
    }
%>