<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>
<%@page import="javax.swing.table.*"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="medstore.*"%>
<%@page import="java.io.Serializable"%>

<%@include file="../WEB-INF/db/db.jsp"%>
<%

    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    HashMap user = (HashMap)in.readObject();
    HashMap data = (HashMap)in.readObject();
    in.close();

    url = cn;
    getConnection();

    String v_nr = data.get("v_nr").toString();

    response.setStatus(response.SC_OK);

    HashMap invoice = loadOrderInfo(v_nr);    
    
    
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());
    o.writeObject(invoice);
    o.flush();
    o.close();
    try{        
        conn.close();
    } catch(Exception e){

    }
%>
<%!    
    String url = "";
    Connection conn;
    public Connection getConnection() throws Exception {
        conn = DriverManager.getConnection(url);
        return conn;
    }
    private HashMap loadOrderInfo(String strOrderIdnt) throws Exception{
        boolean packing = false;
        boolean hidediscont = false;
       
        Connection connDB = getConnection();
        String strSQL = "SELECT vorgang.v_nr, vorgang.patn_idnt, vorgang.patn_dscn, vorgang.invc_addr, " +
                " vorgang.invc_date, vorgang.neto_sum, vorgang.vat_pers, vorgang.totl_sum," +
                " vorgang.altr_name, vorgang.patn_cntr, vorgang.patn_city, vorgang.patn_code, vorgang.patn_strt, " +
                " vorgang.invc_prto, vorgang.macro1text, vorgang.doc_type_idnt, vorgang.patn_cntr, " +

                " base_prsn.prsn_appl, base_prsn.prsn_fnam, base_prsn.prsn_lnam, base_prsn.vatfree, base_prsn.clcode, " +

                " base_user.user_abrv " +

                " FROM dbo.base_prsn INNER JOIN base_cntr ON base_prsn.cntr_idnt = base_cntr.cntr_key " +
                "                    INNER JOIN vorgang   ON base_prsn.prsn_key  = vorgang.patn_idnt " +
                "                    INNER JOIN base_user ON vorgang.oper_idnt   = base_user.user_key " +
                "                    INNER JOIN base_doc_type ON vorgang.doc_type_idnt = base_doc_type.type_key " +
                " WHERE vorgang.v_nr = " + strOrderIdnt ;

        Statement stm = connDB.createStatement();
        ResultSet rsDBData=stm.executeQuery(strSQL);
        boolean bMore = rsDBData.next();
        if(!bMore) {
            return null;
        }
        String customerId = rsDBData.getString("patn_idnt");
        String firstName = rsDBData.getString("prsn_fnam");
        String lastName = rsDBData.getString("prsn_lnam");
        String salutation = rsDBData.getString("prsn_appl");
        String invAltName = rsDBData.getString("altr_name");
        String country = rsDBData.getString("patn_cntr");
        String street = rsDBData.getString("patn_strt");
        String postalCode = rsDBData.getString("patn_code");
        String town = rsDBData.getString("patn_city");

        String altAddressCaption = "Lieferranschrift:";
        String invAltAddress = rsDBData.getString("invc_addr");

        String user_abrv = rsDBData.getString("user_abrv");

        String invoiceNumber = rsDBData.getString("v_nr");
        String invmacro = rsDBData.getString("macro1text");
        Timestamp tmpdate = rsDBData.getTimestamp("invc_date");
        int invoiceType = rsDBData.getInt("doc_type_idnt");

        String invoiceVatPerc = rsDBData.getString("vat_pers");
        String invoiceDicountPerc = rsDBData.getString("patn_dscn");
        String invoiceVersand = rsDBData.getString("invc_prto");
        String invoiceNeto = rsDBData.getString("neto_sum");
        String invoiceTotalSum = "";//rsDBData.getString("totl_sum");

        String invoiceVat = "";
        String invoiceDiscount = "";
        String invoiceSum = "";

        String clcode = rsDBData.getString("clcode");
        clcode = rsDBData.wasNull() ? "" : clcode.trim();

        String vatfree = rsDBData.getString("vatfree");

        rsDBData.close();
        stm.close();

        if(invAltAddress!=null && !"null".trim().equals(invAltAddress) && invAltAddress.trim().length()>0){
            packing = true;
        } else{
            packing = false;
        }

        if(Double.parseDouble(invoiceDicountPerc)<=0){
            hidediscont = false;
        } else{
            hidediscont = true;
        }
        
        HashMap settings = new HashMap();
        settings.put("hidediscont",new Boolean(hidediscont));
        settings.put("packing",new Boolean(packing));
        
        BigDecimal bdmTotal = new BigDecimal(0.0);
        BigDecimal bdmTotalWithoutVat = new BigDecimal(0.0);

        BigDecimal bdmVatPers = new BigDecimal(invoiceVatPerc);
        bdmVatPers = bdmVatPers.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal bdmDiscountPers = new BigDecimal(invoiceDicountPerc);
        bdmDiscountPers = bdmDiscountPers.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal bdmNetto = new BigDecimal(invoiceNeto);
        bdmNetto = bdmNetto.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal bdmPorto = new BigDecimal(invoiceVersand);
        bdmPorto = bdmPorto.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal bdmDiscount = bdmNetto.multiply( bdmDiscountPers ).divide(new BigDecimal(100.0),3,BigDecimal.ROUND_HALF_UP);
        bdmDiscount = bdmDiscount.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal discNeto = new BigDecimal(bdmNetto.doubleValue() - bdmDiscount.doubleValue());

        BigDecimal subTotal = new BigDecimal(discNeto.doubleValue() + bdmPorto.doubleValue());
        subTotal = subTotal.setScale(2,BigDecimal.ROUND_HALF_UP);

        BigDecimal dVat = subTotal.multiply(bdmVatPers).divide( new BigDecimal(100.0), 3, BigDecimal.ROUND_HALF_UP );
        bdmTotal = new BigDecimal(subTotal.doubleValue() + dVat.doubleValue());
        bdmTotal = bdmTotal.setScale(2,BigDecimal.ROUND_HALF_UP);

        dVat = dVat.setScale(2,BigDecimal.ROUND_HALF_UP);

        bdmDiscount = bdmDiscount.setScale(2,BigDecimal.ROUND_HALF_UP);

        bdmPorto = bdmPorto.setScale(2,BigDecimal.ROUND_HALF_UP);


        invoiceVat = dVat.toString();
        invoiceVatPerc = bdmVatPers.toString();

        invoiceDiscount = bdmDiscount.toString();
        invoiceDicountPerc = bdmDiscountPers.toString();

        invoiceVersand = bdmPorto.toString();

        invoiceSum = subTotal.toString();
        invoiceTotalSum = bdmTotal.toString();

        String date = SharedUtils.getStringFromTimestamp(tmpdate,SharedUtils.PARSE_ONLY_DATE);
        String invoiceBarcode = SharedUtils.generateBarcodeString(invoiceNumber);

        lastName+="\n";
        if(!"null".equalsIgnoreCase(invAltName) && invAltName.trim().length()>0){
            lastName += invAltName + "\n";
        }
        if(!"null".equalsIgnoreCase(street) && street.trim().length()>0){
            lastName+=street + "\n";
        }
        if(!"null".equalsIgnoreCase(country) && country.trim().length()>0){
            lastName+=country + " - ";
        }
        if(!"null".equalsIgnoreCase(postalCode) && postalCode.trim().length()>0){
            lastName+=postalCode + " ";
        }
        if(!"null".equalsIgnoreCase(town) && town.trim().length()>0){
            lastName+=town;
        }
        if( "Y".equals(vatfree) && clcode.length()>0) {
            lastName+= "\nIhre MwSt: " + clcode;
        }
        String packmacro = "Ihre Bestellung von " + date +
                " " + user_abrv +"\n";

        HashMap customer = new HashMap();
        customer.put("firstName",firstName);
        customer.put("lastName",lastName);
        customer.put("salutation",salutation);
        customer.put("street",street);
        customer.put("postalCode",postalCode);
        customer.put("town",town);
        customer.put("country",country);
        customer.put("altAddressCaption",altAddressCaption);
        customer.put("invAltAddress",invAltAddress);
        customer.put("invmacro",invmacro);
        customer.put("invAltName",invAltName);
        customer.put("packmacro",packmacro);
        
        String pref = "";
        if(invoiceType==2)
            pref="-";
        HashMap invoice = new HashMap();

        invoice.put("customer",customer);
        invoice.put("date",date);
        invoice.put("invoiceNumber",invoiceNumber);
        invoice.put("invoiceVersand",pref+invoiceVersand);
        invoice.put("invoiceDiscount",pref+invoiceDiscount);
        invoice.put("invoiceSum",pref+invoiceSum);
        invoice.put("invoiceVat",pref+invoiceVat);
        invoice.put("invoiceTotalSum",pref+invoiceTotalSum);
        invoice.put("invoiceVatPerc",invoiceVatPerc + "%");
        invoice.put("customerId",customerId);
        invoice.put("invoiceBarcode",invoiceBarcode);
        invoice.put("invoiceDicountPerc",invoiceDicountPerc + "%");
        invoice.put("invoiceType",new Integer(invoiceType));

        strSQL = " SELECT base_stck.stck_brcd, base_stck.stck_abrv," +
                " base_stck.stck_name, position.p_menge, position.unit_pric,position.sum_pric, base_stck.stck_key " +
                " FROM  vorgang INNER JOIN " +
                " position ON vorgang.v_nr = position.v_nr INNER JOIN" +
                " base_stck ON position.nstk_idnt = base_stck.stck_key  " +
                " WHERE vorgang.v_nr = " + strOrderIdnt +
                " order by position.p_pos asc";

        connDB = getConnection();
        stm = connDB.createStatement();
        rsDBData = stm.executeQuery(strSQL);

        bMore = rsDBData.next();

        ArrayList articles = new ArrayList();

        while(bMore){
            String articleNumber = rsDBData.wasNull() ? "" : rsDBData.getString("stck_brcd");
            String name = rsDBData.wasNull() ? "" : rsDBData.getString("stck_name");
            String price = rsDBData.wasNull() ? "" : rsDBData.getString("unit_pric");
            String count = rsDBData.wasNull() ? "" : rsDBData.getString("p_menge");
            String total = rsDBData.wasNull() ? "" : rsDBData.getString("sum_pric");

            price = SharedUtils.formatFloat(price, '.' );
            total = SharedUtils.formatFloat(total, '.' );

            HashMap article = new HashMap();
            article.put("articleNumber",articleNumber);
            article.put("name",name);
            article.put("price",pref+price);
            article.put("count",count);
            article.put("total",pref+total);
            articles.add(article);
            bMore = rsDBData.next();
        }
        rsDBData.close();
        stm.close();

        invoice.put("articles",articles);
        invoice.put("settings",settings);
        return invoice;
    }

    %>