<%@page import="java.sql.*"%>

<%!
    public class ProcedureStore {
        public String m_insertedEventId;
        public String m_stockId;
        public int m_newStockCountOnHand;
        public String m_stockName;

        public ProcedureStore() {
        }

        public void execStoreOperation(Connection conn,
                String operationCode,
                int addedStockCount, String stockBarcode,
                String storeId, String date, String userId )
                throws Exception {
            m_insertedEventId = null;
            m_stockId = null;
            m_newStockCountOnHand = 0;
            m_stockName = null;

            // return values
            String insertedEventId;
            String stockId;
            int newStockCountOnHand;

            // find stock
            String sql = "SELECT STCK_KEY," +
                    " STCK_PCNT, CNTN_BCOD, STCK_NAME " +
                    " FROM BASE_STCK " +
                    " WHERE STCK_BRCD='" + stockBarcode + "'";
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            if( !rs.next() )
                throw new Exception( "BARCODE NOT REGISTERED IN THE SYSTEM" );
            stockId = rs.getString(1);
            String countInPacket = rs.getString(2);
            String contentBarcode = rs.getString(3);
            String stockName = rs.getString(4);
            rs.close();
            stm.close();

            int stockCountOnHand = 0;
            sql = " SELECT STCK_CNT " +
                    " FROM CONN_STCK_IN_STOR " +
                    " WHERE STCK_IDNT=" + stockId +  " AND STOR_IDNT=" + storeId;
            stm = conn.createStatement();
            rs = stm.executeQuery(sql);
            boolean isExistConnStockStore = rs.next();
            if( isExistConnStockStore ) {
                stockCountOnHand = rs.getInt(1);
            }
            rs.close();
            stm.close();

            //update conn_stock_in_count
            if( operationCode.equals( "IN" ) ) {
                newStockCountOnHand = stockCountOnHand + addedStockCount;
            } else if( operationCode.equals( "OT" ) ) {
                newStockCountOnHand = stockCountOnHand - addedStockCount;
            } else
                throw new Exception("Uncnown operation");
            if( newStockCountOnHand < 0 )
                throw new Exception("CANT'T MOVE OUT MORE THAN WE HAVE ON HAND");
            String errorMessage = "";
            if( isExistConnStockStore ) {
                sql = " UPDATE CONN_STCK_IN_STOR SET STCK_CNT = " +  newStockCountOnHand +
                        " WHERE STCK_IDNT=" + stockId +
                        " AND STOR_IDNT=" + storeId;
                errorMessage = "ERROR UPDATINGINSERTING STOCK COUNT ON HAND ROW";
            } else {
                sql = " INSERT INTO CONN_STCK_IN_STOR (stck_idnt,stor_idnt,stck_cnt,stck_ivtr) VALUES" +
                        " ( " + stockId + "," + storeId + "," +
                        newStockCountOnHand + ", 0) ";
                errorMessage = "ERROR INSERTING STOCK COUNT ON HAND ROW";
            }
            stm = conn.createStatement();
            if( stm.executeUpdate(sql) <= 0 )
                throw new Exception(errorMessage);
            stm.close();

            //update event tables
            sql = "INSERT INTO BASE_EVNT " +
                    " (evnt_date ,stor_idnt , oper_idnt, strn_evnt ,user_idnt) " +
                    "VALUES('" + date + "', " +
                    storeId + ", '" + operationCode + "',NULL," + userId + ")";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();
            insertedEventId = getLastInsertedID(conn);
            sql = "INSERT INTO CONN_STCK_IN_EVNT " +
                    " (stck_idnt ,evnt_idnt , stck_cnt) " +
                    " VALUES ( " + stockId +
                    " , " + insertedEventId + ", " + addedStockCount + " ) ";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();

            m_insertedEventId = insertedEventId;
            m_newStockCountOnHand = newStockCountOnHand;
            m_stockId = stockId;
            m_stockName = stockName;
        }
        public String getLastInsertedID(Connection connDB) throws Exception{
            String strLastOrdrID = null;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery("SELECT SCOPE_IDENTITY() AS LAST_IDNT");
                boolean bMore = rsDBData.next();
                if(bMore){
                    strLastOrdrID = rsDBData.getString(1);
                } else{
                    throw new Exception("There is a problem with the database server!Please try again later");
                }
                rsDBData.close();
                stm.close();
            }catch(Exception e){
                throw new Exception("There is a problem with the database server!Please try again later");
            }
            return strLastOrdrID;
        }
    }

%>