<%@page import="java.sql.*"%>
<%@include file="/medstore/procedures/ProcedureStore.jsp"%>
<%!
    public class ProcedureTranStore {

        public int m_nTranID;
        public int m_nStockID;
        public String m_strStockName;
        public int m_nNewStockBalance;

        public ProcedureTranStore() {
        }

        public void execTranStoreOperation(Connection conn,
                String operationCode, int addedStockCount,
                String stockBarcode, String storeIdSrc,
                String storeIdDst, String date, String userId,
                String tranDesc, int sequence )
                throws Exception {
            ProcedureStore outProc = new ProcedureStore();
            outProc.execStoreOperation(conn , "OT", addedStockCount, stockBarcode,
                    storeIdSrc, date, userId );

            ProcedureStore inProc = new ProcedureStore();
            inProc.execStoreOperation(conn , "IN", addedStockCount, stockBarcode,
                    storeIdDst, date, userId );
            if( tranDesc != null )
                tranDesc = "'" + tranDesc + "'";
            String sql = "INSERT INTO BASE_EVNT_TRNS (trns_descr) VALUES( " + tranDesc + " )";
            Statement stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();
            String insertedTranId = getLastInsertedID(conn);

            sql = "INSERT INTO CONN_EVNT_TRNS " +
                    " (evnt_idnt,trns_idnt,oper_idnt,sqns_nmbr) " +
                    " VALUES(" + outProc.m_insertedEventId +
                    "," + insertedTranId + ",'" + operationCode +  "'," +  sequence + " )";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();

            sql = "INSERT INTO CONN_EVNT_TRNS" +
                    " (evnt_idnt,trns_idnt,oper_idnt,sqns_nmbr)" +
                    " VALUES(" + inProc.m_insertedEventId +
                    "," + insertedTranId + ",'" + operationCode +  "'," +  (sequence + 1) + " )";
            stm = conn.createStatement();
            stm.executeUpdate(sql);
            stm.close();

            m_nTranID = Integer.parseInt( insertedTranId );
            m_nStockID = Integer.parseInt( inProc.m_stockId );
            m_strStockName = inProc.m_stockName;
            m_nNewStockBalance = inProc.m_newStockCountOnHand;
        }
        public String getLastInsertedID(Connection connDB) throws Exception{
            String strLastOrdrID = null;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery("SELECT SCOPE_IDENTITY() AS LAST_IDNT");
                boolean bMore = rsDBData.next();
                if(bMore){
                    strLastOrdrID = rsDBData.getString(1);
                } else{
                    throw new Exception("There is a problem with the database server!Please try again later");
                }
                rsDBData.close();
                stm.close();
            }catch(Exception e){
                throw new Exception("There is a problem with the database server!Please try again later");
            }
            return strLastOrdrID;
        }
    }
%>