<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.io.*"%>
<%@page import="java.sql.*"%>
<%@page import="java.util.*"%>

<%@include file="/WEB-INF/db/db.jsp"%>
<%@include file="/medstore/products/CompositeProduct.jsp"%>
<%@include file="/medstore/procedures/ProcedureTranStore.jsp"%>

<%
    ObjectInputStream in = new ObjectInputStream(request.getInputStream());
    ObjectOutputStream o = new ObjectOutputStream(response.getOutputStream());

    HashMap map;
    String barcode ;
    int count;
    int storeFrom;
    int storeTo;

    try{

        try{
            map = (HashMap)in.readObject();
        } catch(Exception ex){
            o.writeObject(new Exception("Error: Invalid data"));
            return;
        }

        try{
            barcode = String.valueOf(map.get("barcode"));
            count = Integer.parseInt(""+map.get("count"));
            storeFrom = Integer.parseInt(String.valueOf(map.get("storeFrom")));
            storeTo = Integer.parseInt(String.valueOf(map.get("storeTo")));


        } catch(Exception ex){
            ex.printStackTrace();
            o.writeObject(new Exception("Error: Invalid data!"));
            return;
        }

        Connection conn = DriverManager.getConnection(cn);
        boolean b = executeTranStoreOperation(conn, "MV", count, barcode, storeFrom, storeTo,
                medstore.SharedUtils.getDateStringFormatted(java.util.Calendar.getInstance()), 1, null, 1);
        o.writeObject(strStockName);

    } catch(Exception e){
        o.writeObject(e);
    } finally{
        o.flush();
        o.close();
    }

%>

<%!
    String strStockName = null;;
    private boolean executeTranStoreOperation(Connection conn, String strOperationCode,int nStockCount,
            String strBarcode,int nStoreIdSrc, int nStoreIdDst,
            String date, int nUserID, String strTranDesc, int nEventTranSeq) throws Exception {

        CompositeProduct compositeProduct = new CompositeProduct(conn);
        try {
            if(compositeProduct.isCompositeForBarcode(strBarcode)){
                throw new Exception("Can't move composite products!");
            }
            strStockName = null;
            
            conn.setAutoCommit(false);
            ProcedureTranStore proc = new ProcedureTranStore();
            proc.execTranStoreOperation(conn, strOperationCode, nStockCount,
                    strBarcode, "" + nStoreIdSrc, "" + nStoreIdDst, date,
                    "" + nUserID, strTranDesc, nEventTranSeq );
            
            //nTranID = proc.m_nTranID;
            //nStockID = proc.m_nStockID;
            strStockName = proc.m_strStockName;
            //nNewStockBalance = proc.m_nNewStockBalance;
            conn.commit();
        } catch(Exception e) {

            try{
                conn.rollback();
            } catch(Exception ex){

            }
            throw new Exception("Operation can not be completed!\n" + e.getMessage() );
        } finally {
            try{
                conn.close();
            } catch(Exception ex){

            }
        }
        return true;
    }
%>