/*
 * AddStockDialog.java
 *
 * Created on , 2005,  27, 22:49
 */

package medstore;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;

/**
 *
 * @author  JohnyEdu
 */
public class AddStockDialog extends CommonDialog implements SharedConstants{

    private String strStockId;
    private boolean bAddNewStock;
    private String strPanelTitle;
    private int nSelRow;
    /** Creates new form AddStockDialog */
    public AddStockDialog(String strStockId,java.awt.Frame parent, boolean modal,int nSelRow) {
        super(parent, modal);
        initComponents();
        afterInitComponents();
        this.strStockId = strStockId;
        this.nSelRow = nSelRow;
        if(strStockId == null)
        {
            bAddNewStock = true;
            strPanelTitle = "Add new stock to nomenclature";
        }
        else
        {
            bAddNewStock = false;
            strPanelTitle = "Edit existing stock in nomenclature";
            UniversalTableRow tableRow =((UniversalTableModel)StockManager.tblAllStocks.getModel()).getRowObject(nSelRow);
            editStockName.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_NAME_INDEX));
            editStockBarcode.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_BARCODE_INDEX));
            editStockCount.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_PCOUNT_INDEX));
            editContentBarcode.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_CNTN_BARCODE_INDEX));
            editLimit.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_LIMIT_INDEX));
            //editBPrice.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_BPRICE_INDEX));
            editMPrice.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_MPRICE_INDEX));
            editSPrice.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_SPRICE_INDEX));
            editAbbreviation.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_ABBR_INDEX));
            editStockGroup.setText((String)tableRow.vecRowElements.get(StockManager.STOCK_GROUP_INDEX));
        }
        if(Integer.parseInt(editStockCount.getText())>1){
                editContentBarcode.setEnabled(true);
                labelCntBarcode.setEnabled(true);
        }
        else{
            editContentBarcode.setEnabled(false);
            labelCntBarcode.setEnabled(false);
        }

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel2 = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        editContentBarcode = new javax.swing.JTextField();
        labelCntBarcode = new javax.swing.JLabel();
        editLimit = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        editMPrice = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        editStockName = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        editAbbreviation = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        editSPrice = new javax.swing.JTextField();
        editStockGroup = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        buttonSubmit = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add stock");
        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Count in packet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 20, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        editStockCount.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockCount.setText("1");
        editStockCount.setMinimumSize(new java.awt.Dimension(11, 21));
        editStockCount.setPreferredSize(new java.awt.Dimension(50, 21));
        editStockCount.setSelectionEnd(2);
        editStockCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editStockCountActionPerformed(evt);
            }
        });
        editStockCount.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                AddStockDialog.this.focusLost(evt);
            }
        });
        editStockCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 60);
        getContentPane().add(editStockCount, gridBagConstraints);

        editContentBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editContentBarcode.setEnabled(false);
        editContentBarcode.setMinimumSize(new java.awt.Dimension(230, 21));
        editContentBarcode.setPreferredSize(new java.awt.Dimension(230, 21));
        editContentBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editContentBarcode, gridBagConstraints);

        labelCntBarcode.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelCntBarcode.setText("content barcode");
        labelCntBarcode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.ipadx = 17;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 10, 0, 0);
        getContentPane().add(labelCntBarcode, gridBagConstraints);

        editLimit.setFont(new java.awt.Font("Tahoma", 0, 13));
        editLimit.setMinimumSize(new java.awt.Dimension(40, 21));
        editLimit.setPreferredSize(new java.awt.Dimension(50, 21));
        editLimit.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 10);
        getContentPane().add(editLimit, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("Limit");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 20, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        editMPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editMPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editMPrice.setPreferredSize(new java.awt.Dimension(50, 21));
        editMPrice.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 0);
        getContentPane().add(editMPrice, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Mid price");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel6, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Name");
        jLabel1.setMinimumSize(new java.awt.Dimension(50, 18));
        jLabel1.setPreferredSize(new java.awt.Dimension(50, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        editStockName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockName.setMinimumSize(new java.awt.Dimension(230, 21));
        editStockName.setPreferredSize(new java.awt.Dimension(230, 21));
        editStockName.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editStockName, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText("Barcode");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 24;
        gridBagConstraints.ipadx = 37;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        editStockBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockBarcode.setPreferredSize(new java.awt.Dimension(160, 21));
        editStockBarcode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editStockBarcodeActionPerformed(evt);
            }
        });
        editStockBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 10);
        getContentPane().add(editStockBarcode, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("Abbr.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 26;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        editAbbreviation.setFont(new java.awt.Font("Tahoma", 0, 13));
        editAbbreviation.setMinimumSize(new java.awt.Dimension(100, 21));
        editAbbreviation.setPreferredSize(new java.awt.Dimension(100, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editAbbreviation, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Sell price");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel7, gridBagConstraints);

        editSPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editSPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editSPrice.setPreferredSize(new java.awt.Dimension(50, 21));
        editSPrice.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 0);
        getContentPane().add(editSPrice, gridBagConstraints);

        editStockGroup.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockGroup.setMinimumSize(new java.awt.Dimension(11, 21));
        editStockGroup.setPreferredSize(new java.awt.Dimension(50, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 60);
        getContentPane().add(editStockGroup, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Group");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 21;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel8, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(182, 27));
        jPanel1.setPreferredSize(new java.awt.Dimension(182, 27));
        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Submit");
        buttonSubmit.setAlignmentX(0.5F);
        buttonSubmit.setMargin(new java.awt.Insets(1, 5, 2, 4));
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddStockDialog.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        jPanel1.add(buttonSubmit, gridBagConstraints);

        jButton1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jButton1.setAlignmentX(0.5F);
        jButton1.setLabel("Cancel");
        jButton1.setMargin(new java.awt.Insets(1, 5, 2, 4));
        jButton1.setMaximumSize(new java.awt.Dimension(55, 25));
        jButton1.setMinimumSize(new java.awt.Dimension(55, 25));
        jButton1.setPreferredSize(new java.awt.Dimension(55, 25));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 16;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(jButton1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jPanel2, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-483)/2, (screenSize.height-234)/2, 483, 234);
    }//GEN-END:initComponents

    private void editStockBarcodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editStockBarcodeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_editStockBarcodeActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if(evt.getSource()==editStockCount){
            if(Integer.parseInt(editStockCount.getText())>1){
                editContentBarcode.setEnabled(true);
                labelCntBarcode.setEnabled(true);
            }
            else{
                editContentBarcode.setEnabled(false);
                labelCntBarcode.setEnabled(false);
            }
        }
    }//GEN-LAST:event_focusLost

    private void editStockCountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editStockCountActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_editStockCountActionPerformed

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource() == buttonSubmit)
        {
            // --- uncomment here ---
            /*
            if(!UniversalInputVerifier.Universal_String_Verifier(editStockName)){
                JOptionPane.showMessageDialog(null,"Please, enter valid stock name");
                return;
            }
             */
            if(!UniversalInputVerifier.BARCODE_Verifier(editStockBarcode)){
                JOptionPane.showMessageDialog(null,"Please, enter valid barcode");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockCount)){
                JOptionPane.showMessageDialog(null,"Please, enter valid stock count in packet");
                return;
            }
            if(editContentBarcode.isEnabled()){
                if(editContentBarcode.getText().equals("")){
                    JOptionPane.showMessageDialog(null,"Please, enter valid content barcode");
                    return;
                }
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockGroup)){
                JOptionPane.showMessageDialog(null,"Please, enter Stock Group");
                return;
            }

            String strStockName = editStockName.getText();
            //String strStockAbbr = editAbbreviation.getText();
            String strCountInPacket = editStockCount.getText();
            String strLimit = editLimit.getText();
            //String strBPrice = editBPrice.getText();
            String strMPrice = editMPrice.getText();
            String strSPrice = editSPrice.getText();
            String strBarcode = editStockBarcode.getText();
            String strContentBarcode = editContentBarcode.getText();
            String strAbbreviation = editAbbreviation.getText();
            String strStockGroup = editStockGroup.getText();
            /*
            if(!editContentBarcode.isEnabled() && Integer.parseInt(strCountInPacket)>1){
                    JOptionPane.showMessageDialog(null,"You can't enter value bigger that 1 for stock that don't have content!");
                    return;
            }
            */

            Connection connDB=null;
            try{
                connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                Statement stm = connDB.createStatement();
                String strSQL;
                if(bAddNewStock){
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                        "SELECT STCK_KEY FROM BASE_STCK WHERE STCK_ABRV = '" + strAbbreviation + "'")){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that abbreviation.Please, choose another!");
                        return;
                    }
                    strSQL = "INSERT INTO BASE_STCK" +
                            " (stck_name,stck_brcd,stck_pcnt,cntn_bcod,stck_limt," +
                            " pric_buy,pric_mid,pric_sell,stck_abrv,stockgroup) " +
                            " VALUES('" + strStockName + "','"+ strBarcode + "'," +
                              strCountInPacket + ",'" + strContentBarcode + "'," + strLimit + ",0.0"  +
                              "," + strMPrice + "," + strSPrice + ",'" + strAbbreviation + "'," + strStockGroup + ")";
                }
                else{
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                        "SELECT STCK_KEY FROM BASE_STCK WHERE STCK_ABRV = '" + strAbbreviation +
                            "' AND STCK_KEY != " + strStockId )){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that abbreviation.Please, choose another!");
                        return;
                    }
                    if(strStockId == null){
                        JOptionPane.showMessageDialog(null,"System error, please restart!");
                        return;
                    }
                    strSQL = "UPDATE BASE_STCK SET STCK_NAME ='" + strStockName + "', STCK_BRCD ='" + strBarcode +
                              "',STCK_PCNT = " + strCountInPacket + ", CNTN_BCOD ='" + strContentBarcode +
                              "',STCK_LIMT = " + strLimit  + ",PRIC_BUY = 0.0"  + ",PRIC_MID = " + strMPrice +
                              ",PRIC_SELL = " + strSPrice + ", STCK_ABRV = '" + strAbbreviation + "' ,STOCKGROUP=" + strStockGroup + " WHERE STCK_KEY = " + strStockId;
                }

                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                    return;
                }
                stm.close();
            }catch(Exception e){
                JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please restart!");
                return;
            }

            if(bAddNewStock){
                String strLastOrdrID = null;
                String strSQL = "SELECT SCOPE_IDENTITY() AS LAST_IDNT";

                try{
                    Statement stm = connDB.createStatement();
                    ResultSet rsDBData=stm.executeQuery(strSQL);
                    boolean bMore = rsDBData.next();
                    if(bMore){
                        strLastOrdrID = new String(rsDBData.getString("LAST_IDNT"));
                    }
                    else{
                        JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                        return;
                    }
                    rsDBData.close();
                    stm.close();
                }catch(Exception e){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                    return;
                }
                Vector vecRowElements = new Vector();
                vecRowElements.addElement(strStockName);
                vecRowElements.addElement(strAbbreviation);
                vecRowElements.addElement(strStockGroup);
                vecRowElements.addElement(strBarcode);
                vecRowElements.addElement(strContentBarcode);
                vecRowElements.addElement(strCountInPacket);
                vecRowElements.addElement(strLimit);
                vecRowElements.addElement(strMPrice);
                vecRowElements.addElement(strSPrice);
                vecRowElements.addElement(strLastOrdrID);
                
                final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
                javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run()
                {
                    ((UniversalTableModel)StockManager.tblAllStocks.getModel()).addObject((Object)uniTableRow);
                    StockManager.tblAllStocks.updateUI();
                    JOptionPane.showMessageDialog(null,"The Stock was successfully added to the system!");
                    dispose();
                }});
            }
            else{
                Vector vecRowElements = new Vector();
                vecRowElements.addElement(strStockName);
                vecRowElements.addElement(strAbbreviation);
                vecRowElements.addElement(strStockGroup);
                vecRowElements.addElement(strBarcode);
                vecRowElements.addElement(strContentBarcode);
                vecRowElements.addElement(strCountInPacket);
                vecRowElements.addElement(strLimit);
                vecRowElements.addElement(strMPrice);
                vecRowElements.addElement(strSPrice);
                vecRowElements.addElement(strStockId);
               
                final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
                javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run()
                {
                    ((UniversalTableModel)StockManager.tblAllStocks.getModel()).setRowObject((Object)uniTableRow,nSelRow);
                    StockManager.tblAllStocks.updateUI();
                    JOptionPane.showMessageDialog(null,"The Stock was successfully edited!");
                    dispose();
                }});
            }

            if(bAddNewStock){
                editStockName.setText("");
                editStockBarcode.setText("");
                editStockCount.setText("");
                editLimit.setText("");
                editMPrice.setText("");
                editSPrice.setText("");
                editAbbreviation.setText("");
                editStockGroup.setText("");
            }

            editStockName.requestFocus();
            //editStockCount.setText("1");
            //editStockCount.setSelectionStart(0);
            //editStockCount.setSelectionEnd(1);
        }
    }//GEN-LAST:event_actionPerformed

    private void evnhKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_evnhKeyPressed
        char chKeyPressed = evt.getKeyChar();
        if(evt.getSource() == editStockName)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                editStockCount.requestFocus();
                editStockCount.setText("1");
                editStockCount.setSelectionStart(0);
                editStockCount.setSelectionEnd(1);
            }
        }
        else if(evt.getSource() == editStockCount)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                editLimit.requestFocus();
            }
        }
        else if(evt.getSource() == editLimit)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                editMPrice.requestFocus();
            }
        }
        else if(evt.getSource() == editMPrice)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                editSPrice.requestFocus();
            }
        }
        else if(evt.getSource() == editSPrice)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                editStockBarcode.requestFocus();
            }
        }
        else if(evt.getSource() == editStockBarcode)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                if(editContentBarcode.isEnabled()){
                   editContentBarcode.requestFocus();
                }
                else{
                    buttonSubmit.requestFocus();
                    buttonSubmit.doClick();
                }
            }
        }
        else if(evt.getSource() == editContentBarcode)
        {
            if(chKeyPressed == evt.VK_ENTER)
            {
                buttonSubmit.requestFocus();
                buttonSubmit.doClick();
            }
        }
    }//GEN-LAST:event_evnhKeyPressed

    private void afterInitComponents()
    {
        UniversalInputVerifier stockCountInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_COUNT,this);
        editStockCount.setInputVerifier(stockCountInputVerifier);
        UniversalInputVerifier stockGroupInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_GROUP,this);
        editStockGroup.setInputVerifier(stockGroupInputVerifier);
        UniversalInputVerifier stockNameInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_NAME,this);
        editStockName.setInputVerifier(stockNameInputVerifier);
        UniversalInputVerifier stockBarcodeInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_BARCODE,this);
        editStockBarcode.setInputVerifier(stockBarcodeInputVerifier);
        UniversalInputVerifier integerVerifier = new UniversalInputVerifier(Universal_Integer,this);
        editLimit.setInputVerifier(integerVerifier);
        //UniversalInputVerifier floatBVerifier = new UniversalInputVerifier(Universal_Float,this);
        //editBPrice.setInputVerifier(floatBVerifier);
        UniversalInputVerifier floatMVerifier = new UniversalInputVerifier(Universal_Float,this);
        editMPrice.setInputVerifier(floatMVerifier);
        UniversalInputVerifier floatSVerifier = new UniversalInputVerifier(Universal_Float,this);
        editSPrice.setInputVerifier(floatSVerifier);

        //panelEventRegister.setBorder(new javax.swing.border.TitledBorder(strPanelTitle));

    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton buttonSubmit;
    private javax.swing.JTextField editAbbreviation;
    private javax.swing.JTextField editContentBarcode;
    private javax.swing.JTextField editLimit;
    private javax.swing.JTextField editMPrice;
    private javax.swing.JTextField editSPrice;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JTextField editStockGroup;
    private javax.swing.JTextField editStockName;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel labelCntBarcode;
    // End of variables declaration//GEN-END:variables

}
