/*
 * OrderPortoTableRenderer.java
 *
 * Created on , 2005,  13, 15:37
 */

package medstore;

import javax.swing.table.*;
import javax.swing.*;
import java.awt.*;

import java.math.BigDecimal;

public class OrderPortoTableRenderer extends DefaultTableCellRenderer{    
    public OrderPortoTableRenderer() {
        
    }

    public Component getTableCellRendererComponent(
                            JTable table, Object value,
                            boolean isSelected, boolean hasFocus,
                            int row, int column)
    {
    
        super.getTableCellRendererComponent(table,value, isSelected, hasFocus, row, column);        
        //setHorizontalAlignment(JCheckBox.LEFT_ALIGNMENT);        
        if(column == OrdersPlacement.VALUE_COL_INDEX && row == OrdersPlacement.PORTO_INDEX ){
            //JTextField renderedComponent = new JTextField();
            JTextField renderedComponent = new JTextField();
            renderedComponent.setFont(new java.awt.Font("Tahoma", 1, 13));
            renderedComponent.setHorizontalAlignment(JTextField.RIGHT);
            Insets ins = renderedComponent.getInsets();
            ins.right = 1;
            BigDecimal bgdValue = new BigDecimal((String)value);
            bgdValue = bgdValue.setScale(2,BigDecimal.ROUND_HALF_UP);
            renderedComponent.setText(bgdValue.toString());            
            return renderedComponent;
        }
        setHorizontalAlignment(JLabel.RIGHT);
        Insets ins = getInsets();
        ins.right = 1;
        return  this;        
    }
}
