package medstore.auftrag;

import java.io.File;
import java.io.Serializable;
import java.util.Date;
import javax.swing.JOptionPane;
import medstore.io.FileIO;

public class AuftragFile {
    private File file;
    
    public AuftragFile(File file) throws Exception {
        this.file = file;  
        isValidFile();
    }
    
    public AuftragFile(String file) throws Exception {
        String auftrag_file_path = file;        
        this.file = new File(auftrag_file_path);
        isValidFile();
    }
    
    public long lastModefiedtoLong(){
        return file.lastModified();
    }
    
    public Date lastModefiedToDate(){
        return new Date(file.lastModified());
    }
    
    public boolean isValidFile() throws Exception {
        /*if(!file.exists()){
            int i = JOptionPane.showConfirmDialog(null,"Auftrag file, does not exist!\n Do You want to create?","Create file?",JOptionPane.YES_NO_OPTION);
            if(i==JOptionPane.YES_OPTION)
                file.createNewFile();
            else{
                System.exit(0);
            }
        }*/
        return true;
    }
    
    public void createNewFile() throws Exception{
        try{
            if(!file.createNewFile())
                throw new Exception("");  
            else{
               
            }
        }
        catch(Exception e){
            throw new Exception("Can not create new file: " + e.getMessage());
        }        
    }
    public void deleteFile() throws Exception{
        try{
            if(!file.delete())
                throw new Exception("");            
        }
        catch(Exception e){
            throw new Exception("Can not delete file: " + e.getMessage());
        }        
    }
    
    public void appendOrder(AuftragData auftragData) throws Exception{
        Serializable objs[] = {(Serializable)auftragData.toString()};
        FileIO.WriteToFile(file,objs,true);
    }
}
