package medstore.base_cntr;

public class VatTaxData {
    
    private float cntr_vat;
    private int cntr_vat_code;
    private int cntr_code;
    private String vatFree;
            
    public VatTaxData() {
        
        this.cntr_vat = 0;
        this.cntr_vat_code = 0;                
        this.cntr_code = 0;
        this.vatFree = "";
        
    }
    
    
    public VatTaxData(float cntr_vat, int cntr_vat_code, int cntr_code) {
        this.cntr_vat = cntr_vat;
        this.cntr_vat_code = cntr_vat_code;
        this.cntr_code = cntr_code;
    }
    
    public VatTaxData(float cntr_vat, int cntr_vat_code, int cntr_code, 
            float cntr_no_vat, int cntr_no_vat_code, int cntr_code_free, 
            String vatFree) {        
        if("Y".equals(vatFree)){
            this.cntr_vat = cntr_no_vat;
            this.cntr_vat_code = cntr_no_vat_code;
            this.cntr_code = cntr_code_free;
        }
        else{
            this.cntr_vat = cntr_vat;
            this.cntr_vat_code = cntr_vat_code;
            this.cntr_code = cntr_code;
        }        
        this.vatFree = vatFree;
        
        /*
        System.out.println("---------------------------------------------");
        System.out.println("this.cntr_vat " + this.cntr_vat);
        System.out.println("this.cntr_vat_code " + this.cntr_vat_code);
        System.out.println("this.cntr_code " + this.cntr_code);
        System.out.println("---------------------------------------------");
        System.out.println("cntr_vat " + cntr_vat);
        System.out.println("cntr_vat_code " + cntr_vat_code);
        System.out.println("cntr_code " + cntr_code);
        System.out.println("cntr_no_vat " + cntr_no_vat);
        System.out.println("cntr_no_vat_code " + cntr_no_vat_code);
        System.out.println("cntr_code_free " + cntr_code_free);
        System.out.println("vatFree" + vatFree + ":" + this.vatFree);
        System.out.println("---------------------------------------------");
        */
    }
    
    public float cntr_vat(){
        return cntr_vat;
    }
    public int cntr_vat_code(){
        return cntr_vat_code;
    }
    public int cntr_code(){
        return cntr_code;
    }
}
