package medstore.fullfillment;

import medstore.fullfillment.data.FFData;

public class FFDbUtils extends DBConn{
    private FFData ffdata;
    
    public FFDbUtils(final FFData ffdata) throws Exception{
        if(ffdata==null)
            throw new Exception("Warring: Specify order number!");
        this.ffdata = ffdata;
    }
    public boolean fillOrder() throws Exception{
        boolean isFilled = isOrderFilled(ffdata.strOrderID());
        boolean filled = false;
        if(!isFilled){
            filled = fillOrder(ffdata);
        }
        else{
            throw new Exception("Order No. " + ffdata.strOrderID() + " is already fulfilled!" );
        }
        return filled;
    }
    public boolean isFilled() throws Exception{
        return isOrderFilled(ffdata.strOrderID());
    }
}
