package medstore.math;

import java.math.BigDecimal;

public class BigDec {
    
    public static String scaledRoundHalfUp(String value, int scale){
        value = (value==null || value.equals("null") || value.trim().length()<=0) ? "0.00" : value;
        BigDecimal bdm = new BigDecimal(value);
        bdm = bdm.setScale(scale,BigDecimal.ROUND_HALF_UP);
        return bdm.toString();
    }
    public static String scaledRoundHalfUp(double value, int scale){                
        return scaledRoundHalfUp(String.valueOf(value), scale);
    }
    
}
