package medstore.print.reports;

public class ReportTop {
    
    private String report_date;
    private String type;
    private String rep_date_interval;
    private String producer;
    
    
    public ReportTop(final String report_date, final String type, 
            final String rep_date_interval,final String producer) {
        
        this.report_date = report_date;
        this.type = type; 
        this.rep_date_interval = rep_date_interval;
        this.producer = producer;
        
    }
    public String getReportDate(){
        return clrNullString(report_date);
    }
    public String getReportType(){
        return clrNullString(type);
    }
    public String getReportDateInterval(){
        return clrNullString(rep_date_interval);
    }
    public String getReportProducer(){
        return clrNullString(producer);
    }
    private String clrNullString(String value){
        return value==null || value.toLowerCase().trim().equals("null") ? "" : value.trim();
    }
}
