package medstore.trans;
import javax.swing.table.TableModel;

public interface LangPack {
    public static final String menu_file = "fil";
    public static final String menu_file_exit = "fil_ext";
    public static final String menu_movement = "mov";
    public static final String menu_movement_in_out = "mov_io";
    public static final String menu_movement_from_to = "mov_ft";
    public static final String menu_movement_revision = "mov_rev";
    
    public static final String menu_nomenclature = "menu_nomenclature";
    
    public static final String menu_inventory = "inv";
    public static final String menu_inventory_start_stock_counting = "inv_str";
    public static final String menu_inventory_checkout = "inv_edt";
    public static final String menu_inventory_limits = "inv_chk_out";
    
    public static final String menu_inventory_rep = "inv_rep";
    public static final String menu_inventory_mov_revision = "qur_mov_rev";
    public static final String menu_inventory_stock_on_hand = "qur_on_hand";
    public static final String menu_inventory_on_hand_totals = "qur_hnd_tot";
    public static final String menu_inventory_checkouts = "qur_inv_cot";
    public static final String menu_inventory_checkouts_dif = "qur_chk_dff";
    public static final String menu_inventory_time_to_purchase = "qur_tim_pch";
    public static final String menu_inventory_sales_movement = "sales_mov";
    
    public static final String menu_orders = "ord";
    public static final String menu_orders_fullfill = "ord_flf";
    public static final String menu_orders_placement = "ord_plc";
    
    public static final String menu_orderReports = "qur";
    public static final String menu_orderReports_OrderHistory = "qur_ord_history";
    public static final String menu_orderReports_OrderHistoryItems = "ord_hist_item";
    public static final String menu_orderReports_Details = "qur_ord_dtl";
    public static final String menu_orderReports_Amounts = "ord_am";
    public static final String menu_orderReports_OrdersPending = "ord_pend";
    public static final String menu_orderReports_OrdersUnpaid = "ord_unp";
    public static final String menu_orderReports_OrdersNumber_Daily = "num_ord_daily";
    public static final String menu_orderReports_OrdersNumber_Monthly = "num_ord_monthly";
    public static final String menu_orderReports_Usage = "usage";
    public static final String menu_orderReports_Usage_Monthly = "usage_months";
    public static final String menu_orderReports_ActiveSalesPeople_Daily = "act_sal_peo_d";
    public static final String menu_orderReports_ActiveSalesPeople_Monthly = "act_sal_peo_m";
    public static final String menu_orderReports_ActiveCustomers = "act_cust_d";
    public static final String menu_orderReports_ActiveCustomers_Monthly = "act_cust_m";
    public static final String menu_orderReports_OrderCommisions = "report_orders_commission";
    public static final String menu_orderReports_CommissionsBtPeriod = "repport_comm_by_per";
    
    public static final String menu_generate = "Generate";
    public static final String menu_generate_letter1 = "mitemGenLetter1";
    public static final String menu_generate_letter2 = "mitemGenLetter2";
    public static final String menu_generate_letter3 = "mitemGenLetter3";
    
    public static final String menu_query = "Query";
    public static final String menu_query_letter1 = "mitemLetter1";
    public static final String menu_query_letter2 = "mitemLetter2";
    public static final String menu_query_letter3 = "mitemLetter3";
    
    /**  Order Placement *  JTabPanel tabPane  **/
    public static final String tabpane_orderParticipants = "orderParticipants";
    public static final String tabpane_orderSession = "orderSession";
    
    /**  Order Placement *  JTabPanel tabOrders  **/
    public static final String tabpane_orders = "orders";
    public static final String tabpane_invoice = "invoice";
    public static final String tabpane_packingList = "packingList";
    
    /** Order Placement  * JButtons  **/
    public static final String btnOPNewClient = "btnOPNewClient";
    public static final String btnOPEditClient = "btnOPEditClient";
    public static final String btnOPSearchClient = "btnOPSearchClient";
    public static final String btnOPPlaceOrder = "btnOPPlaceOrder";
    public static final String btnOPAddProduct = "btnOPAddProduct";
    public static final String btnOPSetAltAddress = "btnOPSetAltAddress";
    public static final String btnOPCancelNewOrder = "btnOPCancelNewOrder";
    public static final String btnOPPay = "btnOPPay";
    public static final String btnOPMacros = "btnOPMacros";
    public static final String btnOPSendLetter = "btnOPSendLetter";
    public static final String btnOPCreditNote = "btnOPCreditNote";
    
    
    /** Order Placement  * JPanels  **/
    public static final String jpanOPClient = "jpanOPClient";
    public static final String jpanOPClientInfo = "jpanOPClientInfo";
    public static final String jpanOPOrderDetails = "jpanOPOrderDetails";
    
    /** Order Placement * Labels **/
    public static final String lblOPFName = "lblOPFName";
    public static final String lblOPLName = "lblOPLName";
    public static final String lblOPApeal = "lblOPApeal";
    public static final String lblOPAltName = "lblOPAltName";
    public static final String lblOPType = "lblOPType";
    public static final String lblOPStreet = "lblOPStreet";
    public static final String lblOPDiscount = "lblOPDiscount";
    public static final String lblOPCode = "lblOPCode";
    public static final String lblOPCity = "lblOPCity";
    public static final String lblOPCountry = "lblOPCountry";
    public static final String lblOPFirmNo = "lblOPFirmNo";
    public static final String lblOPUIN = "lblOPUIN";
    public static final String lblOPDate = "lblOPDate";
    public static final String lblOPDocNo = "lblOPDocNo";
    public static final String lblOPInvNo = "lblOPInvNo";
    public static final String lblOPDocType = "lblOPDocType";
    public static final String lblOPOperator = "lblOPOperator";
    public static final String lblOPStock = "lblOPStock";
    public static final String lblOPCount = "lblOPCount";
    public static final String lblOPPayDate = "lblOPPayDate";
    public static final String lblOPPayed = "lblOPPayed";
    public static final String lblOPStockNotSel = "lblOPStockNotSel";
    
    public static final String chkOPCanPurchase = "chkOPCanPurchase";
    public static final String chkOPVatFree = "chkOPVatFree";
    public static final String chkAltAddress = "chkAltAddress";
    
    public static final String tblOrderGoods = "tblOrderGoods";
    public static final String tblOrders = "tblOrders";
    
    public static final String wordNetto = "wordNetto";
    public static final String wordDiscount = "wordDiscount";
    public static final String wordPorto = "wordPorto";
    public static final String wordTotal = "wordTotal";
    public static final String wordVAT = "wordVAT";
    public static final String wordTotalSum = "wordTotalSum";
    
    public static final String CLProv1Appropriate = "CLProv1Appropriate";
    public static final String CLProv2Appropriate = "CLProv2Appropriate";
    
    public static final String lblProv1UIN = "lblProv1UIN";
    public static final String lblProv2UIN = "lblProv2UIN";
    public static final String lblProv3UIN = "lblProv3UIN";
    public static final String lblProv1Name = "lblProv1Name";
    public static final String lblProv2Name = "lblProv2Name";
    public static final String lblProv3Name = "lblProv3Name";
    
    public static final String btnSelProv1 = "btnSelProv1";
    public static final String btnSelProv2 = "btnSelProv2";
    public static final String btnSelProv3 = "btnSelProv3";
    
    public static final String lblEnterKeyWords = "lblEnterKeyWords";
    public static final String lblPersonType = "lblPersonType";
    
    public static final String btnSearch = "btnSearch";
    public static final String lblPersons = "lblPersons";
    
    public static final String tblClSearchPersons = "tblClSearchPersons";
    public static final String lblStockSelSearchStr = "lblStockSelSearchStr";
    public static final String lblStockSelStocks = "lblStockSelStocks";
    public static final String btnStockSelSelect = "btnStockSelSelect";
    public static final String tblStockSelStocks = "tblStockSelStocks";
    
    public static final String btnClCancel = "btnClCancel";
    public static final String btnClAdd = "btnClAdd";
    /*
     ***
     */
    //Methods
    public String getElementLabel(int index);
    public String getElementLabel(String name, int col) throws Exception;
    public String getElementLabel(String name) throws Exception;
    public String[] getTblHeader(String name) throws Exception;
}
