/*
 * DOMParser.java
 *
 * Created on , 2005,  29, 22:34
 */

package xmlutils;


import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory; 
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException; 
import org.xml.sax.SAXParseException; 
import java.io.IOException; 
import java.net.URL;
import javax.swing.JOptionPane;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;



/**
 *
 * @author JohnyEdu
 */
public class DOMParser {
    
    private static Document document;
   
    /** Creates a new instance of DOMParser */
    public DOMParser() {
        
    }
    
    public  int  parseRowsPerPage(){
          
          DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
          int rowsPerPage = -1;
          try {
                
                DocumentBuilder builder = factory.newDocumentBuilder();
                String strFileToParse = "/xmlutils/config.xml";
                URL url = getClass().getResource(strFileToParse);
                document = builder.parse( url.openStream() );
                Element element = document.getDocumentElement();
                NodeList variableElements = element.getElementsByTagName("printing");
                for (int i=0;i<variableElements.getLength();i++) {
                        Element variableElement = (Element) variableElements.item(i);

                        String value = variableElement.getElementsByTagName("rows_per_page").item(0).getFirstChild().getNodeValue();
                        
                        rowsPerPage =  Integer.parseInt(value);
                }

          } 
          catch (SAXParseException spe) {
                JOptionPane.showMessageDialog(null,"Printer configuration cannot be obtained!Please, ask the support team!");
                return -1;
          } 
          catch (SAXException sxe) {
               JOptionPane.showMessageDialog(null,"Printer configuration cannot be obtained!Please, ask the support team!");
               return -1;

          } 
          catch (ParserConfigurationException pce) {
                JOptionPane.showMessageDialog(null,"Printer configuration cannot be obtained!Please, ask the support team!");
                return -1;

          } 
          catch (IOException ioe) {
                JOptionPane.showMessageDialog(null,"Printer configuration cannot be obtained!Please, ask the support team!");
                return -1;
          }
          
          return rowsPerPage;

    }
    
}
