package adminmodul.campaign;

public class CampDataObject {

    private int id = -1;
    private int stockid = -1;
    private String fromdate = null;
    private String todate = null;
    private int lownum = -1;
    private int highnum = -1;
    private int discount = 0;
    private int barcode = 0;
    private String prodName = null;
    
    public CampDataObject() {
        id = -1;
        stockid = -1;
        fromdate = null;
        todate = null;
        lownum = -1;
        highnum = -1;
        discount = 0;        
    }
    
    public CampDataObject(int id, int stockid, String fromdate,String todate, int lownum, int highnum, int discount) {
        this.id = id;
        this.stockid = stockid;
        this.fromdate = fromdate;
        this.todate = todate;
        this.lownum = lownum;
        this.highnum = highnum;
        this.discount = discount;
    }
    public CampDataObject(int stockid, String fromdate,String todate, int lownum, int highnum, int discount) {
        this.id = id;
        this.stockid = stockid;
        this.fromdate = fromdate;
        this.todate = todate;
        this.lownum = lownum;
        this.highnum = highnum;
        this.discount = discount;
    }
    
    public CampDataObject(int stockid, String fromdate,String todate, int lownum, int highnum, int discount, int stck_brcd) {
        this.id = id;
        this.stockid = stockid;
        this.fromdate = fromdate;
        this.todate = todate;
        this.lownum = lownum;
        this.highnum = highnum;
        this.discount = discount;
        this.barcode = stck_brcd;
    }
    
    public int getId(){
        return id;
    }
    public void setId(int value){
        id = value;
    }
    public int getStockId(){
        return stockid;
    }
    public String getFromDate(){
        return fromdate;
    }
    public String getToDate(){
        return todate;
    }
    public int getLowNum(){
        return lownum;
    }
    public int getHighNum(){
        return highnum;
    }
    public int getDiscount(){
        return discount;
    }
    public int getBarcode(){
        return barcode;
    }
    public String getProdName(){
        return prodName;
    }
    public void setProdName(String value){
        prodName = value;
    }
}
